from pyramid.config import Configurator
from os import listdir
import os.path
from shutil import rmtree

# Remove left-over working directories after application crash.
current_dir = os.path.split(os.path.abspath(__file__))[0]
remove_us = [dir for dir in listdir(os.path.join(current_dir, 'delwaq')) if os.path.isdir(os.path.join(current_dir, 'delwaq', dir)) and dir.startswith('work')]
for dir in remove_us:
    try:
        rmtree(os.path.join(current_dir, 'delwaq', dir))
    except Exception:
        raise


def main(global_config, **settings):
    """ This function returns a Pyramid WSGI application."""
    config = Configurator(settings=settings)
    config.add_static_view('static', 'deform:static')
    config.add_static_view('elveqo_static', 'elveqo:static')
    config.add_static_view('documents', 'static/documents')
    config.add_route('input', '/')
    config.scan()
    return config.make_wsgi_app()
