
c     Programme to integrate the output for a series of conditions
      implicit none
      
      character*255             :: mapfil 
      character*255             :: tekfil 
      character*255             :: outfil 
      character*255             :: inifil 
      character*255             :: lgafil 
      character*255             :: ccofil 
      character*255             :: mesfil
      character*160             :: moname
      character*20, ALLOCATABLE :: syname(:)
      character*20, ALLOCATABLE :: syname_mean(:)
      character*20, ALLOCATABLE :: syname_max(:)
      integer, parameter        :: lu_map = 20
      integer, parameter        :: lu_tek = 21
      integer, parameter        :: lu_out = 22
      integer, parameter        :: lu_ini = 23
      integer, parameter        :: lu_mes = 24
      integer, parameter        :: lu_lga = 25
      integer, parameter        :: lu_cco = 26
      integer                   :: iseg, isys, itime
      integer                   :: noseg, notot
      integer                   :: nosegstore, nototstore
	integer                   :: n_conditions, ic, n_subst
	integer                   :: n_class_j3d, n_class_dwq
      real                      :: frequency, ss, sss, ccc
      real                      :: sumfrequency
      real                      :: dummy, mixfact
      integer                   :: nrec, ncol
      REAL        , ALLOCATABLE :: class_j3d (:)
      REAL        , ALLOCATABLE :: mfmeanj3d(:)
      REAL        , ALLOCATABLE :: mfmaxj3d(:)
      REAL        , ALLOCATABLE :: class_dwq (:)
      REAL        , ALLOCATABLE :: conc(:,:)
      REAL        , ALLOCATABLE :: cmax(:,:)
      REAL        , ALLOCATABLE :: cmean(:,:)
      REAL        , ALLOCATABLE :: kd(:)
      REAL        , ALLOCATABLE :: Cd(:)
      REAL        , ALLOCATABLE :: SSd(:)
      REAL        , ALLOCATABLE :: Cb(:)
      REAL        , ALLOCATABLE :: EQSMAC(:)
      REAL        , ALLOCATABLE :: MZMAC(:)
      REAL        , ALLOCATABLE :: MZMAX(:)
      CHARACTER*10, ALLOCATABLE :: permitedmax(:)
      REAL        , ALLOCATABLE :: EQSAA(:)
      REAL        , ALLOCATABLE :: MZAA (:)
      REAL        , ALLOCATABLE :: MZMEAN (:)
      CHARACTER*10, ALLOCATABLE :: permitedmean(:)
      REAL        , ALLOCATABLE :: SafetyFactor(:)


	integer :: NMAX,MMAX,NOSEGL,NLAY,NOQ1,NOQ2,NOQ3,npart
	integer :: n,m,k,is,i,iclass
	real    :: x0,y0,alpha, rdum, distance, xs, ys, mixzon
	real    :: x,y
      INTEGER     , ALLOCATABLE :: LGRID(:,:)
      REAL        , ALLOCATABLE :: XB(:,:)
      REAL        , ALLOCATABLE :: YB(:,:)
      REAL        , ALLOCATABLE :: xyseg(:,:)
      REAL        , ALLOCATABLE :: cmeanj3d(:,:)
      REAL        , ALLOCATABLE :: cmaxj3d(:,:)
      REAL        , ALLOCATABLE :: cmeandwq(:,:)
      REAL        , ALLOCATABLE :: cmaxdwq(:,:)
      
      REAL                      :: interpolate
      logical :: foundseg
      real  :: nan = 0.0
      nan = nan/nan
      
      ! collect input and output file names, open some files
      
      CALL GETARG (1, inifil)
      CALL GETARG (2, lgafil)

      CALL GETARG (3, outfil)
      CALL GETARG (4, mesfil)

      open (lu_ini,file=inifil,status='old',err=900)
	read (lu_ini,*) n_class_j3d
      allocate (class_j3d(n_class_j3d)) 
      
	read (lu_ini,*) class_j3d
      read (lu_ini,*) n_class_dwq
      allocate (class_dwq(n_class_dwq)) 
      read (lu_ini,*) class_dwq
	read (lu_ini,*) n_subst
	read (lu_ini,*)
      allocate (cmeanj3d(n_subst,n_class_j3d))
      allocate (cmaxj3d(n_subst,n_class_j3d))
      allocate (cmeandwq(n_subst,n_class_dwq))
      allocate (cmaxdwq(n_subst,n_class_dwq))
      allocate (kd(n_subst)) 
      allocate (Cd(n_subst))
      allocate (SSd(n_subst))
      allocate (Cb(n_subst))
      allocate (EQSMAC(n_subst))
      allocate (MZMAC(n_subst))
      allocate (MZMAX(n_subst))
      allocate (permitedmax(n_subst))
      allocate (EQSAA(n_subst))
      allocate (MZAA (n_subst))
      allocate (MZMEAN (n_subst))
      allocate (permitedmean(n_subst))
      allocate (SafetyFactor(n_subst))

      allocate (syname(n_subst))
      allocate (syname_mean(n_subst))
      allocate (syname_max(n_subst))

	do isys = 1,n_subst
	    read (lu_ini,*) syname(isys), kd(isys), Cd(isys), SSd(isys),
     m                    Cb(isys), EQSMAC(isys), MZMAC(isys),
     m                    EQSAA(isys), MZAA (isys), SafetyFactor(isys)
	enddo
	read (lu_ini,*) n_conditions
	read (lu_ini,*)
      open (lu_out,file=outfil,access='stream',form='unformatted')

      sumfrequency = 0.0
      cmeanj3d = 0.0
      cmaxj3d = 0.0
	do ic = 1,n_conditions
	    read (lu_ini,*) frequency, ss, mapfil, tekfil
          sumfrequency = sumfrequency + frequency
!         merge delwaq results          
          open (lu_map,file=mapfil,access='stream',form='unformatted')
	    read (lu_map) moname
	    read (lu_map) notot,noseg
          if (n_subst .ne. notot) goto 910
	    if (ic.eq.1) then
	        write (lu_out) moname
	        nototstore = notot
	        nosegstore = noseg
	        write (lu_out) notot*2,noseg
	        allocate (cmax (notot,noseg))
	        allocate (cmean(notot,noseg))
	        allocate (conc (notot,noseg))
	        cmean = 0.0
	        cmax = 0.0
	        if (n_subst.ne.notot) goto 910
	    else
	        if (nototstore .ne. notot) goto 910
	        if (nosegstore .ne. noseg) goto 910
	    endif
	    do isys = 1,notot
	        read (lu_map) syname(isys)
	        if (ic.eq.1) then
	            syname_mean(isys) = trim(syname(isys))//'_mean'
	            write (lu_out) syname_mean(isys)
	            syname_max(isys) = trim(syname(isys))//'_max'
	            write (lu_out) syname_max(isys)
	        endif
	    enddo
          read (lu_map) itime,conc
	    do iseg = 1,noseg
	    do isys = 1,notot
	        ccc = Cb(isys)+(conc(isys,iseg)*SafetyFactor(isys))/
     m                  (1.+kd(isys)*ss)
              cmax(isys,iseg) = max(cmax(isys,iseg),ccc)
              cmean(isys,iseg) = cmean(isys,iseg)+ccc*frequency
          enddo
          enddo
          close (lu_map)

!         merge jet3d results
          open (lu_tek,file=tekfil)
          do i=1,10
              read (lu_tek,*)
          end do
          read (lu_tek,*) nrec, ncol
          iclass = 1
          mixzon = real(class_j3d(iclass))-0.1
          do n = 1, nrec
              read (lu_tek,*) dummy, x, y, dummy, mixfact
     	        distance = sqrt(x**2+y**2)
	        if (distance.gt.mixzon) then
!              C_t=(C_d*SafetyFactor+(Mix-1) * C_b)/Mix
                  do isys = 1, notot
                     sss = (SSd(isys) +(mixfact-1) * SS)/mixfact
                     ccc = ((Cd(isys)*SafetyFactor(isys)/
     m                     (1.+kd(isys)*sss) + 
     m                     (mixfact - 1) * Cb(isys))/mixfact)
!                     ccc = max(ccc, Cb(isys)) TODO: can the concentration be lower than the background??
                     cmeanj3d(isys, iclass) = cmeanj3d(isys, iclass) + 
     m                                ccc * frequency
                     if (ccc.gt.cmaxj3d(isys,iclass)) then
                         cmaxj3d(isys,iclass) = ccc
                     end if
                  end do
                  iclass = iclass + 1
                  if (iclass .gt. n_class_j3d) then
                      exit
                  end if
                  mixzon = real(class_j3d(iclass))-0.1
              end if    
      	enddo
          close (lu_tek)
	enddo
      
      cmean = cmean/sumfrequency
      cmeanj3d = cmeanj3d/sumfrequency
      write (lu_out) itime
	do iseg = 1,noseg
	    write (lu_out) (cmean(isys,iseg),cmax(isys,iseg),isys=1,notot)
	enddo
	close (lu_ini)
	close (lu_out)

! ----------------------------              
! Former Scremo_pp starts here
! ----------------------------              
      
	open (lu_lga,file=lgafil,access='stream',form='unformatted',
     &      status='old',err=920)
	ccofil = lgafil(1:index(lgafil,'.lga')-1)//'.cco'
	open (lu_cco,file=ccofil,access='stream',form='unformatted',
     &      status='old',err=920)
	open (lu_mes,file=mesfil)

	write (lu_mes,*) 'Input file: ', trim(inifil)
	write (lu_mes,*) 'LGA   file: ', trim(lgafil)
	write (lu_mes,*) 'CCO   file: ', trim(ccofil)
      
	! read grid input

      read (lu_lga) NMAX,MMAX,NOSEGL,NLAY,NOQ1,NOQ2,NOQ3
      ALLOCATE (LGRID(NMAX,MMAX))
      ALLOCATE (XB(NMAX,MMAX))
      ALLOCATE (YB(NMAX,MMAX))

      read (lu_lga) lgrid
	close (lu_lga)

      read (LU_cco)
      read (LU_cco) mmax,nmax,x0,y0,alpha,npart,nlay
      do n=1 , 2*npart+9
         read (LU_cco) rdum
      enddo
      read (LU_cco) XB
      read (LU_cco) YB
	close (lu_cco)

      if (noseg.ne.nosegl*nlay) goto 930

      ! calculate cell co-ordinates

	allocate (xyseg(2,noseg))
	do n = 1,nmax
	do m = 1,mmax
	    iseg = lgrid(n,m)
          if (iseg.gt.0) then
	        xyseg(1,iseg) = ( xb(n  ,m  ) 
     j                        + xb(n-1,m  ) 
     j                        + xb(n  ,m-1) 
     j                        + xb(n-1,m-1)  ) / 4.
	        xyseg(2,iseg) = ( yb(n  ,m  ) 
     j                        + yb(n-1,m  ) 
     j                        + yb(n  ,m-1) 
     j                        + yb(n-1,m-1)  ) / 4.
	        do k = 2,nlay
	        xyseg(1,iseg+(k-1)*nosegl) = xyseg(1,iseg)
	        xyseg(2,iseg+(k-1)*nosegl) = xyseg(2,iseg)
	        enddo
	    endif
	enddo
	enddo

	! find source (C max)

	cmaxdwq = 0.0
	do iseg = 1,noseg
	    if (cmax(notot,iseg) .gt. cmaxdwq(notot,1)) then
	        cmaxdwq(notot,1) = cmax(notot,iseg)
	        xs = xyseg(1,iseg)
	        ys = xyseg(2,iseg)
	    endif
	enddo
      write (lu_mes,'(/''X,Y of discharge: '',2f15.1)') xs,ys

      ! write jet3d mixing zones
      write (lu_mes,'(/i12, ''; number of jet3d mixing zones'')')
     m                n_class_j3d
      write (lu_mes,'(/''mixing zone (m)'',100('';'',a))')
     j (trim(syname_mean(isys)),trim(syname_max(isys)),isys=2,notot)
	do iclass = 1, n_class_j3d
          mixzon = class_j3d(iclass)
	    write (lu_mes,'(f10.0,100('';'',1p,e20.6))') 
     j            mixzon,(cmeanj3d(isys,iclass), cmaxj3d(isys,iclass),
     m            isys=2,notot)
	enddo

      ! loop over mixing zones
      cmeandwq = 0.0
	cmaxdwq = 0.0
      write (lu_mes,'(/i12, ''; number of mixing zones'')') n_class_dwq
      write (lu_mes,'(/''mixing zone (m)'',100('';'',a))')
     j (trim(syname_mean(isys)),trim(syname_max(isys)),isys=2,notot)
	do iclass = 1, n_class_dwq
c         subtract 0.1 to avoid being very sensitive to 100-100>0
	    mixzon = real(class_dwq(iclass))-0.1
          foundseg = .false.
	    do iseg = 1,noseg
	        x = xyseg(1,iseg)
	        y = xyseg(2,iseg)
	        distance = sqrt((x-xs)**2+(y-ys)**2)
c	if (is.eq.100) write (lu_mes,*) iseg,distance.gt.mixzon,distance
	        if (distance.gt.mixzon) foundseg = .true.
              do isys = 1,notot
	          if (distance.gt.mixzon .and. 
     m              cmean(isys,iseg).gt.cmeandwq(isys, iclass)) 
     j                  cmeandwq(isys,iclass) = cmean(isys,iseg)
	          if (distance.gt.mixzon .and. 
     m              cmax(isys,iseg).gt.cmaxdwq(isys, iclass)) 
     j                  cmaxdwq(isys,iclass) = cmax(isys,iseg)
	        enddo
          enddo
          if (.not. foundseg) then
            do isys = 1,notot
	        cmeandwq(isys,iclass) = nan
	        cmaxdwq(isys,iclass) = nan
            enddo
          end if
	    write (lu_mes,'(f10.0,100('';'',1p,e20.6))') 
     j            mixzon,(cmeandwq(isys,iclass), cmaxdwq(isys,iclass),
     m            isys=2,notot)
	enddo

!     EQS (MAC, maximum allowable concentration)
!     allowable mixing zone (MAC)
!     EQS (AA, annually averaged concentration)
!     allowable mixing zone (AA)

      mzmax = 0.0
      do isys = 1,notot
          if (MZMAC(isys).le.class_j3d(1)) then
             mzmax(isys) = cmaxj3d(isys,1)
          else if (MZMAC(isys).le.class_j3d(n_class_j3d)) then
             do iclass = 1, n_class_j3d - 1
                if(MZMAC(isys).ge.class_j3d(iclass).and.
     m             MZMAC(isys).le.class_j3d(iclass+1)) then
                   mzmax(isys) = interpolate(class_j3d(iclass),
     m              class_j3d(iclass+1), cmaxj3d(isys,iclass), 
     m              cmaxj3d(isys,iclass+1), MZMAC(isys))
                end if
             end do
          else if (MZMAC(isys).le.class_dwq(1)) then
             mzmax(isys) = interpolate(class_j3d(n_class_j3d),
     m          class_dwq(1), cmaxj3d(isys,n_class_j3d), 
     m          cmaxdwq(isys,1), MZMAC(isys))
          else if (MZMAC(isys).le.class_dwq(n_class_dwq)) then
             do iclass = 1, n_class_dwq - 1
                if(MZMAC(isys).ge.class_dwq(iclass).and.
     m             MZMAC(isys).le.class_dwq(iclass+1)) then
                   mzmax(isys) = interpolate(class_dwq(iclass),
     m              class_dwq(iclass+1), cmaxdwq(isys,iclass), 
     m              cmaxdwq(isys,iclass+1), MZMAC(isys))
                end if
             end do
          else
             mzmax(isys) = -1.0
          end if
          if (mzmax(isys).lt.0.0) then
              permitedmax(isys) = 'UNKNOWN'
          else if (mzmax(isys).le.EQSMAC(isys)) then
              permitedmax(isys) = 'YES'
          else
              permitedmax(isys) = 'NO'
          end if
      end do     
      
      mzmean = 0.0
      do isys = 1,notot
          if (MZAA(isys).le.class_j3d(1)) then
             mzmean(isys) = cmeanj3d(isys,1)
          else if (MZAA(isys).le.class_j3d(n_class_j3d)) then
             do iclass = 1, n_class_j3d - 1
                if(MZAA(isys).ge.class_j3d(iclass).and.
     m             MZAA(isys).le.class_j3d(iclass+1)) then
                   mzmean(isys) = interpolate(class_j3d(iclass),
     m              class_j3d(iclass+1), cmeanj3d(isys,iclass), 
     m              cmeanj3d(isys,iclass+1), MZAA(isys))
                end if
             end do
          else if (MZAA(isys).le.class_dwq(1)) then
             mzmean(isys) = interpolate(class_j3d(n_class_j3d),
     m          class_dwq(1), cmeanj3d(isys,n_class_j3d), 
     m          cmeandwq(isys,1), MZAA(isys))
          else if (MZAA(isys).le.class_dwq(n_class_dwq)) then
             do iclass = 1, n_class_dwq - 1
                if(MZAA(isys).ge.class_dwq(iclass).and.
     m             MZAA(isys).le.class_dwq(iclass+1)) then
                   mzmean(isys) = interpolate(class_dwq(iclass),
     m              class_dwq(iclass+1), cmeandwq(isys,iclass), 
     m              cmeandwq(isys,iclass+1), MZAA(isys))
                end if
             end do
          else
             mzmean(isys) = -1.0
          end if
          if (mzmean(isys).lt.0.0) then
              permitedmean(isys) = 'UNKNOWN'
          else if (mzmean(isys).le.EQSAA(isys)) then
              permitedmean(isys) = 'YES'
          else
              permitedmean(isys) = 'NO'
          end if
      end do     
      
      write (lu_mes,'(/''description'',100('';'',a))')
     j (trim(syname_mean(isys)),trim(syname_max(isys)),isys=2,notot)
      write (lu_mes,'(''EQS (concentration)  '',100('';'',1p,e20.6))')
     m      (EQSAA(isys), EQSMAC(isys), isys=2,notot)
      write (lu_mes,'(''allowable mixing zone'',100('';'',1p,e20.6))') 
     m      (MZAA(isys), MZMAC(isys), isys=2,notot)
      write (lu_mes,'(''field concentration'',100('';'',1p,e20.6))') 
     m      (mzmean(isys), mzmax(isys), isys=2,notot)
      write (lu_mes,'(''concentration below EQS?'',100('';'',a))') 
     m      (permitedmean(isys), permitedmax(isys), isys=2,notot)
    	close (lu_mes)

      write (*,*) 'Normal end'
      stop (0)
  900 write (*,*) 'Error: input file not found'
      stop (1)
  910 write (*,*) 'Error: inconsistent input files'
      stop (2)
      
  920 write (*,*) 'Error: input file not found'
      stop (3)
  930 write (*,*) 'Error: map file not consistent with cco/lga'
      stop (4)
  960 write (*,*)  'Allocation error'
      stop (5)
      end

      real function interpolate(X1, X2, Y1, Y2, XInt)
      implicit none
      real X1, X2, Y1, Y2, XInt
      !((E3-B3)*C4+(C3-E3)*B4)/(C3-B3)
      interpolate = ((XInt-X1)*Y2+(X2-XInt)*Y1)/(X2-X1)
      end