c     jet3d         , version  2.07,  5 October   1995, Antoon Koster
      PROGRAM JET3D
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD/ SEKTOR EZ
C
C     version 0.02           : JUNI 1979      A.W.J. KOSTER
C             1.00           : JUNI 1986      R. LE CLERCQ
C             2.00           : DEC. 1986      A. A. VAN RIJ
C             2.02 (PC)      : JULI 1988      COR VD SCHELDE, H. LEEPEL
C             2.03           : Sept 1990      BRAM VAN RIJ
C             2.04           : NOV  1990      Bram van Rij
C             2.05           : JULY 1991      Heleen Leepel
C             2.06           : Sept 1993      Pleun Koole
C             2.07           : Oct  1995      Antoon Koster
C                              Original DVOGER work array WK(10,*) changed 
C                              into 1D array WK(*), due to exceedance of
C                              (incorrect) first array dimension.
C             2.08           : TEKAL file compatible with GPP  
C
C     $Id: jet3d.for 33618 2014-04-25 11:39:48Z jeuke_ml $
C     $HeadURL: https://repos.deltares.nl/repos/ds/trunk/additional/Scremo/Jet3D/src/jet3d.for $
C
C     FUNKTIEOMSCHRIJVING    : INITIALISATIES EN DOORLOPEN VAN DE BAAN
C     INGANG                 : PROGRAMMA-AKTIVATIE
C     UITGANG                : PROGRAMMA-BEEINDIGING
C     EXTERNALS              : DFUN
C     FOUTMELDINGEN          : GEEN
C     LOGICAL UNITNUMMERS    : LUN=ISCR VOOR SCRATCH FILE
C                              LUN=INUM VOOR NUMERIEKE FILE
C                              LUN=IPR VOOR PRINTUITVOER
C                              LUN=IREF VOOR INTERFACE FILE FOR TEKAL
C                              LUN=IINP VOOR INPUT FILE (READ OR WRITE)
C     GEBRUIKTE SUBROUTINES  : INFO
C                              LEES
C                              KONTR
C                              FIND1
C                              UA1
C                              UA2
C                              RHOA1
C                              KOSPL1  (WILDLIB)
C                              DVOGER  ( I.M.S.L.)
C                              IBCICU  ( I.M.S.L.)
C                              DBCEVU  ( I.M.S.L.)
C                              ERRORS
C                              RESET
C                              WRTTEK
C
C     LIJST VAN VARIABELEN
C
C     NAAM    SOORT  COMMON-BLOCK  LENGTE  OMSCHRIJVING
C     ----    -----  ------------  ------  ------------
C
C     YYMAX   REAL       -           1     MAXIMALE WAARDE VOOR Y
C     ZZMAX   REAL       -           1     MAXIMALE WAARDE VOOR Z
C     NY      INTEGER    -           1     AANTAL RIJEN VAN HET NETWERK
C     NZ      INTEGER    -           1     AANTAL KOLOMMEN VAN HET NET-
C                                          WERK
C     YY      REAL ARRAY -           21    AFSTANDEN VAN DE RESP. RIJEN
C                                          TOT DE OORSPRONG
C                                          YY(I) IS DE AFSTAND VAN DE
C                                          I-DE RIJ TOT DE OORSPRONG
C     ZZ      REAL ARRAY -           21    AFSTANDEN VAN DE RESP. KOLOM-
C                                          MEN TOT DE OORSPRONG
C                                          ZZ(I) IS DE AFSTAND VAN DE
C                                          I-DE KOLOM TOT DE OORSPRONG
C     UTAB    INTEGER    -           1     KEUZEPARAMETER:
C                                          =0 : UA IS KONSTANT
C                                          =1 : UA = UA(Y)
C                                          =2 : UA = UA(Y,Z)
C     UA      REAL       VAST        1     AKTUELE SNELHEID VAN HET
C                                          MEDIUM
C     UAP     REAL ARRAY -           21    GETABELLEERDE SNELHEID UA(Y)
C                                          UAP(I) IS DE SNELHEID OP
C                                          Y=YY(I) , Z WILLEKEURIG
C     UAT     REAL ARRAY -           21X15 GETABELLEERDE SNELHEID
C                                          UA(Y,Z)
C                                          UAT(I,J) IS DE SNELHEID VOOR
C                                          (Y,Z)=(YY(I),ZZ(J))
C     RTAB    INTEGER    -           1     KEUZEPARAMETER:
C                                          =0 : RHOA IS KONSTANT
C                                          =1 : RHOA = RHOA(Y)
C     RHOA    REAL       VAST        1     AKTUELE DICHTHEID VAN HET
C                                          MEDIUM
C     RHOAT   REAL ARRAY -           21    GETABELLEERDE DICHTHEID
C                                          RHOA(Y)
C                                          RHOA(I) IS DE DICHTHEID VOOR
C                                          Y=YY(I)
C     XL      REAL       -           1     X-COORDINAAT LOZINGSPUNT
C     YL      REAL       -           1     Y-COORDINAAT LOZINGSPUNT
C     ZL      REAL       -           1     Z-COORDINAAT LOZINGSPUNT
C     ALMOM   REAL       VAST        1     MEESLEURKOEFFICIENT VOOR
C                                          STRALEN
C     ALTH    REAL       VAST        1     MEESLEURKOEFFICIENT VOOR
C                                          'THERMALS'
C     CD      REAL       VAST        1     'DRAG'-KOEFFICIENT
C     G       REAL       VAST        1     VERSNELLING VAN DE ZWAARTE-
C                                          KRACHT
C     H0      REAL       -           1     INITIELE STAP LANGS DE AS VAN
C                                          DE STRAAL
C     S       REAL       -           1     KOORDINAAT LANGS DE AS VAN DE
C                                          STRAAL, GERICHT VOLGENS DE
C                                          RAAKLIJN AAN DIE AS
C     SMAX    REAL       -           1     MAXIMALE WAARDE VOOR S
C     S0      REAL       -           1     STARTPUNT VOOR S
C     X0      REAL       -           1     BEGINVOORWAARDE VOOR X-KOOR-
C                                          DINAAT
C     Y0      REAL       -           1     BEGINVOORWAARDE VOOR Y-KOOR-
C                                          DINAAT
C     Z0      REAL       -           1     BEGINVOORWAARDE VOOR Z-KOOR-
C                                          DINAAT
C     C0      REAL       -           1     BEGINVOORWAARDE VOOR DE CON-
C                                          CENTRATIE OP DE AS VAN DE
C                                          STRAAL
C     PHI0    REAL       -           1     BEGINVOORWAARDE VOOR DE HOEK
C                                          DIE DE SNELHEIDSVEKTOR AAN DE
C                                          AS VAN STRAAL, MAAKT MET
C                                          PROJECTIE VAN DEZE VEKTOR IN
C                                          HET (X-Z)-VLAK
C     THETA0  REAL       -           1     BEGINVOORWAARDE VOOR DE HOEK
C                                          DIE DE PROJEKTIE VAN DE SNEL-
C                                          HEIDSVEKTOR AAN DE AS VAN DE
C                                          STRAAL, IN HET (X-Z)-VLAK
C                                          MAAKT MET DE POSITIEVE X-AS
C     B0      REAL       -           1     BEGINVOORWAARDE VOOR DE STRAA
C                                          VAN DE CIRKEL DIE DE DOORSNE-
C                                          DE VORMT VAN DE STRAAL
C     U0      REAL       -           1     BEGINVOORWAARDE VOOR DE SNEL-
C                                          HEIDSVEKTOR AAN DE AS VAN DE
C                                          STRAAL
C     RHO0    REAL       -           1     DICHTHEID VAN DE STRAAL
C     IFILE   INTEGER    -           1     KEUZEPARAMETER
C                                          IFILE=0 : GEEN UITVOER NAAR
C                                                    NUMERIEKE FILE
C                                               =1 : NUMERIEKE PROCES-
C                                                    GEGEVENS NAAR FILE
C     COSCOS  INTEGER    VAST        1     KEUZEPARAMETER
C                                          COSCOS =0 : ENTRAINMENTVGL.
C                                                      ZONDER COSFI*COST
C                                                      TERM
C                                          COSCOS =1 : -- MET COSFI*COST
C                                                      TERM
C     PRINT   REAL       -           1     ZGN. PRINTPUNT,D.W.Z. EEN PUN
C                                          OP DE AS VAN DE STRAAL,WAAROP
C                                          PRINTUITVOER WORDT GELEVERD.
C
C     PRSTEP  REAL       -           1     VASTE AFSTAND TUSSEN PUNTEN
C                                          OP DE AS VAN DE STRAAL, WAAR
C                                          PRINTUITVOER VERZORGD WORDT
C     Y       TWEE-DIM   -           8X9   OPLOSSINGSVEKTOR VAN HET STEL
C             REAL ARRAY                   SEL DIFFERENTIAALVERGELIJKIN-
C                                          GEN
C     N       INTEGER    -           1     AANTAL VERGELIJKINGEN VAN HET
C                                          STELSEL
C     MAXDER  INTEGER    -           1     MAXIMALE ORDE VAN DE DIFFEREN
C                                          TIEMETHODE
C     MTH     INTEGER    -           1     INDICATOR VAN DE DIFFERENTIE-
C                                          METHODE
C                                          MTH=0 : ADAMS-METHODE
C                                             =1 : VARIABELE-ORDE-METHOD
C                                                  VOOR STIJVE DIFFEREN-
C                                                  TIAALVERGELIJKINGEN
C                                             =2 : VARIABELE-ORDE-METHOD
C     JSTART  INTEGER    -           1     -ALS INVOERPARAMETER VOOR SUB
C                                          ROUTINE DVOGER
C                                          JSTART=0 : INITIALISEER INTE-
C                                                     GRATIE
C                                                =1 : NEEM NIEUWE STAP
C                                                     AANSLUITEND OP VO-
C                                                     RIGE STAP
C                                          -ALS UITVOERPARAMETER VOOR SU
C                                          ROUTINE DVOGER WORDT HIERMEE
C                                          DE ORDE VAN DE GEBRUIKTE ME-
C                                          THODE AANGEGEVEN
C     H       REAL       -           1     STAPGROOTTE VOOR S
C     HMIN    REAL       -           1     MINIMALE H
C     HMAX    REAL       -           1     MAXIMALE H
C     EPS     REAL       -           1     KRITERIUM VOOR DE MAXIMALE
C                                          FOUT IN DE OPLOSSING
C     YMAX    REAL ARRAY -           9     BEVAT DE MAXIMALE ABSOLUTE
C                                          WAARDE VAN ELKE KOMPONENT(=
C                                          ONBEKENDE)
C     ERROR   REAL ARRAY -           9     GESCHATTE LOKALE AFBREEKFOUT
C                                          IN ELKE KOMPONENT
C     LABDA   REAL       VAST        1     INSTELPARAMETER IN HET
C                                          STELSEL DIFFERENTIAALVERG.
C     WK      REAL ARRAY -           250   WERKPARAMETER VOOR DVOGER
C     WKK     REAL ARRAY -           250   WERKPARAMETER VOOR IBCICU
C     E       REAL       -           1     ENTRAINMENT-RATE
C     BTERM   REAL       -           1     BEHOUDSTERM
C     DUADY   REAL       VAST        1     DE AFGELEIDE DUA/DY
C     DUADZ   REAL       VAST        1     DE AFGELEIDE DUA/DZ
C     DRHODY  REAL       VAST        1     DE AFGELEIDE DRHOA/DY
C     AU      REAL ARRAY -           21    KONSTANTE TERM IN DE SPLINE
C                                          VAN UA(Y)
C     BU      REAL ARRAY -           21    KOEFFICIENT VAN Y IN DE
C                                          DE SPLINE VAN UA(Y)
C     CU      REAL ARRAY -           21    KOEFFICIENT VAN Y**2 IN DE
C                                          SPLINE VAN UA(Y)
C     DU      REAL ARRAY -           21    KOEFFICIENT VAN Y**3 IN DE
C                                          SPLINE VAN UA(Y)
C     ARHO    REAL ARRAY -           21    KONSTANTE TERM IN DE SPLINE
C                                          VAN RHOA(Y)
C     BRHO    REAL ARRAY -           21    KOEFFICIENT VAN Y IN DE
C                                          SPLINE VAN RHOA(Y)
C     CRHO    REAL ARRAY -           21    KOEFFICIENT VAN Y**2 IN DE
C                                          SPLINE VAN RHOA(Y)
C     DRHO    REAL ARRAY -           21    KOEFFICIENT VAN Y**3 IN DE
C                                          SPLINE VAN RHOA(Y)
C     C       TWEE-DIM.  -          4X4    KOEFFICIENTEN VAN DE
C             REAL ARRAY -                 BICUBIC SPLINE
C                                          ( ZIE DEF. IMSL-MANUAL 1 )
C     PDS     REAL ARRAY -           6     UITVOERPARAMETER VAN SUBR.
C                                          DBCEVU WAARIN FUNKTIEWAARDEN
C                                          EN PARTIELE AFGELEIDEN VAN
C                                          DE BICUBIC SPLINE VERMELD
C                                          STAAN
C                                          ( ZIE DEF. IMSL-MANUAL 1 )
C     IER     INTEGER    -           1     FOUTPARAMETER VANUIT
C                                          VERSCH. IMSL-ROUTINES
C
C           M A T H E M A T I S C H   M O D E L   S T R A A L 3 D
C                        D W A R S P R O F I E L
C
C     ----------------------------------------------------------------
C     Y                                .
C     ^                                .
C     A                                .
C     S                              YYMAX
C                                      .
C                                      .
C                                      .
C                                      .
C                                      .
C     <...................................... ZZMAX .................>
C                                      .
C             X  LOZINGSPUNT           .
C                                      .
C     X---------------------------------------------------------------
C     ^                                                    POS. Z-AS
C     OORSPRONG
C
C     OPM. HET PROGRAMMA IS VOLGENS DE HIERBOVEN GEDEFINIEERDE VLAKVER-
C     ---  DELING OPGEZET, WAARBIJ DE POS. X-RICHTING LOOPT IN DE LENG-
C          TERICHTING VAN HET MODEL. TER GEMOETKOMING AAN DE GEBRUIKERS-
C          LOGICA ZIJN BIJ DE IN- EN UITVOER-BESCHRIJVINGEN CQ UITVOER-
C          LAYOUT DE Y- EN Z-ASSEN OMGEWISSELD.
C          DUS IN BESCHRIJVING EN LAYOUT IS Z DE VERTICALE COORDINAAT
C          EN Y DE 2E HORIZONTALE COORDINAAT, TERWIJL DIT IN HET
C          PROGRAMMA PRECIES ANDERSOM IS !
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      PARAMETER (MAXZ=21, MAXN=9, MAXUIT=8)
C
      EXTERNAL DFUN
C
C     EXPLICIETE TYPE-DEFINIERING VAN VARIABELEN
C     VASTLEGGEN VAN COMMON-GEBIED
C
      INTEGER      COSCOS,UTAB,RTAB
      REAL*8       LABDA
C
      CHARACTER*1  NEWPG
      CHARACTER*3  EXT
C
      LOGICAL      FOUT
C
      COMMON /VAST/ UA    ,ALMOM ,ALTH  ,CD    ,G     ,RHOA  ,
     *              PI    ,LABDA ,DUADY ,DUADZ ,DRHODY,COSCOS
      COMMON /PRIN/ IPR
C
C     DIMENSIONERING VAN ARRAY 'S
C
      DIMENSION UAT(MAXZ,MAXZ),WK(250)   ,WKK(250)   ,
     *          Y( 8,MAXN)    ,UAP(MAXZ) ,RHOAT(MAXZ),
     *          YY(MAXZ)      ,ZZ(MAXZ)  ,AU(MAXZ)   ,
     *          BU(MAXZ)      ,CU(MAXZ)  ,DU(MAXZ)   ,
     *          ARHO(MAXZ)    ,BRHO(MAXZ),CRHO(MAXZ) ,
     *          DRHO(MAXZ)    ,C(4,4)    ,YMAX(MAXN) ,
     *          ERROR(MAXN)   ,PDS(6)    ,YMMX(2,MAXUIT)
C
C     INITIALIZE
C
      NEWPG  = CHAR(12)
      MXZ    = MAXZ
      MXUIT  = MAXUIT
      EXT    = 'EXT'
C
C     PARAMETER WAARDEN VAN INITIELE GROOTHEDEN
C               DEZE ZIJN OPTIONEEL TE WIJZIGEN IN LEES
C
      LABDA  = 0.90
      ALMOM  = 0.057
      ALTH   = 0.5
      CD     = 0.3
      G      = 9.81
      H0     = 1.E-3
      HMIN   = 1.E-8
      EPS    = 1.E-3
      COSCOS = 1
C
C     INITIALISATIE REKEN VARIABELEN
C
      PI     =   4.*ATAN(1.)
      RAD    = 180./PI
      IFOUT  =    0
      N      = MAXN
C
C     MACHINE AFHANKELIJKE OPEN STATEMENTS EN BANNER
C
      CALL INFO  (ISCR  ,INUM  ,IPR   ,IREF  ,IFILE ,
     *            EXT   ,JNIF  ,IINP  ,FOUT         )
      IF (FOUT) GOTO 9999
C
C     INLEZEN VAN KONSTANTEN CYBER VERSIE
C
      CALL LEES  (YYMAX ,ZZMAX ,NY    ,NZ    ,UTAB  ,UAP   ,
     *            UAT   ,RTAB  ,RHOAT ,XL    ,YL    ,ZL    ,
     *            S0    ,C0    ,THETA0,PHI0  ,B0    ,U0    ,
     *            RHO0  ,SMAX  ,H0    ,HMIN  ,EPS   ,PRSTEP,
     *            JNIF  ,IINP  ,MXZ                        )
C
C     KONTROLE OP DE LIGGING VAN DE PARAMETER LABDA
C     BEHOORT LABDA NIET TOT HET INTERVAL (0,1] DAN WORDT HET PROGRAMMA
C     MET EEN FOUTMELDING BEEINDIGD.
C
      IF (LABDA .LE. 0. .OR. LABDA .GT. 1.) CALL ERRORS(2)
C
C     WANNEER DE SNELHEDEN EN/ OF DICHTHEDEN OPGEGEVEN ZIJN IN TABEL-
C     VORM, EN DUS SPLINE-INTERPOLATIE VEREIST IS, WORDT T.G.V. HET
C     SLECHTS TWEEMAAL CONTINUE DIFFERENTIEERBAAR ZIJN VAN DE CUBIC-
C     SPLINE, DE MAXIMALE ORDE VAN DE PREDICTOR-CORRECTOR METHODE
C     IN SUBR. DVOGER GELIJK AAN TWEE GESTELD.
C     SLECHTS IN EEN VOLLEDIG HOMOGENE SITUATIE ZIJN HOGERE-ORDE
C     METHODEN TOEGESTAAN ( T/M P=7 )
C
      MAXDER = 7
      IF (UTAB .NE. 0 .OR. RTAB .NE. 0) MAXDER = 2
C
C     BEREKENEN VAN BEGINVOORWAARDEN VOOR X,Y EN Z
C
      PHI    = PHI0    /RAD
      THETA  = THETA0  /RAD
      COSPHI = COS(PHI)
      X0     = S0 * COSPHI * COS(THETA) + XL
      Y0     = S0 *          SIN(PHI  ) + YL
      Z0     = S0 * COSPHI * SIN(THETA) + ZL
C
C     KONTROLE OP DE LIGGING VAN HET PUNT (X0,Y0,Z0).
C     WANNEER HET PUNT BUITEN HET DEFINITIE-GEBIED VALT,
C     WORDT HET PROGRAMMA MET HET PRINTEN VAN EEN FOUTMELDING BEEINDIGD.
C
      IF (Y0 .LT. 0. .OR. Y0 .GT. YYMAX .OR.
     +    Z0 .LT. 0. .OR. Z0 .GT. ZZMAX    ) GO TO 55
C
C     FORMEREN VAN RIJEN EN KOLOMMEN VAN HET NETWERK
C     EN BEPALEN VAN LIGGING PUNT (X0,Y0,Z0) BINNEN NETWERK
C
      IF (UTAB .NE.0 .OR. RTAB .NE. 0) THEN
         YY(1)  =  0.
         DO 10 I=2,NY
            YY (I) = REAL (I-1) * YYMAX /REAL (NY-1)
            IF (Y0 .GE. YY (I-1)) LY = I - 1
   10    CONTINUE
C
         IF (UTAB.EQ.2) THEN
            ZZ(1)  =  0.
            DO 15 J=2,NZ
               ZZ (J) = REAL (J-1) * ZZMAX /REAL (NZ-1)
               IF (Z0 .GE. ZZ (J-1)) LZ = J - 1
   15       CONTINUE
         ENDIF
      ENDIF
C
C     PRINTUITVOER VAN KONSTANTEN
C
      CALL KONTR(EXT   ,YYMAX ,ZZMAX ,YY    ,NY    ,ZZ    ,
     *           NZ    ,UTAB  ,UAP   ,UAT   ,RTAB  ,RHOAT ,
     *           XL    ,YL    ,ZL    ,S0    ,X0    ,Y0    ,
     *           Z0    ,C0    ,THETA0,PHI0  ,B0    ,U0    ,
     *           RHO0  ,SMAX  ,N     ,MAXDER,H0    ,HMIN  ,
     *           EPS   ,IFILE ,PRSTEP,IPR   ,MXZ          )
C
C     TOEKENNEN VAN BEGINVOORWAARDEN
C
      Y (1,1) =    X0
      Y (1,2) =    Y0
      Y (1,3) =    Z0
      Y (1,4) =    C0
      Y (1,5) = THETA
      Y (1,6) =   PHI
      Y (1,7) =    B0
      Y (1,8) =    U0
      Y (1,9) =  RHO0
C
C     I.G.V. EENDIMENSIONALE TABELLEN WORDEN DE COEFFICIENTEN VAN DE
C     NATUURLIJKE SPLINE-FUNKTIE BEPAALD VAN SNELHEID EN/ OF DICHTHEID
C
      IF (UTAB.EQ.1) CALL KOSPL1(YY,UAP  ,1,NY,AU  ,BU  ,CU  ,DU  )
      IF (RTAB.EQ.1) CALL KOSPL1(YY,RHOAT,1,NY,ARHO,BRHO,CRHO,DRHO)
C
C     BEPALEN VAN SNELHEID UA EN AFGELEIDEN DUA/DY EN DUA/DZ
C     VOOR HET STARTPUNT OP DE BAAN.
C
      DUADY  = 0.
      DUADZ  = 0.
      IF (UTAB .EQ. 1) THEN
         CALL UA1   (Y0    ,LY    ,YY    ,AU    ,BU    ,CU    ,DU    )
      ELSE IF (UTAB .EQ. 2) THEN
         CALL IBCICU(UAT   ,MXZ   ,YY    ,NY    ,ZZ    ,NZ    ,
     *               LY    ,LZ    ,C     ,WKK   ,IER          )
         IF (IER .GT. 128) THEN
             WRITE (*,*) ' *** Abnormal end of program JET3D ***'
             STOP (128)
         END IF
         CALL DBCEVU(YY    ,NY    ,ZZ    ,NZ    ,LY    ,LZ    ,
     *               C     ,Y0    ,Z0    ,PDS   ,IER          )
         UA     = PDS (1)
         DUADY  = PDS (2)
         DUADZ  = PDS (3)
      ENDIF
C
C     BEPALEN VAN DICHTHEID RHOA EN AFGELEIDE DRHOA/DY VOOR HET
C     STARTPUNT OP DE BAAN.
C
      DRHODY = 0.
      IF (RTAB .EQ. 1) CALL RHOA1(Y0,LY,YY,ARHO,BRHO,CRHO,DRHO)
C
C     VASTLEGGEN VAN YMAX
C
      DO 30 J=1,N
         YMAX (J) = 1.
   30 CONTINUE
C
C     INITIEREN VAN KONSTANTEN
C
      S      = S0
      ISTEP  =  0
      IBT    =  0
      IBTC   =  1
      H      = 0.
C
C     AFDRUKKEN VAN KOPREGEL MET GEGEVENS VOOR HET STARTPUNT
C
      WRITE(IPR,'(1X,A1)') NEWPG
      WRITE(IPR,'(/,'' Results of Case: '',A3,//)') EXT
      WRITE(IPR,'(10X,''X'',9X,''Y'',9X,''Z   MIX FAC   WIDTH  '',
     *            5X,''U TOT  THETA    PHI'',7X,''RHO'',9X,''C'',
     *            9X,''U    E-RATE'',9X,''S'',/)')
C
      E1     = ALMOM  * ABS (Y(1,8))
      E2     = ALTH   * ABS (UA    ) *
     *         SQRT (SIN(Y(1,6))**2  + (COS(Y(1,6)) * SIN(Y(1,5)))**2 )
      IF (COSCOS .EQ. 1) THEN
         E2  = E2     * ABS ( COS(Y(1,6)) * COS(Y(1,5)) )
      ENDIF
      E      = E1     + E2
      BTERM  = Y(1,7) * Y(1,7) *
     *        (UA     * COS(Y(1,6))  * COS(Y(1,5))  +
     *         Y(1,8) / (LABDA       * LABDA + 1.)) * Y(1,4)
      BTERMO = BTERM
      VTOT   = UA     * COS(Y(1,6))  * COS(Y(1,5))  + Y(1,8)
      Y4     = Y(1,4) / C0
      Y5     = Y(1,5) * RAD
      Y6     = Y(1,6) * RAD
C
      IF (ABS(Y(1,4)) .GT. 1.E-12) THEN
         Y4  = 1.0 / Y4
      ELSE
         WRITE(IPR,'(/,'' ***WARNING - Concentration less  '',
     *                 ''1.E-12 on step nr: '',I5)') ISTEP
         WRITE(IPR,'(  ''              mixing is set on  0. '')')
         Y4  = 0.
      ENDIF
C
      BREED=2.0*Y(1,7)
      WRITE(IPR,'(1X,6E10.3,2F7.1,F10.2,4E10.3)')
     *            Y(1,1),Y(1,3),Y(1,2),Y4    ,BREED ,VTOT,
     *            Y5    ,Y6    ,Y(1,9),Y(1,4),Y(1,8),E   ,S
C
C     GEGEVENS VAN HET STARTPUNT NAAR DE PLOTFILE
C
      WRITE(ISCR) Y(1,1), Y(1,3), Y(1,2), Y4, BREED, VTOT, Y(1,4), S
C
C     KOPREGEL VOOR DE NUMERIEKE FILE
C
      IF (IFILE .EQ. 1) THEN
         WRITE(INUM,'('' Numerical file'',//)')
         WRITE(INUM,'('' First line   : Step        S       '',
     *                '' order of the method'')')
         WRITE(INUM,'('' Second line  : Maxima per component'')')
         WRITE(INUM,'('' Third line   : Local error per component'')')
         WRITE(INUM,'('' Fourth line  : Advised H for next step'',//)')
      ENDIF
C
C     INITIEREN VAN OVERIGE KONSTANTEN
C
      JSTART = 0
      MTH    = 0
      H      =     H0
      HMAX   = PRSTEP
      PRINT  =     S0 + PRSTEP
      J      = 1
C
C     STAPSGEWIJS DOORLOPEN VAN DE AS VAN DE STRAAL
C
C ==> START ITERATIE GEDEELTE
C
   40 CONTINUE
C
C ==> ITERATIE GEDEELTE
C
C     BEGRENS DE STAPGROOTTE H TOT HET INTERVAL (HMIN,HMAX)
C
      H      = MAX (H ,HMIN)
      H      = MIN (H ,HMAX)
C
C     PER STAP OPLOSSEN VAN HET STELSEL DIFFERENTIAALVERGELIJKINGEN.
C
      CALL DVOGER(DFUN,Y,S,N,MTH,MAXDER,JSTART,H,HMIN,HMAX,EPS,YMAX,
     +            ERROR,WK,IER)
      IP     = JSTART
      JSTART = 1
C
C     TENEINDE DE CONCENTRATIE AAN DE HAND VAN EEN RELATIEF FOUTEN-
C     KRITERIUM TE BEPALEN, WORDT HET MAXIMUM GELIJK GESTELD AAN DE
C     LAATST BEREKENDE WAARDE VOOR DE CONCENTRATIE C.
C
      YMAX(4) = Y(1,4)
C
C     BEPALEN VAN SNELHEID EN DICHTHEID VAN HET MEDIUM IN HET LAATST
C     BEREKENDE PUNT OP DE BAAN : (XP,YP,ZP)
C     VOOR DE SNELHEID EN DICHTHEID WORDEN TEVENS DE PARTIELE AFGELEIDEN
C     BEPAALD
C
      DUADY  = 0.
      DUADZ  = 0.
      DRHODY = 0.
C     XP     = Y(1,1)
      YP     = Y(1,2)
      ZP     = Y(1,3)
C
C     KONTROLE OF HET LAATST BEREKENDE PUNT BINNEN HET DEFINITIEGEBIED
C     VALT
C
      IF (YP .LT. 0. .OR. YP .GT. YYMAX .OR.
     +    ZP .LT. 0. .OR. ZP .GT. ZZMAX    ) GO TO 55
C
      IF (UTAB.EQ.2) CALL UA2(UAT,YY,NY,ZZ,NZ,YP,ZP,LY,LZ,C,WKK,MXZ)
      IF (UTAB.EQ.1 .OR. (RTAB.EQ.1 .AND. UTAB.NE.2))
     *                                   CALL FIND1(YY,NY,YP,LY)
      IF (UTAB.EQ.1) CALL UA1(YP,LY,YY,AU,BU,CU,DU)
      IF (RTAB.EQ.1) CALL RHOA1(YP,LY,YY,ARHO,BRHO,CRHO,DRHO)
C
C     BEREKEN VERDUNNING EN SCHRIJF ELKE ISTEP NAAR ISCR
C      ISTEP WORDT PAS VERHOOGD ALS ZEKER IS DAT LAATST BEREKENDE
C      PUNT BINNEN DEFINITIE GEBIED LIGT
C
      ISTEP  = ISTEP + 1
C
      Y4     = Y(1,4)  / C0
      IF (ABS(Y(1,4)) .GT. 1.E-12) THEN
         Y4  = 1.0 / Y4
      ELSE
         WRITE(IPR,'(/,'' ***WARNING - Concentration less than '',
     *             ''1.E-12 on step nr: '',I5)') ISTEP
         WRITE(IPR,'(  ''              mixing is set to  0. '')')
         Y4  = 0.
      ENDIF
      VTOT = UA * COS(Y(1,6)) * COS(Y(1,5)) + Y(1,8)
C
C---REKENING BLIJVEN HOUDEN MET Y EN Z VERWISSELT
C
      BREED=2.0*Y(1,7)
      WRITE(ISCR) Y(1,1), Y(1,3), Y(1,2), Y4, BREED, VTOT, Y(1,4), S
C
C     WANNEER S EN HET VOLGENDE PRINTPUNT OP DE BAAN SAMENVALLEN, WORDT
C     ER PRINTUITVOER GELEVERD.
C     AFHANKELIJK VAN DE VARIABELE IFILE WORDEN OOK DE
C     NUMERIEKE FILE BESCHREVEN.
C
      IF (ABS(PRINT-S) .LE. (1.1*HMIN)) THEN
C
         E1     = ALMOM  * ABS (Y(1,8))
         E2     = ALTH   * ABS (UA    ) *
     *            SQRT (SIN(Y(1,6))**2 + (COS(Y(1,6)) * SIN(Y(1,5)))**2)
         IF (COSCOS .EQ. 1) THEN
            E2  = E2     * ABS (COS(Y(1,6)) * COS(Y(1,5)))
         ENDIF
         E      = E1     + E2
         BTERM  = Y(1,7) * Y(1,7)       *
     *           (UA     * COS(Y(1,6))  * COS(Y(1,5))  +
     *            Y(1,8) / (LABDA       * LABDA + 1.)) * Y(1,4)
         IF (ABS(BTERM-BTERMO) .GT. 0.01*BTERMO) IBT = IBT + 1
         IF (ISTEP .GT. IBTC) THEN
           BTERMO = BTERM
           IBTC   = IBTC + 5
         ENDIF
         Y5     = Y(1,5) * RAD
         Y6     = Y(1,6) * RAD
C
         WRITE(IPR,'(1X,6E10.3,2F7.1,F10.2,4E10.3)')
     *               Y(1,1),Y(1,3),Y(1,2),Y4    ,BREED ,VTOT,
     *               Y5    ,Y6    ,Y(1,9),Y(1,4),Y(1,8),E   ,S
C
         IF (IFILE .EQ .1) THEN
            WRITE(INUM,'(I5,E10.3,I5/9E10.3/9E10.3/E10.3)')
     *                   ISTEP ,S     ,IP    ,(YMAX(I),I=1,N),
     *                   (ERROR(I),I=1,N)    ,H
         ENDIF
C
C        BEPALING VAN DE LIGGING VAN HET VOLGENDE PRINTPUNT OP DE BAAN
C
         PRINT  = PRINT + PRSTEP
         J      =     J + 1
      ENDIF
C
C     WANNEER IN DE IMSL-SUBROUTINE DVOGER EEN FOUTMELDING OPTREEDT,
C     (BIJV. WARNING-ERROR OF TERMINAL ERROR) DAN WORDT DE FOUTENTELLER
C     IN ALLE GEVALLEN MET EEN EENHEID VERHOOGD.
C     WANNEER IN TOTAAL MEER DAN 100 FOUTMELDINGEN GEKONSTATEERD ZIJN,
C     WORDT HET PROGRAMMA GESTOPT.
C     BETREFT HET EEN NIET-TRIVIALE MELDING UIT SUBR. DVOGER DAN WORDT
C     NA AANROEP VAN SUBR. RESET EEN NIEUWE POGING GEDAAN OM HET
C     STELSEL OP TE LOSSEN.
C
      IF (IER .EQ. 33 .OR. IER .EQ. 34 .OR. IER .EQ. 35) THEN
         CALL RESET(ISTEP ,H     )
         BACKSPACE (ISCR)
         WRITE(IPR,'(/,'' ***WARNING - Reset on Istep = '',I5)') ISTEP+1
      ENDIF
      IF (IER   .NE.   0) IFOUT = IFOUT + 1
      IF (IFOUT .GT. 100) CALL ERRORS(1)
C
C     WANNEER HET EINDE VAN DE BAAN BEREIKT IS, WORDT VERDERGEGAAN MET
C     HET VOLGENDE REKENGEVAL.
C
      IF (S .GT. SMAX) GO TO 60
C
C     DE MAXIMALE STAPGROOTTE(HMAX) WORDT ZODANIG GEKOZEN, DAT BIJ DE
C     VOLGENDE STAP HET EERSTVOLGENDE PRINTPUNT NIET KAN WORDEN
C     GEPASSEERD.
C     DOOR ALLEEN PRINTUITVOER TE GEVEN OP DE ZGN. PRINTPUNTEN WORDT
C     EEN TABEL VERKREGEN DIE EQUIDISTANT IS IN S.
C
      HMAX   = PRINT  - S
C
C <== ITERATIE GEDEELTE
C
      GO TO 40
C
C <== EINDE ITERATIE GEDEELTE
C
   55 CONTINUE
C
C EINDE ITERATIE EN OVERSCHRIJDING YYMAX OF ZZMAX
C
      WRITE(IPR,'(/,'' ***WARNING - Curve outside definition area'')')
C
   60 CONTINUE
C
C EINDE ITERATIE NA VOLTOOIING BAAN   S .GE. SMAX
C
      WRITE(IPR,'(1X,A1)') NEWPG
      WRITE(IPR,'(/,''    Last computed conservation term '',E11.4,/,
     *              '' Forlast computed conservation term '',E11.4,/)')
     *             BTERM ,BTERMO
      IF (IBT .GT. 0) THEN
         WRITE(IPR,'('' Number of variations on forlast conservation'',
     *               '' term'',I5)') IBT
      ENDIF
C
C WRITE CALCULATED VALUES FROM SCRATCH FILE TO INTERFACE FILE
C
      CALL WRTTEK(ISCR  ,IPR   ,IREF  ,EXT   ,ISTEP ,YMMX ,MXUIT)
C
C FOUTIEF / CORRECT EINDE
C
 9999 CONTINUE
C
      CLOSE(ISCR)
      CLOSE(INUM)
      CLOSE(IPR )
      CLOSE(IREF)
      CLOSE(IINP)
C
      IF (FOUT) THEN
         WRITE(*,'(/,'' *** Abnormal end of program Jet3d ***'')')
         STOP (1)
      ELSE
         WRITE(*,'(/,'' *** Normal end of program Jet3d ***'')')
         STOP (0)
      ENDIF
C
      END

c     jet3d-dbcevu  , version  2.05,  1 Januari   1978, imsl routine
      SUBROUTINE DBCEVU (X,NX,Y,NY,LX,LY,C,XL,YL,PDS,IER)
C
C   IMSL ROUTINE NAME   - DBCEVU
C
C-----------------------------------------------------------------------
C
C   FUNCTION            - BICUBIC SPLINE MIXED PARTIAL DERIVATIVE
C                           EVALUATOR
C
C   USAGE               - CALL DBCEVU (X,NX,Y,NY,LX,LY,C,XL,YL,PDS,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX. (INPUT) X MUST BE
C                           ORDERED SO THAT X(I) .LT. X(I+1) FOR
C                           I=1,...,NX-1.
C                NX     - NUMBER OF ELEMENTS IN X. (INPUT) NX MUST BE
C                           .GE. 2.
C                Y      - VECTOR OF LENGTH NY. (INPUT) Y MUST BE
C                           ORDERED SO THAT Y(J) .LT. Y(J+1) FOR
C                           J=1,...,NY-1.
C                NY     - NUMBER OF ELEMENTS IN Y. (INPUT) NY MUST BE
C                           .GE. 2.
C                         NOTE - THE COORDINATE PAIRS (X(I),Y(J)), FOR
C                           I=1,...,NX AND J=1,...,NY, GIVE THE POINTS
C                           WHERE THE FUNCTION VALUES ARE DEFINED.
C                LX     - X-DIRECTION INTERVAL FOR WHICH SPLINE
C                           COEFFICIENTS HAVE BEEN CALCULATED. (INPUT)
C                           LX MUST BE .GE. 1 AND .LT. NX.
C                LY     - Y-DIRECTION INTERVAL FOR WHICH SPLINE
C                           COEFFICIENTS HAVE BEEN CALCULATED. (INPUT)
C                           LY MUST BE .GE. 1 AND .LT. NY.
C                C      - 4 BY 4 MATRIX OF SPLINE COEFFICIENTS. (INPUT)
C                           THE SPLINE COEFFICIENTS CAN BE COMPUTED BY
C                           IMSL SUBROUTINE IBCICU.
C                XL,YL  - (XL,YL) IS THE POINT AT WHICH THE MIXED
C                           PARTIAL DERIVATIVES OF THE SPLINE ARE TO BE
C                           EVALUATED. (INPUT) THE FOLLOWING TWO
C                           CONDITIONS MUST HOLD,
C                             1. X(LX) .LE. XL .LE. X(LX+1)
C                             2. Y(LY) .LE. YL .LE. Y(LY+1).
C                PDS    - VECTOR OF LENGTH 6 CONTAINING THE PARTIAL
C                           DERIVATIVES OF THE BICUBIC SPLINE, S(U,V),
C                           EVALUATED AT U=XL AND V=YL. (OUTPUT)
C                           S(U,V) = SUM OVER I,J
C                             C(I,J)*(U-X(LX))**(I-1)*(V-Y(LY))**(J-1)
C                           FOR I=1,...,4 AND J=1,...,4.
C
C                             PDS(1) = S(XL,YL)
C                             PDS(2) = DS/DX
C                             PDS(3) = DS/DY
C                             PDS(4) = D(DS/DX)/DY
C                             PDS(5) = D(DS/DX)/DX
C                             PDS(6) = D(DS/DY)/DY.
C                           NOTE - ALL PARTIAL DERIVATIVES ARE EVALUATED
C                             AT THE POINT (XL,YL).
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         WARNING ERROR
C                           IER = 33, XL IS LESS THAN X(LX).
C                           IER = 34, YL IS LESS THAN Y(LY).
C                           IER = 35, XL IS GREATER THAN X(LX+1).
C                           IER = 36, YL IS GREATER THAN Y(LY+1).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      THE CONDITIONS REQUIRED FOR INPUT ARGUMENTS X, Y, NX,
C                NY, LX, AND LY ARE NOT CHECKED IN THE ROUTINE. IF ANY
C                OF THOSE CONDITIONS ARE NOT MET THE ROUTINE WILL NOT
C                PERFORM CORRECTLY.
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
C
      IMPLICIT REAL*8    (A-H,O-Z)
      INTEGER            NX,NY,LX,LY,IER
      REAL*8             X(NX),Y(NY),C(4,4),XL,YL,PDS(6)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            I,II,I4P1,JER,KER
      REAL*8             RIM1,RIM2,SX,SY,THREE,TWO,XLM,YLM,ZERO
      DATA               ZERO/0.0/,TWO/2.0/,THREE/3.0/,I4P1/5/
C                                  FIRST EXECUTABLE STATEMENT
      JER = 0
      KER = 0
C                                  CHECK TO SEE IF XL AND YL ARE IN THE
C                                    PROPER INTERVAL
      IF (X(LX) .GT. XL) JER = 33
      IF (XL .GT. X(LX+1)) JER = 35
      IF (Y(LY) .GT. YL) KER = 34
      IF (YL .GT. Y(LY+1)) KER = 36
C                                  INITIALIZE PDS TO ZERO
      DO 5 I=1,6
         PDS(I) = ZERO
    5 CONTINUE
C                                  COMPUTE THE DERIVATIVES AND EVALUATE
C                                    AT (XL,YL)
      XLM = XL-X(LX)
      YLM = YL-Y(LY)
      DO 10 II=1,4
         I = I4P1-II
         SY = C(I,1)+YLM*(C(I,2)+YLM*(C(I,3)+C(I,4)*YLM))
         PDS(1) = PDS(1)+SY
         IF (I .EQ. 1) GO TO 10
         RIM1 = I-1
         SY = SY*RIM1
         SX = RIM1*(C(1,I)+XLM*(C(2,I)+XLM*(C(3,I)+C(4,I)*XLM)))
         PDS(1) = PDS(1)*XLM
         PDS(2) = PDS(2)+SY
         PDS(3) = PDS(3)+SX
         PDS(4) = PDS(4)+RIM1*(C(I,2)+YLM*(TWO*C(I,3)+THREE*C(I,4)*YLM))
         IF (I .EQ. 2) GO TO 10
         PDS(2) = PDS(2)*XLM
         PDS(3) = PDS(3)*YLM
         PDS(4) = PDS(4)*XLM
         RIM2 = I-2
         PDS(5) = PDS(5)+SY*RIM2
         PDS(6) = PDS(6)+SX*RIM2
         IF (I .EQ. 3) GO TO 10
         PDS(5) = PDS(5)*XLM
         PDS(6) = PDS(6)*YLM
   10 CONTINUE
      IER = MAX0(JER,KER)
C 9000 CONTINUE
      IF (JER .NE. 0) CALL UERTST(JER,'DBCEVU')
      IF (KER .NE. 0) CALL UERTST(KER,'DBCEVU')
      RETURN
      END
c     jet3d-dfun    , version  1.01,  1 July      1979, A. W. J. Koster
      SUBROUTINE DFUN(YP, TP, M, DY, PW, IND)
C
C     FUNKTIEOMSCHRIJVING    : TOEKENNEN VAN DE RECHTERLEDEN VAN STELSEL
C     INGANG                 : SUBROUTINE-AANROEP
C     UITGANG                : TERUG NAAR AANROEPEND MODUUL
C     LOGICAL UNITNUMMERS    : GEEN
C     GEBRUIKTE SUBROUTINES  : ERRORS
C
C     LIJST VAN PARAMETERS/ VARIABELEN
C
C     NAAM    SOORT     COMMON  OMSCHRIJVING
C                       BLOCK
C     ----    -----     ------  ------------
C
C     YP      TWEE-DIM.    -    OPLOSSINGSVEKTOR VAN HET STELSEL DIFFE-
C             REAL ARRAY        RENTIAALVERGELIJKINGEN
C             (8XDYN)           YP(1,I),I=1,...,N ZIJN DE OPLOSSINGEN
C                               VOOR DE N ONBEKENDEN
C     TP      REAL         -    INAKTIEF
C     M       INTEGER      -    INAKTIEF
C     DY      EEN-DIM.     -    RECHTERLID VAN DE I-DE VERGELIJKING WORD
C             REAL ARRAY        TOEGEKEND AAN DY(I)
C             (DYN)
C     PW      TWEE-DIM.    -    INAKTIEF
C             REAL ARRAY
C             (8XDYN)
C     IND     INTEGER      -    INAKTIEF
C     UA      REAL         VAST SNELHEID IN HET ONTVANGENDE MEDIUM
C     ALMOM   REAL         VAST MEESLEURKOEFFICIENT VOOR STRALEN
C     ALTH    REAL         VAST MEESLEURKOEFFICIENT VOOR 'THERMALS'
C     CD      REAL         VAST 'DRAG'-KOEFFICIENT
C     G       REAL         VAST VERSNELLING VAN DE ZWAARTEKRACHT
C     RHOA    REAL         VAST DICHTHEID VAN HET MEDIUM
C     PI      REAL         VAST OPPERVLAKTE EENHEIDSCIRKEL
C     COSCOS  INTEGER      VAST INDICATOR ENTRAINMENTVGL.
C     LABDA   REAL         VAST INSTELPARAMETER : LABDA UIT (0,1]
C     DUADY   REAL         VAST PARTIELE AFGELEIDE DUA/DY VAN UA(Y,Z)
C     DUADZ   REAL         VAST PARTIELE AFGELEIDE DUA/DZ VAN UA(Y,Z)
C     DRHODY  REAL         VAST AFGELEIDE DRHOA/DY VAN RHOA(Y)
C     DUADS   REAL         -    AFGELEIDE DUA/DS VAN UA(S)
C     DRHODS  REAL         -    AFGELEIDE DRHOA/DS VAN RHOA(S)
C     UGEM    REAL         -    GEMIDDELDE SNELHEID
C     E       REAL         -    ENTRAINMENT-RATE
C     FDN     REAL         -    NORMAALKRACHT VAN DE 'DRAG-FORCE'
C  F1 T/M F9  REALS        -    RECHTERLEDEN IN DE IMPLICIETE DIFF. VERG
C
C     DEZE SUBROUTINE WORDT AANGEROEPEN DOOR DE SUBROUTINE DVOGER UIT
C     DE STANDAARDBIBLIOTHEEK VAN HET INTERNATIONAL MATHEMATICAL AND STA
C     TISTICAL LIBRARIES, INC. (I.M.S.L.)
C     DE GEBRUIKTE PARAMETERLIST IS VEREIST VOOR GEBRUIK VAN DVOGER
C     DIT VERKLAART DE INAKTIEVE PARAMETERS
C
C     DE OPLOSSINGSVEKTOR (X,Y,Z,C,THETA,PHI,B,U,RHO) :
C
C
C     X     = YP(1,1)
C     Y     = YP(1,2)
C     Z     = YP(1,3)
C     C     = YP(1,4)
C     THETA = YP(1,5)
C     PHI   = YP(1,6)
C     B     = YP(1,7)
C     U     = YP(1,8)
C     RHO   = YP(1,9)
C
C     VASTLEGGEN VAN COMMON-GEBIED
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER COSCOS
      REAL*8  LABDA
C
      COMMON /VAST /    UA, ALMOM,  ALTH,    CD,     G,  RHOA,    PI,
     *              LABDA, DUADY, DUADZ,DRHODY, COSCOS
C
C     DIMENSIONERING VAN ARRAYS
C
      DIMENSION YP(8,*), DY(*),PW(*)
C
C     BEPALING VAN SINUS EN COSINUS VAN POOLHOEKEN
C
      SINFI=SIN(YP(1,6))
      COSFI=COS(YP(1,6))
      SINTH=SIN(YP(1,5))
      COSTH=COS(YP(1,5))
C
C     VOOR  COSFI=0 IS HET RECHTERLID VAN DE 5-DE DIFFERENTIAALVERGELIJ-
C     KING ONBEPAALD.
C     IN SUBROUTINE ERRORS WORDT HET PROGRAMMA NA PRINTEN VAN EEN
C     FOUTMELDING GESTOPT.
C
      IF (ABS(COSFI).LT.1.E-10) CALL ERRORS(3)
C
C     BEPALEN VAN DE FAKTOREN UGEM,E,FDN EN PLAB
C
      UGEM=2.*UA*COSFI*COSTH+YP(1,8)
      TERM=1.
      IF (COSCOS.EQ.1) TERM=ABS(COSFI*COSTH)
      E=ALMOM*ABS(YP(1,8))+
     +   ALTH*ABS(UA)*SQRT(SINFI*SINFI+COSFI*COSFI*SINTH*SINTH)*TERM
      FDN=CD*SQRT(2.)*UA*ABS(UA)*YP(1,7)*
     +    SQRT(1.-COSFI*COSFI*COSTH*COSTH)/PI
      PLAB=(1.-LABDA*LABDA)/(1.+LABDA*LABDA)
C
C     VOOR UGEM=0 ZIJN DE RECHTERLEDEN VAN DIFFERENTIAALVERGELIJKING
C     4 T/M 8 ONBEPAALD
C     IN SUBROUTINE ERRORS WORDT HET PROGRAMMA NA PRINTEN VAN
C     EEN FOUTMELDING GESTOPT.
C
      IF (ABS(UGEM).LT.1.E-10) CALL ERRORS(4)
C
C     BEPALEN VAN DE FAKTOREN F1 T/M F3
C
      F1=COSFI*COSTH
      F2=SINFI
      F3=COSFI*SINTH
C
C     BEPALEN VAN AFGELEIDEN DUA/DS EN DRHOA/DS VAN UA(S) RESP. RHOA(S)
C
C     ER GELDEN DE RELATIES :
C     DUA/DS   =DUA/DY * DY/DS + DUA/DZ * DZ/DS
C     DRHOA/DS =DRHOA/DY * DY/DS
C
      DUADS=DUADY*F2+DUADZ*F3
      DRHODS=DRHODY*F2
C
C     BEPALEN VAN DE FAKTOREN F4 T/M F9
C
      F4=2.*YP(1,7)*E
C     F5=0.
      F6=UA*F4+FDN*(1.-F1*F1)
      F7=LABDA*LABDA*YP(1,7)*YP(1,7)*G*(RHOA-YP(1,9))/RHOA-FDN*SINFI*
     +   COSFI*COSTH
      F8=-FDN*COSFI*COSFI*COSTH*SINTH
      F9=-YP(1,7)*YP(1,7)*UGEM*DRHODS/(LABDA*LABDA)
C
C     BEPALEN VAN DE HULPFAKTOR T1
C
      T1=F7*SINFI+F8*SINTH*COSFI+F6*COSTH*COSFI
C
C     TOEKENNEN VAN RECHTERLEDEN VAN DIFFERENTIAALVERGELIJKINGEN
C
C
C     BEPALEN VAN AFGELEIDE D(X)/DS
C
      DY(1)=F1
C
C     BEPALEN VAN AFGELEIDE D(Y)/DS
C
      DY(2)=F2
C
C     BEPALEN VAN AFGELEIDE D(Z)/DS
C
      DY(3)=F3
C
C     BEPALEN VAN AFGELEIDE D(THETA)/DS
C
      DY(5)=(F8*COSTH-F6*SINTH)/(YP(1,7)*YP(1,7)/2.*UGEM*UGEM*COSFI)
C
C     BEPALEN VAN AFGELEIDE D(FI)/DS
C
      DY(6)=(F7*COSFI-F8*SINFI*SINTH-F6*COSTH*SINFI)/
     +      (YP(1,7)*YP(1,7)/2.*UGEM*UGEM)
C
C     BEPALEN VAN AFGELEIDE D(B)/DS
C
      DY(7)=F4/(YP(1,7)*UGEM)-T1/(YP(1,7)*UGEM*UGEM)
C
C     BEPALEN VAN AFGELEIDE D(U)/DS
C
      DY(8)=-F4/(YP(1,7)*YP(1,7))+
     +      2.*T1/(YP(1,7)*YP(1,7)*UGEM)-2.*COSFI*COSTH*DUADS+
     +      2.*UA*COSTH*SINFI*DY(6)+2.*UA*SINTH*COSFI*DY(5)
C
C     BEPALING VAN DE HULPFAKTOREN T2 EN T3
C
      T2=0.5*F4+0.5*PLAB*YP(1,7)*YP(1,7)*DY(8)+
     +   PLAB*YP(1,7)*YP(1,8)*DY(7)
      T3=YP(1,7)*YP(1,7)*(UA*COSFI*COSTH+YP(1,8)/(LABDA*LABDA+1.))
C
C     BEPALEN VAN AFGELEIDE D(RHO)/DS
C
      DY(9)=(F9-(YP(1,9)-RHOA)*T2)/T3+DRHODS
C
C     BEPALEN VAN DE AFGELEIDE D(C)/DS
C
      DY(4)=-YP(1,4)*T2/T3
C
      RETURN
      END
c     jet3d-dvoger  , version  2.05,  1 Januari   1978, imsl routine
      SUBROUTINE DVOGER (DFUN,Y,T,N,MTH,MAXDER,JSTART,H,HMIN,HMAX,EPS,
     *                   YMAX,ERROR,WK,IER)
C
C   FUNCTION            - FIRST ORDER DIFFERENTIAL EQUATION SOLVER-
C                           GEAR0S METHOD FOR DX/DT=F(X,T)
C   USAGE               - CALL DVOGER(DFUN,Y,T,N,MTH,MAXDER,JSTART,H,
C                           HMIN,HMAX,EPS,YMAX,ERROR,WK,IER)
C   PARAMETERS   DFUN   - USER SUPPLIED EXTERNAL SUBROUTINE, DFUN(YP TP,
C                           M,DY,PW,IND), WHERE
C                             YP CONTAINS THE PRESENT (I.E. AT TP)
C                               SOLUTION VECTOR AS X(1)=YP(1,1),
C                               X(2)=YP(1,2),...,X(N)=YP(1,N),
C                             TP IS THE PRESENT TIME,AND
C                             M IS THE ORDER OF THE JACOBIAN.
C                           IF IND=0, DFUN MUST COMPUTE THE N-VECTOR
C                             F(YP,TP) AND STORE THE VALUES IN DY.
C                           IF IND=1, DFUN MUST COMPUTE THE JACOBIAN OF
C                             F EVALUATED AT (YP,TP) AND STORE THE
C                             RESULT IN THE M BY M MATRIX PW.
C                           THE JACOBIAN IS COMPUTED ONLY FOR CALLS WITH
C                             MTH = 1.
C                         YP IS AN 8 BY N ARRAY. THE SOLUTION COMPONENTS
C                           ARE Y(1,1),Y(1,2),...,Y(1,N).
C                Y      - Y IS A TWO DIMENSIONAL ARRAY (8 BY N)
C                           CONTAINING THE DEPENDENT VARIABLES AND THEIR
C                           SCALED DERIVATIVES. THE SOLUTION COMPONENTS
C                           ARE X(1) = Y(1,1), X(2) = Y(1,2),...,
C                           X(N) = Y(1,N) AND Y(J+1,I) CONTAINS THE J-TH
C                           DERIVATIVE OF X(I) SCALED BY H**J/FACTORIAL
C                           (J). HERE H IS THE CURRENT STEP SIZE.
C                         ONLY Y(1,I), I=1,2,...,N NEED BE PROVIDED BY
C                           THE CALLING PROGRAM ON THE FIRST CALL TO
C                           DVOGER, I.E. WITH JSTART = 0.
C                T      - T IS THE INDEPENDENT VARIABLE.  ON INPUT, T
C                           SHOULD CONTAIN THE INITIAL VALUE OF THE
C                           INDEPENDENT VARIABLE.  ON OUTPUT, T
C                           CONTAINS THE UPDATED VALUE OF THE INDEPEN-
C                           DENT VARIABLE.
C                N      - N IS THE NUMBER OF FIRST ORDER DIFFERENTIAL
C                           EQUATIONS.
C                MTH    - MTH IS THE METHOD INDICATOR. THE USER MAY
C                           SELECT ONE OF THE FOLLOWING.
C                             MTH=0 INDICATES A PREDICTOR-CORRECTOR
C                               (ADAMS) METHOD
C                             MTH=1 INDICATES A VARIABLE-ORDER METHOD
C                               SUITABLE FOR SYSTEMS OF STIFF DIFFER-
C                               ENTIAL EQUATIONS. HERE THE USER MUST
C                               PROVIDE THE PARTIAL DERIVATIVES OF THE
C                               DIFFERENTIAL EQUATIONS WITH RESPECT TO
C                               THE X0S, THAT IS, THE JACOBIAN. THIS IS
C                               DONE IN THE CALL TO DFUN(YP,TP,M,DY,PW,
C                               IND) WITH IND=1. ON OUTPUT, PW(I,J)
C                               (I,J=1,2,...,M) MUST BE SET TO THE
C                               PARTIAL DERIVATIVE OF THE I-TH EQUATION
C                               WITH RESPECT TO X(J).
C                             MTH=2 INDICATES A VARIABLE-ORDER METHOD,
C                               BUT DVOGER COMPUTES THE PARTIAL DERVA-
C                               TIVES BY NUMERICAL DIFFERENCING. HENCE,
C                               DFUN IS CALLED WITH IND=0 ONLY.
C                MAXDER - MAXDER MUST BE SET BY THE USER TO THE MAXIMUM
C                           ORDER TO BE USED IN THE APPROXIMATION.
C                           IT MUST BE LESS THAN 8 FOR THE ADAMS METHOD
C                           AND LESS THAN 7 FOR THE STIFF METHODS.
C                JSTART - ON INPUT, JSTART HAS THE FOLLOWING MEANINGS...
C                           -1 - REPEAT THE LAST STEP WITH A NEW VALUE
C                             FOR H.
C                            0 - INITIALIZE THE INTEGRATION. THE FIRST
C                             CALL TO DVOGER MUST BE DONE WITH THIS
C                             VALUE OF JSTART.
C                           +1 - TAKE A NEW STEP CONTINUING FROM THE
C                             LAST.
C                         ON OUTPUT, JSTART IS SET TO IO, THE CURRENT
C                           ORDER OF THE METHOD. JSTART IS ALSO THE
C                           ORDER OF THE MAXIMUM DERIVATIVE AVAILABLE IN
C                           Y.
C                H      - ON INPUT, H CONTAINS THE STEP SIZE TO BE
C                           ATTEMPTED ON THE NEXT STEP. IF THIS STEP
C                           SIZE DOES NOT CAUSE A LARGER ERROR THAN
C                           REQUESTED, IT WILL BE USED. OTHERWISE, SEE
C                           PARAMETER IER. THE USER IS ADVISED TO USE
C                           A FAIRLY SMALL STEP IN THE FIRST CALL TO
C                           DVOGER.
C                         ON OUTPUT, H CONTAINS A SUGGESTED STEP SIZE
C                           FOR THE NEXT STEP IN ORDER TO ACHIEVE AN
C                           ECONOMICAL INTEGRATION.
C                HMIN   - HMIN MUST BE SET TO THE SMALLEST STEP SIZE
C                           ALLOWABLE IN THIS INTEGRATION. HMIN SHOULD
C                           BE MUCH SMALLER THAN THE EXPECTED AVERAGE
C                           STEP SIZE  FOR THE FIRST CALL SINCE A FIRST
C                           ORDER METHOD IS USED INITIALLY.
C                HMAX   - HMAX MUST BE SET TO THE LARGEST STEP SIZE
C                           ALLOWABLE IN THIS INTEGRATION.
C                EPS    - EPS IS USED TO SPECIFY THE MAXIMUM ERROR
C                           CRITERION. THE STEP SIZE AND/OR THE ORDER IS
C                           ADJUSTED SO THAT THE SINGLE STEP ERROR ESTI-
C                           MATES DIVIDED BY YMAX(I) ARE LESS THAN
C                           EPS IN THE EUCLIDEAN NORM.
C                YMAX   - YMAX IS AN N-VECTOR WHICH CONTAINS THE MAXIMUM
C                           ABSOLUTE VALUE OF EACH COMPONENT OF X CAL-
C                           CULATED SO FAR. THE COMPONENTS OF YMAX
C                           SHOULD NORMALLY BE SET TO 1. BEFORE THE
C                           FIRST CALL TO DVOGER.
C                ERROR  - ERROR IS AN N-VECTOR WHICH CONTAINS THE ESTI-
C                           MATED ONE STEP ERROR IN EACH COMPONENT.
C                WK     - WORK AREA OF DIMENSION
C                           17*N     IF MTH = 0
C                           N*(N+17) OTHERWISE
C                IER    - ERROR PARAMETER
C                         WARNING ERROR = 32 + N
C                           N = 1 INDICATES THE STEP WAS TAKEN WITH
C                             H=HMIN, BUT THE REQUESTED ERROR WAS NOT
C                             ACHIEVED
C                           N = 2 INDICATES CORRECTOR CONVERGENCE COULD
C                             NOT BE ACHIEVED FOR H GREATER THAN HMIN
C                           N = 3 INDICATES THE REQUESTED ERROR IS
C                             SMALLER THAN CAN BE HANDLED FOR THIS
C                             PROBLEM
C                         WARNING ERROR (WITH FIX ) = 64 + N
C                           N = 4 INDICATES THE MAXIMUM ORDER SPECIFIED
C                             WAS FOUND TO BE TOO LARGE. THE MAXIMUM
C                             ORDER WAS SET TO 7 FOR MTH = 0 AND
C                             TO 6 OTHERWISE.
C   PRECISION             SINGLE
C   REQD. IMSL ROUTINES - LUELMF,LUDATF,UERTST
C   LANGUAGE            - FORTRAN
C-----------------------------------------------------------------------
C   LATEST REVISION     - MARCH 18, 1975
C
      IMPLICIT REAL*8    (A-H,O-Z)
C
      DIMENSION          Y(8,N),YMAX(N),ERROR(N),WK(*),
     1                   C(8),COEF(7,2,3)
      SAVE 
      DATA               C(2),ZERO,HALF,ONE,ONEP,NDIG/-1.,0.,.5,1.,
     *                   1.000001,0/
C                                  COEFF CONTAINS THE COEFFICIENTS
C                                  USED IN SELECTING THE STEP SIZE AND
C                                  THE ORDER. THESE CONSTANTS NEED ONLY
C                                  BE ACCURATE TO A FEW DIGITS.
      DATA               COEF/2.,4.5,7.333,10.42,13.7,17.15,1.,
     *                   2.0,12.0,24.0,37.89,53.33,70.08,87.97,
     *                   3.0,6.0,9.167,12.5,15.98,1.0,1.0,
     *                   12.0,24.0,37.89,53.33,70.08,87.97,1.0,
     *                   1.,1.,0.5,0.1667,0.04133,0.008267,1.0,
     *                   1.0,1.0,2.0,1.0,.3157,.07407,.0139/
C
C     Modification JET3D Version 2.07 / Antoon Koster
C
C     Statement function IND introduced for transformation 2D work array 
C     into 1D work array.
C     Remember the original matrix was declared as WK(10,*) and that in 
C     FORTRAN 2D arrays are stored in colum major order.
C     So this gives the idendity : WK( I,J ) = WK( I + 10 * (J-1) )
C
C     All arrays WK(I,J) are replaced by WK(IND(I,J)) since there is
C     a problem with the first dimension (10) of the 2D array WK.
C
      IND(I,J)=I+10*(J-1)
C
      IER=0
      JER=0
      N4 = N*N
      IF(MTH.EQ.0) N4=0
      N1=N*10+N4
      N2 = N1 + 1
      N3 = N
      N5 = N1 + N
      N6 = N5 + 1
      N7=N6+N+N
      N8=N7+N
      N9=N8+N
      N10=N8-1
      IND1=N4+1
      IND2=N4+2
      IND9=N4+9
      IND10=N4+10
      IRET = 1
      KFLAG = 1
C                                  CHECK MAXDER. IF MTH=0, MAXDER MUST
C                                  BE LESS THAN 7. MAXDER MUST BE LESS
C                                  THAN 6, OTHERWISE.
      MXDER=MAXDER
      IF(MTH.EQ.0) GO TO 5
      IF(MAXDER.LE.6) GO TO 10
      JER=68
      MXDER=6
      GO TO 10
    5 IF(MAXDER.LE.7) GO TO 10
      JER=68
      MXDER=7
   10 IF (JSTART .LE. 0) GO TO 35
C                                  TAKE A STEP CONTINUING FROM THE LAST
C                                  STEP. SAVE INFORMATION FOR A POSSIBLE
C                                  RESTART AND CHECK H FOR A POSSIBLE
C                                  USER CHANGE. HNEW IS THE PREVIOUS
C                                  STEP SIZE AND IO IS THE CURRENT ORDER
   15 DO 20  I = 1,N
         DO 20  J = 1,K
C           WK(N4+J,I)=Y(J,I)
            WK(IND(N4+J,I))=Y(J,I)
   20 CONTINUE
      HOLD = HNEW
      IF (H .EQ. HOLD) GO TO 30
   25 RACUM = H/HOLD
      IRET1 = 1
      GO TO 375
   30 IOOLD = IO
      TOLD = T
      RACUM = ONE
      IF (JSTART .GT. 0) GO TO 135
      GO TO 50
   35 IF (JSTART .EQ. -1) GO TO 45
C                                  FIRST CALL, THE ORDER IS SET TO 1 AND
C                                  THE INITIAL DERIVATIVES CALCULATED.
      IO  = 1
      CALL DFUN(Y,T,N,WK(IND(N2,1)),WK,0)
      DO 40  I = 1,N
         N11 = N1 + I
         Y(2,I)=WK(IND(N11,1))*H
   40 CONTINUE
      HNEW = H
      K = 2
      GO TO 15
C                                  REPEAT LAST STEP. RESTORE THE SAVED
C                                  INFORMATION.
   45 IF (IO .EQ. IOOLD) JSTART = 1
      T = TOLD
      IO = IOOLD
      K = IO + 1
      GO TO 25
C                                  SET ALL COEFFICIENTS DETERMINED BY
C                                  THE ORDER AND THE METHOD TYPE.
   50 IF (MTH .EQ. 0) GO TO 55
      GO TO (95,100,105,110,115,120),IO
   55 GO TO (60,65,70,75,80,85,90),IO
   60 C(1) = -ONE
      GO TO 125
   65 C(1)=-HALF
      C(3)=-HALF
      GO TO 125
   70 C(1) = -0.41666666666667
      C(3) = -0.75
      C(4) = -0.16666666666667
      GO TO 125
   75 C(1) = -0.375
      C(3) = -0.91666666666667
      C(4) = -0.33333333333333
      C(5) = -.41666666666667E-1
      GO TO 125
   80 C(1) = -0.34861111111111
      C(3) = -1.0416666666667
      C(4) = -0.48611111111111
      C(5) = -0.10416666666667
      C(6) = -.83333333333333E-2
      GO TO 125
   85 C(1) = -0.32986111111111
      C(3) = -1.1416666666667
      C(4) = -0.625
      C(5) = -0.17708333333333
      C(6) = -0.025
      C(7) = -.13888888888889E-2
      GO TO 125
   90 C(1) = -0.31559193121693
      C(3) = -1.225
      C(4) = -0.75185185185185
      C(5) = -0.25520833333333
      C(6) = -.48611111111111E-1
      C(7) = -.48611111111111E-2
      C(8) = -.19841269841270E-3
      GO TO 125
   95 C(1)=-ONE
      GO TO 125
  100 C(1) = -0.66666666666667
      C(3) = -0.33333333333333
      GO TO 125
  105 C(1) = -0.54545454545455
      C(3) = C(1)
      C(4) = -0.09090909090909
      GO TO 125
  110 C(1) = -0.48
      C(3) = -0.7
      C(4) = -0.2
      C(5) = -0.02
      GO TO 125
  115 C(1) = -0.43795620437956
      C(3) = -0.82116788321168
      C(4) = -0.31021897810219
      C(5) = -.54744525547445E-1
      C(6) = -.36496350364963E-2
      GO TO 125
  120 C(1) = -0.40816326530612
      C(3) = -0.92063492063492
      C(4) = -0.41666666666667
      C(5) = -.99206349206349E-1
      C(6) = -.11904761904762E-1
      C(7) = -.56689342403628E-3
C                                  IF THE JACOBIAN MUST BE RE-CALCULATED
C                                  BECAUSE OF AN ORDER CHANGE, SET
C                                  IWEVAL POSITIVE AND REPEAT THE INTE-
C                                  GRATION STEP IF IT HAS NOT YET BEEN
C                                  DONE(IRET=1) OR SKIP TO A FINAL SCAL-
C                                  ING IF IT HAS BEEN COMPLETED(IRET=2).
C                                  E IS USED FOR COMPARISON OF ERRORS IN
C                                  THE CURRENT ORDER. EUP IS USED TO
C                                  INCREASE THE ORDER, EDWN IS USED TO
C                                  DECREASE THE ORDER.
  125 K = IO+1
      IDOUB = K
      MTYP = (4 - MTH)/2
      ENQ2 = .5/(IO + 1)
      ENQ3 = .5/(IO + 2)
      ENQ1 = 0.5/(IO)
      PEPSH = EPS
      EUP = (COEF(IO,MTYP,2)*PEPSH)**2
      E = (COEF(IO,MTYP,1)*PEPSH)**2
      EDWN = (COEF(IO,MTYP,3)*PEPSH)**2
      IF (EDWN .EQ. 0) GO TO 390
      BND = EPS*ENQ3/N
      IWEVAL = MTH
      GO TO (135,340), IRET
C                                  COMPUTE THE PREDICTED Y VALUES BY
C                                  EFFECTIVELY MULTIPLYING THE SAVED
C                                  INFORMATION BY THE PASCAL TRIANGLE
C                                  MATRIX.
  135 T = T + H
      DO 140 J = 2,K
         DO 140 J1 = J,K
            J2 = K - J1 + J - 1
               DO 140 I = 1,N
                  Y(J2,I) = Y(J2,I) + Y(J2+1,I)
  140 CONTINUE
C                                  TAKE UP TO 3 CORRECTOR ITERATIONS.
C                                  CONVERGENCE IS TESTED BY REQUIRING
C                                  CHANGES TO BE LESS THAN BND.
C                                  THE SUMS OF THE CORRECTIONS ARE
C                                  ACCUMULATED IN THE ARRAY ERROR(I). IT
C                                  IS EQUAL TO THE K-TH DERIVATIVE OF Y
C                                  MULTIPLIED BY H**K/(FACTORIAL(K-1) *
C                                  (C(K)). ERROR(I) IS THEREFORE PRO-
C                                  PORTIONAL TO THE ACTUAL ERRORS IN THE
C                                  LOWEST POWER OF H PRESENT. (H**K)
      DO 145 I = 1,N
         ERROR(I) = ZERO
  145 CONTINUE
      DO 220 L = 1,3
         CALL DFUN(Y,T,N,WK(IND(N2,1)),WK,0)
C                                  IF THERE HAS BEEN A CHANGE OF ORDER
C                                  OR THERE HAS BEEN TROUBLE WITH CON-
C                                  VERGENCE, THE JACOBIAN IS RE-EVALU-
C                                  ATED PRIOR TO STARTING THE CORRECTOR
C                                  ITERATION IN THE CASE OF STIFF
C                                  METHODS. IWEVAL IS THEN SET TO -1 AS
C                                  AN INDICATOR THAT IT HAS BEEN DONE.
         IF (IWEVAL .LT. 1) GO TO 185
         IF (MTH .EQ. 2) GO TO 165
         CALL DFUN(Y,T,N3,WK,WK,1)
         R = C(1)*H
         DO 150 I = 1,N4
            WK(IND(I,1))=WK(IND(I,1))*R
  150    CONTINUE
  155    N11 = N3 + 1
         N12 = N*N11 - N3
         DO 160 I = 1,N12,N11
            WK(IND(I,1))=WK(IND(I,1))+ONE
  160    CONTINUE
         IWEVAL = -1
C------- IF(N.EQ.1) GO TO 185
C                                  LU DECOMPOSE JACOBIAN
C------- CALL LUDATF(WK,WK,N,N3,NDIG,D1,D2,WK(IND(N7,1)),
C------- WK(IND(N8,1)),WK(IND(N9,1)),
C-------                                                          KER)
C------- IF(KER) 185,185,225
         GOTO 185
  165    DO 170 I = 1,N
            WK(IND(IND9,I))=Y(1,I)
  170    CONTINUE
         DO 180 J = 1,N
            R=EPS*MAX(EPS,ABS(WK(IND(IND9,J))))
            Y(1,J) = Y(1,J) + R
            D = C(1)*H/R
            CALL DFUN(Y,T,N,WK(IND(N6,1)),WK,0)
            DO 175 I = 1,N
               N11 = I + (J-1)*N3
               N12 = N5 + I
               N13 = N1 + I
               WK(IND(N11,1))=(WK(IND(N12,1))-WK(IND(N13,1)))*D
  175       CONTINUE
            Y(1,J)=WK(IND(IND9,J))
  180    CONTINUE
         GO TO 155
  185    IF (MTH .NE. 0) GO TO 195
         DO 190 I = 1,N
            N11 = N1 + I
            WK(IND(IND9,I))=Y(2,I)-WK(IND(N11,1))*H
  190    CONTINUE
         GO TO 210
  195    DO 200 I = 1,N
            N11 = N5 + I
            N12 = N1 + I
            WK(IND(N11,1))=Y(2,I)-WK(IND(N12,1))*H
  200    CONTINUE
C------- IF(N.GT.1) GO TO 202
         WK(IND(N8,1)) = WK(IND(N6,1)) / WK(IND(1,1))
         GO TO 203
C-202--- CALL LUELMF(WK,WK(IND(N6,1)),WK(IND(N7,1)),N,N3,WK(IND(N8,1)))
  203    DO 205 I=1,N
            WK(IND(IND9,I))=WK(IND(N10+I,1))
  205    CONTINUE
  210    NT = N
         DO 215 I = 1,N
            Y(1,I)=Y(1,I)+C(1)*WK(IND(IND9,I))
            Y(2,I)=Y(2,I)-WK(IND(IND9,I))
            ERROR(I)=ERROR(I)+WK(IND(IND9,I))
            IF (ABS(WK(IND(IND9,I))).LE. (BND*YMAX(I))) NT=NT-1
  215    CONTINUE
         IF (NT .LE. 0) GO TO 245
  220 CONTINUE
C                                  THE CORRECTOR FAILED TO CONVERGE IN 3
C                                  ITERATIONS. VARIOUS POSSIBILITIES ARE
C                                  CHECKED. IF H IS EQUAL TO HMIN AND
C                                  THIS IS THE ADAMS METHOD OR A STIFF
C                                  METHOD IN WHICH THE JACOBIAN HAS
C                                  ALREADY BEEN RE-EVALUATED, A NO CON-
C                                  VERGENCE EXIT IS TAKEN. OTHERWISE THE
C                                  JACOBIAN IS RE-EVALUATED AND/OR THE
C                                  STEP IS REDUCED TO TRY TO OBTAIN
C                                  CONVERGENCE.
C 225 CONTINUE
      T = T - H
      IF((ABS(H) .LE. (ABS(HMIN)*ONEP)) .AND. ((IWEVAL - MTYP) .LT. -1))
     *GO TO 230
      IF ((MTH .EQ. 0) .OR. (IWEVAL .NE. 0)) RACUM = RACUM*0.25
      IWEVAL = MTH
      IRET1 = 2
      GO TO 375
  230 KFLAG = -3
  235 DO 240 I = 1,N
         DO 240 J = 1,K
            Y(J,I)=WK(IND(N4+J,I))
  240 CONTINUE
      H = HOLD
      IO = IOOLD
      JSTART = IO
      GO TO 395
C                                  THE CORRECTOR CONVERGED AND CONTROL
C                                  IS PASSED TO STATEMENT 260 IF THE
C                                  ERROR TEST IS PASSED, AND TO 270
C                                  OTHERWISE.
C                                  IF THE STEP IS O.K. IT IS ACCEPTED.
C                                  IF IDOUB HAS BEEN REDUCED TO ONE,
C                                  A TEST IS MADE TO SEE IF THE STEP CAN
C                                  BE INCREASED AT ONE LOWER, THE
C                                  CURRENT, OR ONE HIGHER ORDER. A STEP
C                                  CHANGE IS ONLY MADE IF THE STEP CAN
C                                  BE INCREASED BY AT LEAST 1.1*H. IF NO
C                                  CHANGE IS POSSIBLE, IDOUB IS SET TO
C                                  10 TO PREVENT FURTHER TESTING FOR THE
C                                  NEXT TEN STEPS.
C                                  IF A CHANGE IS POSSIBLE, IT IS MADE
C                                  AND IDOUB IS SET TO IO + 1 TO PREVENT
C                                  FURTHER TESTING FOR THAT NUMBER OF
C                                  STEPS. IF THE ERROR WAS TOO LARGE,
C                                  THE OPTIMUM STEP SIZE FOR THIS OR
C                                  SOME LOWER ORDER IS COMPUTED, AND THE
C                                  STEP RETRIED. IF IT SHOULD FAIL TWICE
C                                  MORE IT IS AN INDICATION THAT THE
C                                  DERIVATIVES THAT HAVE ACCUMULATED IN
C                                  THE Y ARRAY HAVE ERRORS OF THE WRONG
C                                  ORDER, SO THE FIRST DERIVATIVES ARE
C                                  RECOMPUTED AND THE ORDER IS SET TO 1.
  245 D = ZERO
      DO 250 I = 1,N
         D = D + (ERROR(I)/YMAX(I))**2
  250 CONTINUE
      IWEVAL = 0
      IF (D .GT. E) GO TO 270
      IF (K .LT. 3) GO TO 260
      DO 255 J = 3,K
         DO 255 I = 1,N
               Y(J,I) = Y(J,I) + C(J)*ERROR(I)
  255 CONTINUE
  260 KFLAG = +1
      HNEW = H
      IF (IDOUB .LE. 1) GO TO 275
      IDOUB = IDOUB - 1
      IF (IDOUB .GT. 1) GO TO 350
      DO 265 I = 1,N
         WK(IND(IND10,I))=ERROR(I)
  265 CONTINUE
      GO TO 350
  270 KFLAG = KFLAG - 2
      IF(ABS(H) .LE. (ABS(HMIN)*ONEP)) GO TO 370
      T = TOLD
      IF (KFLAG .LE. -5) GO TO 360
  275 PR2 = (D/E)**ENQ2*1.2
      PR3 = 1.E+20
      IF ((IO .GE. MXDER) .OR. (KFLAG .LE. -1)) GO TO 285
      D = ZERO
      DO 280 I = 1,N
         D=D+((ERROR(I)-WK(IND(IND10,I)))/YMAX(I))**2
  280 CONTINUE
      PR3 = (D/EUP)**ENQ3*1.4
  285 PR1 = 1.E+20
      IF (IO .LE. 1) GO TO 295
      D = ZERO
      DO 290 I = 1,N
         D = D + (Y(K,I)/YMAX(I))**2
  290 CONTINUE
      PR1 = (D/EDWN)**ENQ1*1.3
  295 CONTINUE
      IF (PR2 .LE. PR3) GO TO 325
      IF (PR3 .LT. PR1) GO TO 330
  300 R = 1.0/MAX(PR1,1.E-4)
      NEWI = IO - 1
  305 IDOUB = 10
      IF ((KFLAG .EQ. 1) .AND. (R .LT. (1.1))) GO TO 350
      IF (NEWI .LE. IO) GO TO 315
      XK = ONE / K
      DO 310 I = 1,N
         Y(NEWI+1,I) = ERROR(I)*C(K)*XK
  310 CONTINUE
  315 K = NEWI + 1
      IF (KFLAG .EQ. 1) GO TO 335
      RACUM = RACUM*R
      IRET1 = 3
      GO TO 375
  320 IF (NEWI .EQ. IO) GO TO 135
      IO = NEWI
      GO TO 50
  325 IF (PR2 .GT. PR1) GO TO 300
      NEWI = IO
      R = 1.0/MAX(PR2,1.E-4)
      GO TO 305
  330 R = 1.0/MAX(PR3,1.E-4)
      NEWI = IO + 1
      GO TO 305
  335 IRET = 2
      R = MIN(R,ABS(HMAX/H))
      H = H*R
      HNEW = H
      IF (IO .EQ. NEWI) GO TO 340
      IO = NEWI
      GO TO 50
  340 R1 = ONE
      DO 345 J = 2,K
         R1 = R1*R
         DO 345 I = 1,N
               Y(J,I) = Y(J,I)*R1
  345 CONTINUE
      IDOUB = K
  350 DO 355 I = 1,N
         YMAX(I) = MAX(YMAX(I),ABS(Y(1,I)))
  355 CONTINUE
      JSTART = IO
      GO TO 395
  360 IF (IO .EQ. 1) GO TO 390
      CALL DFUN(Y,T,N,WK(IND(N2,1)),WK,0)
      R = H/HOLD
      DO 365 I = 1,N
         Y(1,I)=WK(IND(IND1,I))
         N11 = N1 + I
         WK(IND(IND2,I))=HOLD*WK(IND(N11,1))
         Y(2,I)=WK(IND(IND2,I))*R
  365 CONTINUE
      IO = 1
      KFLAG = 1
      GO TO 50
  370 KFLAG = -1
      HNEW = H
      JSTART = IO
      GO TO 400
C                                  SCALE ALL VARIABLES CONNECTED WITH
C                                  H AND RETURN TO THE CALLING SECTION
  375 RACUM = MAX(ABS(HMIN/HOLD),RACUM)
      RACUM = MIN(RACUM,ABS(HMAX/HOLD))
      R1 = 1.0
      DO 380 J = 2,K
         R1 = R1*RACUM
         DO 380 I = 1,N
            Y(J,I)=WK(IND(N4+J,I))*R1
  380 CONTINUE
      H = HOLD*RACUM
      DO 385 I = 1,N
         Y(1,I)=WK(IND(IND1,I))
  385 CONTINUE
      IDOUB = K
      GO TO (30,135,320),IRET1
  390 KFLAG = -4
      GO TO 235
  395 IF(KFLAG.EQ.1) GO TO 9000
  400 IER=32-KFLAG
 9000 CONTINUE
      IF(JER.NE.0) CALL UERTST(JER,'DVOGER')
      IF(IER.GT.33) IER = IER - 1
      IF(IER.NE.0) CALL UERTST(IER,'DVOGER')
C
      RETURN
      END
c     jet3d-errors  , version  1.02,  1 November  1990, A. A. van Rij
      SUBROUTINE ERRORS(IFLAG)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     INGANG              : SUBROUTINE-AANROEP
C     UITGANG             : FOUTMELDING EN STOP
C     LOGICAL UNITNUMMERS : LUN = IPR VOOR PRINTUITVOER
C
C     LIJST VAN PARAMETERS
C
C     NAAM       SOORT   I O T   LENGTE  COMMON  OMSCHRIJVING
C
C     IFLAG      INTEGER *          1      -     FOUTPARAMETER
C
      COMMON /PRIN/ IPR
C
      GO TO (10,20,30,40),IFLAG
C
   10 WRITE (IPR,100)
      WRITE (*,*) ' *** Abnormal end of program JET3D ***'
      STOP (100)
   20 WRITE (IPR,200)
      WRITE (*,*) ' *** Abnormal end of program JET3D ***'
      STOP (200)
   30 WRITE (IPR,300)
      WRITE (*,*) ' *** Abnormal end of program JET3D ***'
      STOP (300)
   40 WRITE (IPR,400)
      WRITE (*,*) ' *** Abnormal end of program JET3D ***'
      STOP (400)
C
C     FORMATS
C
  100 FORMAT(/,' ***ERROR - Number of error messages from',
     *         ' IMSL-routines > 100',/)
  200 FORMAT(/,' ***ERROR - Parameter LABDA not in interval ( 0,1 ]',/)
  300 FORMAT(/,' ***ERROR - Singularity in derivatives, because',
     *         ' of PHI = 90 deg.',/)
  400 FORMAT(/,' ***ERROR - Mean velocity UGEM equal zero',
     *         ' causes a singularity in the derivatives',/)
      END
c     jet3d-find1   , version  1.02,  1 April     1979, A. W. J. Koster
      SUBROUTINE FIND1(Y, NY, YS, INT)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : VOOR Y=YS WORDT HET BIJBEHORENDE INTERVAL GEZOCHT
C                    IN DE VEKTOR Y
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C
C     LIJST VAN PARAMETERS
C
C     NAAM SOORT  OMSCHRIJVING
C
C     Y     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  DE VEKTOR WAARVOOR HET INTERVAL VOOR YS GEZOCHT WORDT
C     NY   INTEGER INPUTVARIABELE ;
C                  LENGTE VAN VEKTOR Y
C     YS    REAL   INPUTVARIABELE ;
C                  DE Y-WAARDE WAARVOOR HET INTERVAL GEZOCHT WORDT
C     INT  INTEGER OUTPUTVARIABELE ;
C                  HET INTERVAL VOOR YS ; ER GELDT: Y(INT)<YS<Y(INT+1)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION Y(*)
C
C     ZOEKEN VAN HET INTERVAL VOOR YS
C
      DO 10 I=2,NY
      IF (YS.LE.Y(I)) GO TO 20
   10 CONTINUE
      I=NY
   20 INT=I-1
C
      RETURN
      END
c     jet3d-find2   , version  1.02,  1 November  1990, A. A. van Rij
      SUBROUTINE FIND2(Y, NY, Z, NZ, YS, ZS, LY, LZ)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : ZOEKEN VAN DE RECHTHOEK (LY,LZ) WAARIN HET PUNT
C                    (YS,ZS) ZICH BEVINDT
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C
C     LIJST VAN PARAMETERS
C
C     NAAM  SOORT  OMSCHRIJVING
C
C     Y     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  Y(I) IS DE AFSTAND VAN DE I-DE RIJ TOT DE OORSPRONG
C     NY   INTEGER INPUTVARIABELE ;
C                  AANTAL RIJEN IN HET NETWER
C     Z     REAL   INPUTVEKTOR VAN LENGTE NZ;
C                  Z(I) IS DE AFSTAND VAN DE I-DE KOLOM TOT DE OORSPRONG
C     NZ   INTEGER INPUTVARIABELE ;
C                  AANTAL KOLOMMEN IN HET NETWERK
C     YS    REAL   INPUTVARIABELE ;
C                  Y-COORDINAAT VAN HET GEGEVEN PUNT
C     ZS    REAL   INPUTVARIABELE ;
C                  Z-COORDINAAT VAN HET GEGEVEN PUNT
C     LY   INTEGER ALS INPUTVARIABELE :
C                  ------------------
C                  Y-INTERVAL VOOR HET VORIGE PUNT OP DE BAAN
C                  ALS OUTPUTVARIABELE :
C                  -------------------
C                  Y-INTERVAL VOOR HET PUNT (YS,ZS) ;
C                  ER GELDT Y(LY)<YS<Y(LY+1)
C     LZ   INTEGER ALS INPUTVARIABELE ;
C                  ------------------
C                  Z-INTERVAL VOOR HET VORIGE PUNT OP DE BAAN
C                  ALS OUTPUTVARIABELE :
C                  -------------------
C                  Z-INTERVAL VOOR HET PUNT (YS,ZS)
C                  ER GELDT Z(LZ)<ZS<Z(LZ+1)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION Y(*), Z(*)
C
C     ZOEK DE RECHTHOEK WAARIN HET PUNT ZICH BEVINDT.
C     ALLEEN AANGRENZENDE RECHTHOEKEN WORDEN AFGEZOCHT,
C     INITIEER EERST LOOP GRENZEN
C
      LY1=LY-1
      LY2=LY+2
      LZ1=LZ-1
      LZ2=LZ+2
C
C     CHECK ARRAY GRENZEN
C
      IF (LY1.LT.2)  LY1=2
      IF (LY2.GT.NY) LY2=NY
      IF (LZ1.LT.2)  LZ1=2
      IF (LZ2.GT.NZ) LZ2=NZ
C
C     INDEX I LOOPT IN DE Y-RICHTING
C     INDEX J LOOPT IN DE Z-RICHTING
C
C     ZOEKEN VAN DE RIJ-INDEX
C
      DO 10 I=LY1,LY2
      IF (YS.LT.Y(I)) GOTO 20
   10 CONTINUE
      I =LY2
   20 LY=I-1
C
C     ZOEKEN VAN DE KOLOM-INDEX
C
      DO 30 J=LZ1,LZ2
      IF (ZS.LT.Z(J)) GO TO 40
   30 CONTINUE
      J =LZ2
   40 LZ=J-1
C
      RETURN
      END
c     jet3d-ibcicu  , version  2.05,  1 June      1980, imsl routine
      SUBROUTINE IBCICU (F,IFD,X,NX,Y,NY,LX,LY,C,WK,IER)
C
C   FUNCTION            - BICUBIC SPLINE TWO-DIMENSIONAL COEFFICIENT
C                           CALCULATOR
C
C   USAGE               - CALL IBCICU (F,IFD,X,NX,Y,NY,LX,LY,C,WK,IER)
C
C   ARGUMENTS    F      - NX BY NY MATRIX CONTAINING THE FUNCTION
C                           VALUES. (INPUT) F(I,J) IS THE FUNCTION VALUE
C                           AT THE POINT (X(I),Y(J)) FOR I=1,...,NX AND
C                           J=1,...,NY.
C                IFD    - ROW DIMENSION OF THE MATRIX F EXACTLY
C                           AS SPECIFIED IN THE DIMENSION STATEMENT
C                           IN THE CALLING PROGRAM. (INPUT)
C                X      - VECTOR OF LENGTH NX. (INPUT) X MUST BE
C                           ORDERED SO THAT X(I) .LT. X(I+1) FOR
C                           I=1,...,NX-1.
C                NX     - NUMBER OF ELEMENTS IN X. (INPUT) NX MUST BE
C                           .GE. 2.
C                Y      - VECTOR OF LENGTH NY. (INPUT) Y MUST BE
C                           ORDERED SO THAT Y(J) .LT. Y(J+1) FOR
C                           J=1,...,NY-1.
C                NY     - NUMBER OF ELEMENTS IN Y. (INPUT) NY MUST BE
C                           .GE. 2.
C                         NOTE - THE COORDINATE PAIRS (X(I),Y(J)), FOR
C                           I=1,...,NX AND J=1,...,NY, GIVE THE POINTS
C                           WHERE THE FUNCTION VALUES F(I,J) ARE
C                           DEFINED.
C                LX     - X-DIRECTION INTERVAL FOR WHICH SPLINE
C                           COEFFICIENTS ARE SOUGHT. (INPUT) LX MUST BE
C                           .GE. 1 AND LX MUST BE .LT. NX.
C                LY     - Y-DIRECTION INTERVAL FOR WHICH SPLINE
C                           COEFFICIENTS ARE SOUGHT. (INPUT) LY MUST BE
C                           .GE. 1 AND LY MUST BE .LT. NY.
C                         NOTE - SPLINE COEFFICIENTS ARE DETERMINED FOR
C                           THE RECTANGLE, R, CONTAINING ALL POINTS
C                           (X,Y) THAT SATISFY THE FOLLOWING TWO
C                           CONDITIONS,
C                             1. X(LX) .LE. X .LE. X(LX+1)
C                             2. Y(LY) .LE. Y .LE. Y(LY+1).
C                C      - 4 BY 4 MATRIX OF SPLINE COEFFICIENTS. (OUTPUT)
C                           THE VALUE OF THE SPLINE APPROXIMATION AT A
C                           POINT (P1,P2) IN THE RECTANGLE R IS GIVEN BY
C                           S(P1,P2) = SUM OVER I,J OF
C
C                             C(I,J)*(P1-X(LX))**(I-1)*(P2-Y(LY))**(J-1)
C
C                           FOR I=1,...,4 AND J=1,...,4.
C                WK     - WORK VECTOR OF LENGTH
C                           4*MAX(4,NY)+MAX((NX-1)*3,(NY-1)*3+NY)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IFD IS LESS THAN NX.
C                           IER = 130, NX IS LESS THAN 2.
C                           IER = 131, NY IS LESS THAN 2.
C                           IER = 132, VECTOR X IS NOT ORDERED SO THAT
C                             X(1) .LT. X(2) ... .LT. X(NX).
C                           IER = 133, VECTOR Y IS NOT ORDERED SO THAT
C                             Y(1) .LT. Y(2) ... .LT. Y(NY).
C                           IER = 134, LX .LT. 1 OR LX .GE. NX.
C                           IER = 135, LY .LT. 1 OR LY .GE. NY.
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - IBCIEU,ICSEVU,ICSCCU,UERSET,UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
C
      IMPLICIT REAL*8    (A-H,O-Z)
C
      INTEGER            IFD,NX,NY,LX,LY,IER
      REAL*8             F(IFD,NY),X(NX),Y(NY),C(16),WK(1)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IWK,JER,L,LM1,I,IPL,J,LC,LW,K
      REAL*8             A(4,4),DX,DXX,DY,DYY,ONE,P25,P75,
     1                   THREE,XL(4),YL(4),ZERO
      DATA               ZERO/0.0/,P25/0.25/,P75/0.75/,
     1                   ONE/1.0/,THREE/3.0/,
     2                   A/3.0,-19.0,32.0,-16.0,
     3                     0.0,24.0,-56.0,32.0,
     4                     0.0,-8.0,40.0,-32.0,
     5                     0.0,3.0,-16.0,16.0/
C                                  FIRST EXECUTABLE STATEMENT
      IER = 0
C                                  CHECK NX AND NY
      IF (NX .LT. 2) GO TO 40
      IF (NY .LT. 2) GO TO 45
C                                  CHECK LX AND LY
      IF (LX .LT. 1 .OR. LX .GE. NX) GO TO 50
      IF (LY .LT. 1 .OR. LY .GE. NY) GO TO 55
C                                  COMPUTE LENGTH OF X AND Y INTERVALS,
C                                    DIVIDE EACH INTO FOUR EQUAL PARTS
C                                    AND ASSIGN THESE VALUES TO XL AND
C                                    YL RESPECTIVELY
      DX = X(LX+1)-X(LX)
      DY = Y(LY+1)-Y(LY)
      XL(1) = X(LX)
      XL(2) = X(LX)+P25*DX
      XL(3) = X(LX)+P75*DX
      XL(4) = X(LX+1)
      YL(1) = Y(LY)
      YL(2) = Y(LY)+P25*DY
      YL(3) = Y(LY)+P75*DY
      YL(4) = Y(LY+1)
C                                  INTERPOLATE PLACING THE SPLINE VALUES
C                                    IN WK(1),...,WK(IWK-1). IWK IS
C                                    COMPUTED IN ORDER TO ALLOW
C                                    SUFFICIENT LENGTH OF WK AS IT IS
C                                    ALSO USED AS WORKING STORAGE BY
C                                    IBCIEU.
      IWK = 4*MAX0(4,NY)+1
      CALL IBCIEU (F,IFD,X,NX,Y,NY,XL,4,YL,4,WK(1),4,WK(IWK),JER)
C                                  CHECK FOR TERMINAL ERROR FROM IBCIEU.
C                                    NOTE THAT A WARNING ERROR CANNOT
C                                    OCCUR BECAUSE OF THE WAY XL AND YL
C                                    ARE DEFINED.
      IF (JER .NE. 0) GO TO 60
C                                  COMPUTE THE COEFFICIENTS BY SOLVING
C                                    THE 16 BY 16 LINEAR SYSTEM.
      DO 10 L=1,13,4
         LM1 = L-1
         DO 5 I=1,4
            IPL = I+LM1
            C(IPL) = ZERO
            DO 5 J=1,4
               C(IPL) = C(IPL)+A(I,J)*WK(J+LM1)
    5    CONTINUE
   10 CONTINUE
      DO 15 L=1,16
         WK(L) = C(L)/THREE
         C(L) = ZERO
         IF (L .LE. 4) C(L) = WK(L)
   15 CONTINUE
      LC = 0
      DO 25 I=2,4
         LC = LC+4
         LW = -4
         DO 20 J=1,4
            LW = LW+4
            DO 20 K=1,4
               C(LC+K) = C(LC+K)+A(I,J)*WK(LW+K)
   20    CONTINUE
   25 CONTINUE
C
      L = 0
      DYY = ONE
      DO 35 J=1,4
         DXX = ONE
         DO 30 I=1,4
            L = L+1
            C(L) = C(L)*DXX*DYY
            IF (L .GE. 5) C(L) = C(L)/THREE
            DXX = DXX/DX
   30    CONTINUE
         DYY = DYY/DY
   35 CONTINUE
      GO TO 9005
   40 IER = 130
      GO TO 9000
   45 IER = 131
      GO TO 9000
   50 IER = 134
      GO TO 9000
   55 IER = 135
      GO TO 9000
   60 IER = JER
      IF (IER .GT. 132) IER = IER-1
 9000 CONTINUE
      CALL UERTST(IER,'IBCICU')
 9005 RETURN
      END
c     jet3d-ibcieu  , version  2.05,  1 June      1980, imsl routine
      SUBROUTINE IBCIEU (F,IFD,X,NX,Y,NY,XL,NXL,YL,NYL,FL,IFLD,WK,IER)
C
C   FUNCTION            - BICUBIC SPLINE TWO-DIMENSIONAL INTERPOLATOR
C
C   USAGE               - CALL IBCIEU (F,IFD,X,NX,Y,NY,XL,NXL,YL,NYL,
C                           FL,IFLD,WK,IER)
C
C   ARGUMENTS    F      - NX BY NY MATRIX CONTAINING THE FUNCTION
C                           VALUES. (INPUT) F(I,J) IS THE FUNCTION VALUE
C                           AT THE POINT (X(I),Y(J)) FOR I=1,...,NX AND
C                           J=1,...,NY.
C                IFD    - ROW DIMENSION OF THE MATRIX F EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT
C                           IN THE CALLING PROGRAM. (INPUT)
C                X      - VECTOR OF LENGTH NX. (INPUT) X MUST BE
C                           ORDERED SO THAT X(I) .LT. X(I+1) FOR
C                           I=1,...,NX-1.
C                NX     - NUMBER OF ELEMENTS IN X. (INPUT) NX MUST BE
C                           .GE. 2.
C                Y      - VECTOR OF LENGTH NY. (INPUT) Y MUST BE
C                           ORDERED SO THAT Y(J) .LT. Y(J+1) FOR
C                           J=1,...,NY-1.
C                NY     - NUMBER OF ELEMENTS IN Y. (INPUT) NY MUST BE
C                           .GE. 2.
C                         NOTE - THE COORDINATE PAIRS (X(I),Y(J)), FOR
C                           I=1,...,NX AND J=1,...,NY, GIVE THE POINTS
C                           WHERE THE FUNCTION VALUES F(I,J) ARE
C                           DEFINED.
C                XL     - VECTOR OF LENGTH NXL. (INPUT)
C                NXL    - NUMBER OF ELEMENTS IN XL. (INPUT)
C                YL     - VECTOR OF LENGTH NYL. (INPUT)
C                NYL    - NUMBER OF ELEMENTS IN YL. (INPUT)
C                         NOTE - THE COORDINATE PAIRS (XL(I),YL(J)),
C                           FOR I=1,...,NXL AND J=1,...,NYL, GIVE THE
C                           POINTS AT WHICH THE INTERPOLATORY BICUBIC
C                           SPLINE IS TO BE EVALUATED.
C                FL     - NXL BY NYL MATRIX CONTAINING THE INTERPOLATORY
C                           BICUBIC SPLINE VALUES. (OUTPUT) FL(I,J) IS
C                           SET TO THE VALUE OF THE INTERPOLATORY
C                           BICUBIC SPLINE AT (XL(I),YL(J)) FOR
C                           I=1,...,NXL AND J=1,...,NYL. NOTE THAT THE
C                           NUMBER OF COLUMNS IN FL MUST BE .GE.
C                           MAX(NYL,NY) SINCE FL IS ALSO USED AS
C                           WORKING STORAGE (OF SIZE NXL BY NY) DURING
C                           THE COMPUTATION.
C                IFLD   - ROW DIMENSION OF THE MATRIX FL EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT
C                           IN THE CALLING PROGRAM. (INPUT)
C                WK     - WORK VECTOR OF LENGTH
C                           MAX((NX-1)*3,(NY-1)*3+NY).
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IFD IS LESS THAN NX.
C                           IER = 130, IFLD IS LESS THAN NXL.
C                           IER = 131, NX IS LESS THAN 2.
C                           IER = 132, NY IS LESS THAN 2.
C                           IER = 133, VECTOR X IS NOT ORDERED SO THAT
C                             X(1) .LT. X(2) ... .LT. X(NX).
C                           IER = 134, VECTOR Y IS NOT ORDERED SO THAT
C                             Y(1) .LT. Y(2) ... .LT. Y(NY).
C                         WARNING ERROR
C                           IER = 37, XL(I) IS LESS THAN X(1) OR
C                             GREATER THAN X(NX).
C                           IER = 38, YL(I) IS LESS THAN Y(1) OR
C                             GREATER THAN Y(NY).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - ICSEVU,ICSCCU,UERSET,UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
C
      IMPLICIT REAL*8    (A-H,O-Z)
C
      INTEGER            IFD,NX,NY,NXL,NYL,IFLD,IER
      REAL*8             F(IFD,NY),X(NX),Y(NY),XL(NXL),YL(NYL),
     1                   FL(IFLD,1),WK(1)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            KER,LER,MER,NXM1,NYM1,IY,JER,KYL,KYLP1,IXL,
     1                   IYL,LEVEL,LEVOLD
C                                  FIRST EXECUTABLE STATEMENT
      KER = 0
      LER = 0
C                                  CHECK IFD .GE. NX
      IF (IFD .LT. NX) GO TO 30
C                                  CHECK IFLD .GE. NX.
      IF (IFLD .LT. NXL) GO TO 35
C                                  CHECK NX .GE. 2
      IF (NX .LT. 2) GO TO 36
C                                  CHECK NY .GE. 2
      IF (NY .LT. 2) GO TO 37
C                                  CALL UERSET TO SILENCE WARNING
C                                    MESSAGES FROM ICSEVU
      LEVEL = 2
      CALL UERSET (LEVEL,LEVOLD)
      MER = 0
      NXM1 = NX-1
      NYM1 = NY-1
C                                  INTERPOLATE IN THE X-DIRECTION
      DO 10 IY=1,NY
C                                  CALCULATE THE COEFFICIENTS
         CALL ICSCCU (X,F(1,IY),NX,WK(1),NXM1,JER)
C                                  CHECK FOR ERROR IN ICSCCU
         IF (JER .NE. 0) GO TO 40
C                                  EVALUATE
         CALL ICSEVU (X,F(1,IY),NX,WK(1),NXM1,XL,FL(1,IY),NXL,JER)
C                                  CHECK FOR ERROR IN ICSEVU
         IF (JER .NE. 0) KER = 37
   10 CONTINUE
      KYL = NYM1*3
      KYLP1 = KYL+1
C                                  INTERPOLATE IN THE Y-DIRECTION
      DO 25 IXL=1,NXL
         DO 15 IY=1,NY
            WK(KYL+IY) = FL(IXL,IY)
   15    CONTINUE
C                                  CALCULATE THE COEFFICIENTS
         CALL ICSCCU (Y,WK(KYLP1),NY,WK(1),NYM1,JER)
C                                  CHECK FOR ERROR IN ICSCCU
         IF (JER .NE. 0) GO TO 45
C                                  EVALUATE
         DO 20 IYL=1,NYL
            CALL ICSEVU (Y,WK(KYLP1),NY,WK(1),NYM1,YL(IYL),FL(IXL,IYL),
     1                   1,JER)
C                                  CHECK FOR ERROR IN ICSEVU
            IF (JER .NE. 0) LER = 38
   20    CONTINUE
   25 CONTINUE
      GO TO 46
C                                  HANDLE ERRORS
   30 MER = 129
      GO TO 50
   35 MER = 130
      GO TO 50
   36 MER = 131
      GO TO 50
   37 MER = 132
      GO TO 50
   40 MER = 133
      GO TO 46
   45 MER = 134
   46 CALL UERSET (LEVOLD,LEVEL)
   50 IER = MAX0(MER,KER,LER)
C9000 CONTINUE
      IF (MER .NE. 0) CALL UERTST(MER,'IBCIEU')
      IF (KER .NE. 0) CALL UERTST(KER,'IBCIEU')
      IF (LER .NE. 0) CALL UERTST(LER,'IBCIEU')
c9005 CONTINUE
      RETURN
      END
c     jet3d-icsccu  , version  2.05,  1 June      1980, imsl routine
      SUBROUTINE ICSCCU (X,Y,NX,C,IC,IER)
C
C   FUNCTION            - CUBIC SPLINE INTERPOLATION
C                           (EASY-TO-USE VERSION)
C
C   USAGE               - CALL ICSCCU (X,Y,NX,C,IC,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX. (INPUT) X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS.
C                           (INPUT)
C                NX     - NUMBER OF ELEMENTS IN X AND Y. (INPUT) NX
C                           MUST BE .GE. 2.
C                C      - SPLINE COEFFICIENTS. (OUTPUT) C IS AN NX-1 BY
C                           3 MATRIX. THE VALUE OF THE SPLINE
C                           APPROXIMATION AT T IS
C                           S(T) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
C                           WHERE X(I) .LE. T .LT. X(I+1) AND
C                           D = T-X(I).
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT IN
C                           THE CALLING PROGRAM. (INPUT)
C                IER    - ERROR PARAMETER. (OUTPUT)
C                         TERMINAL ERROR
C                           IER = 129, IC IS LESS THAN NX-1.
C                           IER = 130, NX IS LESS THAN 2.
C                           IER = 131, INPUT ABSCISSA ARE NOT ORDERED
C                             SO THAT X(1) .LT. X(2) ... .LT. X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1980 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
C
      IMPLICIT REAL*8    (A-H,O-Z)
C
      INTEGER            NX,IC,IER
      REAL*8             X(NX),Y(NX),C(IC,3)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            IM1,I,JJ,J,MM1,MP1,M,NM1,NM2
      REAL*8             DIVDF1,DIVDF3,DTAU,G,CNX(3)
C                                  FIRST EXECUTABLE STATEMENT
      NM1 = NX-1
      IER = 129
      IF (IC .LT. NM1) GO TO 9000
      IER = 130
      IF (NX .LT. 2) GO TO 9000
      IER = 131
      IF (NX .EQ. 2) GO TO 45
C                                  COMPUTE NOT-A-KNOT SPLINE
      DO 5 M = 2,NM1
         MM1=M-1
         C(M,2) = X(M)-X(MM1)
         IF (C(M,2).LE.0.0) GO TO 9000
         C(M,3) = (Y(M)-Y(MM1))/C(M,2)
    5 CONTINUE
      CNX(2) = X(NX)-X(NM1)
      IF (CNX(2).LE.0.0) GO TO 9000
      CNX(3) = (Y(NX)-Y(NM1))/CNX(2)
      IER = 0
      NM2 = NX-2
      IF (NX .GT. 3) GO TO 10
      C(1,3) = CNX(2)
      C(1,2) = C(2,2)+CNX(2)
      C(1,1) = ((C(2,2)+2.*C(1,2))*C(2,3)*CNX(2)+C(2,2)**2*CNX(3))
     1/C(1,2)
      GO TO 20
   10 C(1,3) = C(3,2)
      C(1,2) = C(2,2)+C(3,2)
      C(1,1) = ((C(2,2)+2.*C(1,2))*C(2,3)*C(3,2)+C(2,2)**2*C(3,3))
     1/C(1,2)
      DO 15 M=2,NM2
         MP1=M+1
         MM1=M-1
         G = -C(MP1,2)/C(MM1,3)
         C(M,1) = G*C(MM1,1)+3.*C(M,2)*C(MP1,3)+3.*C(MP1,2)*C(M,3)
         C(M,3) = G*C(MM1,2)+2.*C(M,2)+2.*C(MP1,2)
   15 CONTINUE
   20 G = -CNX(2)/C(NM2,3)
      C(NM1,1) = G*C(NM2,1)+3.*C(NM1,2)*CNX(3)+3.*CNX(2)*C(NM1,3)
      C(NM1,3) = G*C(NM2,2)+2.*C(NM1,2)+2.*CNX(2)
      IF (NX.GT.3) GO TO 25
      CNX(1)=2.*CNX(3)
      CNX(3)=1.
      G=-1./C(NM1,3)
      GO TO 30
   25 G = C(NM1,2)+CNX(2)
      CNX(1) = ((CNX(2)+2.*G)*CNX(3)*C(NM1,2)+CNX(2)**2*
     1(Y(NM1)-Y(NX-2))/C(NM1,2))/G
      G = -G/C(NM1,3)
      CNX(3) = C(NM1,2)
   30 CNX(3) = G*C(NM1,2)+CNX(3)
      CNX(1) = (G*C(NM1,1)+CNX(1))/CNX(3)
      C(NM1,1) = (C(NM1,1)-C(NM1,2)*CNX(1))/C(NM1,3)
      DO 35 JJ=1,NM2
         J = NM1-JJ
         C(J,1) = (C(J,1)-C(J,2)*C(J+1,1))/C(J,3)
   35 CONTINUE
      DO 40 I=2,NM1
         IM1 = I-1
         DTAU = C(I,2)
         DIVDF1 = (Y(I)-Y(IM1))/DTAU
         DIVDF3 = C(IM1,1)+C(I,1)-2.*DIVDF1
         C(IM1,2) = (DIVDF1-C(IM1,1)-DIVDF3)/DTAU
         C(IM1,3) = DIVDF3/DTAU**2
   40 CONTINUE
      DTAU = CNX(2)
      DIVDF1 = (Y(NX)-Y(NM1))/DTAU
      DIVDF3 = C(NM1,1)+CNX(1)-2.*DIVDF1
      C(NM1,2) = (DIVDF1-C(NM1,1)-DIVDF3)/DTAU
      C(NM1,3) = DIVDF3/DTAU**2
      GO TO 9005
   45 IF (X(1) .GE. X(2)) GO TO 9000
      IER = 0
      C(1,1) = (Y(2)-Y(1))/(X(2)-X(1))
      C(1,2) = 0.0
      C(1,3) = 0.0
      GO TO 9005
 9000 CONTINUE
      CALL UERTST(IER,'ICSCCU')
 9005 RETURN
      END
c     jet3d-icsevu  , version  2.05,  1 Januari   1978, imsl routine
      SUBROUTINE ICSEVU  (X,Y,NX,C,IC,U,S,M,IER)
C
C   FUNCTION            - EVALUATION OF A CUBIC SPLINE
C
C   USAGE               - CALL ICSEVU(X,Y,NX,C,IC,U,S,M,IER)
C
C   ARGUMENTS    X      - VECTOR OF LENGTH NX CONTAINING THE ABSCISSAE
C                           OF THE NX DATA POINTS (X(I),Y(I)) I=1,...,
C                           NX (INPUT). X MUST BE ORDERED SO THAT
C                           X(I) .LT. X(I+1).
C                Y      - VECTOR OF LENGTH NX CONTAINING THE ORDINATES
C                           (OR FUNCTION VALUES) OF THE NX DATA POINTS
C                           (INPUT).
C                NX     - NUMBER OF ELEMENTS IN X AND Y (INPUT).
C                           NX MUST BE .GE. 2.
C                C      - SPLINE COEFFICIENTS (INPUT). C IS AN NX-1 BY
C                           3 MATRIX.
C                IC     - ROW DIMENSION OF MATRIX C EXACTLY AS
C                           SPECIFIED IN THE DIMENSION STATEMENT
C                           IN THE CALLING PROGRAM (INPUT).
C                           IC MUST BE .GE. NX-1.
C                U      - VECTOR OF LENGTH M CONTAINING THE ABSCISSAE
C                           OF THE M POINTS AT WHICH THE CUBIC SPLINE
C                           IS TO BE EVALUATED (INPUT).
C                S      - VECTOR OF LENGTH M (OUTPUT).
C                           THE VALUE OF THE SPLINE APPROXIMATION AT
C                           U(I) IS
C                           S(I) = ((C(J,3)*D+C(J,2))*D+C(J,1))*D+Y(J)
C                           WHERE X(J) .LE. U(I) .LT. X(J+1) AND
C                           D = U(I)-X(J).
C                M      - NUMBER OF ELEMENTS IN U AND S (INPUT).
C                IER    - ERROR PARAMETER (OUTPUT).
C                         WARNING ERROR
C                           IER = 33, U(I) IS LESS THAN X(1).
C                           IER = 34, U(I) IS GREATER THAN X(NX).
C
C   PRECISION/HARDWARE  - SINGLE AND DOUBLE/H32
C                       - SINGLE/H36,H48,H60
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS  1.  THE ROUTINE ASSUMES THAT THE ABSCISSAE OF THE NX
C                DATA POINTS ARE ORDERED SUCH THAT X(I) IS LESS THAN
C                X(I+1) FOR I=1,...,NX-1. NO CHECK OF THIS CONDITION
C                IS MADE IN THE ROUTINE. UNORDERED ABSCISSAE WILL CAUSE
C                THE ALGORITHM TO PRODUCE INCORRECT RESULTS.
C            2.  THE ROUTINE GENERATES TWO WARNING ERRORS. ONE ERROR
C                OCCURS IF U(I) IS LESS THAN X(1), FOR SOME I IN THE
C                THE INTERVAL (1,M) INCLUSIVELY. THE OTHER ERROR OCCURS
C                IF U(I) IS GREATER THAN X(NX), FOR SOME I IN THE
C                INTERVAL (1,M) INCLUSIVELY.
C            3.  THE ORDINATE Y(NX) IS NOT USED BY THE ROUTINE. FOR
C                U(K) .GT. X(NX-1), THE VALUE OF THE SPLINE, S(K), IS
C                GIVEN BY
C                 S(K)=((C(NX-1,3)*D+C(NX-1,2))*D+C(NX-1,1))*D+Y(NX-1)
C                WHERE D=U(K)-X(NX-1).
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
C
      IMPLICIT REAL*8    (A-H,O-Z)
C
      INTEGER            NX,IC,M,IER
      REAL*8             X(NX),Y(NX),C(IC,3),U(M),S(M)
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      INTEGER            I,JER,KER,NXM1,K
      REAL*8             D,DD,ZERO
      DATA               I/1/,ZERO/0.0/
C                                  FIRST EXECUTABLE STATEMENT
      JER = 0
      KER = 0
      IF (M .LE. 0) GO TO 9005
      NXM1 = NX-1
      IF (I .GT. NXM1) I = 1
C                                  EVALUATE SPLINE AT M POINTS
      DO 40 K=1,M
C                                  FIND THE PROPER INTERVAL
         D = U(K)-X(I)
         IF (D) 5,25,15
    5    IF (I .EQ. 1) GO TO 30
         I = I-1
         D = U(K)-X(I)
         IF (D) 5,25,20
   10    I = I+1
         D = DD
   15    IF (I .GE. NX) GO TO 35
         DD = U(K)-X(I+1)
         IF (DD .GE. ZERO) GO TO 10
         IF (D .EQ. ZERO) GO TO 25
C                                  PERFORM EVALUATION
   20    S(K) = ((C(I,3)*D+C(I,2))*D+C(I,1))*D+Y(I)
         GO TO 40
   25    S(K) = Y(I)
         GO TO 40
C                                  WARNING - U(I) .LT. X(1)
   30    JER = 33
         GO TO 20
C                                  IF U(I) .GT. X(NX) - WARNING
   35    IF (DD .GT. ZERO) KER = 34
         D = U(K)-X(NXM1)
         I = NXM1
         GO TO 20
   40 CONTINUE
      IER = MAX0(JER,KER)
c9000 CONTINUE
      IF (JER .GT. 0) CALL UERTST(JER,'ICSEVU')
      IF (KER .GT. 0) CALL UERTST(KER,'ICSEVU')
 9005 RETURN
      END
c     jet3d-info    , version  2.06,  5 September 1993, Pleun Koole
      SUBROUTINE INFO  (ISCR  ,INUM  ,IPR   ,IREF  ,IFILE ,
     *                  EXT   ,JNIF  ,IINP  ,FOUT         )
C
C***********************************************************************
C
C DELFT HYDRAULICS             DIVISION ESTUARIES AND SEAS
C
C FUNCTION           : GENERAL INFORMATION AND FILE DEFINITION
C ENTRY              : SUBROUTINE CALL STR3D
C EXIT               : CALLING MODULE
C EXTERNALS          : NONE
C ERROR MESSAGES     : NONE
C LOGICAL UNITS      : MACHINE DEPENDENT OPEN FILE PC EXTENSION
C                      ISCR  =  1               SCRATCH FILE FOR IREF
C                      INUM  =  2 STR3DNUM.EXT  NUMERICAL OUTPUT FILE
C                      IPR   =  6 STR3DPRT.EXT  PRINT DEVICE
C                      IREF  =  8 STR3DTEK.EXT  INTERFACE FILE FOR TEKAL
C                      IINP  =  9 STR3DINP.EXT  INPUT FILE FOR NEXT RUN
C SUBROUTINES CALLED : TRISULA.SIM  DATTIM
C
C PARAMETERS
C
C NAME    TYPE     I O T LENGTH    DESCRIPTION
C ----    ----     - - - ------    -----------
C
C ISCR    INTEGER    *   1         SCARTCH FILE FOR TEKAL
C INUM    INTEGER    *   1         FILE WITH NUMERICAL RESULTS
C IPR     INTEGER    *   1         PRINT FILE
C IREF    INTEGER    *   1         INTERFACE FILE FOR TEKAL
C IFILE   INTEGER    *   1         FLAG FOR NUMERICAL FILE
C EXT     CHAR*3     *   1         RUN IDENTIFICATION
C FOUT    LOGICAL    *   1         FLAG TO EXIT PROGRAM
C BEGDAT  CHAR*20      * 1         PROGRAM START DATE AND TIME
C JNIF    INTEGER    *   1         INDICATOR J/N (1/0) INPUT FILE
C IINP    INTEGER    *   1         LUN INPUT FILE
C
C***********************************************************************
C
C DECLARATIONS AND SPECIFICATIONS
C
C
      CHARACTER*1  ANTW
      CHARACTER*3  EXT   ,EXT1
      CHARACTER*4  CLS
      CHARACTER*12 FILE
      CHARACTER*20 BEGDAT,PRIDCO
      CHARACTER*77 WLBOX(16)
      CHARACTER*255 INPFILE
      CHARACTER*255 TEKFILE
C
      LOGICAL      FOUT  ,EX
C
C             *********************************
C             *       INITIALIZE              *
C             *********************************
C
C     CALL DATTIM(BEGDAT)
      BEGDAT = 'TODAY'
      PRIDCO = 'JET 3D     2.08 9712'
      CLS    = CHAR(27)//'[2J'
      JNIF   = 0
      FOUT   = .FALSE.
C
C-----SET FILE UNIT NUMBERS
C
      ISCR   =  11
      INUM   =  12
      IPR    =  16
      IREF   =  18
      IINP   =  19
C
C             *********************************
C             *   SET LOGO AND TEXT           *
C             *********************************
C
      WLBOX( 1)( 1:45)=''
      WLBOX( 2)( 1:45)='                                            '
      WLBOX( 3)( 1:45)='                    '
      WLBOX( 4)( 1:45)='                 '
      WLBOX( 5)( 1:45)='               '
      WLBOX( 6)( 1:45)='               '
      WLBOX( 7)( 1:45)='                  '
      WLBOX( 8)( 1:45)='                      '
      WLBOX( 9)( 1:45)='                            '
      WLBOX(10)( 1:45)='                                            '
      WLBOX(11)( 1:45)=' (C) copyright: DELFT HYDRAULICS, 1997      '
      WLBOX(12)( 1:45)='                PO Box  177                 '
      WLBOX(13)( 1:45)='                2600 MH  DELFT              '
      WLBOX(14)( 1:45)='                                            '
      WLBOX(15)( 1:45)='                                            '
      WLBOX(16)( 1:45)=''
      WLBOX( 1)(46:77)=''
      WLBOX( 2)(46:77)='                               '
      WLBOX( 3)(46:77)=' J E T 3 D          V   2.08   '
      WLBOX( 4)(46:77)='                               '
      WLBOX( 5)(46:77)=' A round buoyant jet with      '
      WLBOX( 6)(46:77)=' a 3-dimensional trajectory    '
      WLBOX( 7)(46:77)=' in an ambient flow            '
      WLBOX( 8)(46:77)='                               '
      WLBOX( 9)(46:77)=' Fortran 77                    '
      WLBOX(10)(46:77)='                               '
      WLBOX(11)(46:77)=' Division Estuaries & Seas     '
      WLBOX(12)(46:77)=' (C) copyright: D.A.G Delvigne '
      WLBOX(13)(46:77)=' tech. support: A.W.J. Koster  '
      WLBOX(14)(46:77)='                P. Koole       '
      WLBOX(15)(46:77)='                               '
      WLBOX(16)(46:77)=''
C
      WRITE(*,*) CLS
      WRITE(*  ,'(/,16(/2X,A77),/)') WLBOX
      WRITE(*  ,'(/,33X,''PROGRAM  START'')')
      WRITE(*  ,'(  31X,A20)'  ) BEGDAT
      WRITE(*  ,'(/,31X,A20,//)') PRIDCO
C
C-----------------------------------------------------------------------
C     OPEN FILES
C-----------------------------------------------------------------------
C
      jnif = 1
      call getarg (1, inpfile)
      if (inpfile == "") then
         open (iinp,file='jet3d.inp',status='old')
      else
         open (iinp,file=inpfile,status='old')
      end if
      
c      WRITE(*,'(  '' Do you use an existing input file  STR3DINP.'',
c     *            ''ext (Y/N)    : '',$)')
c      READ (*,'(A)') ANTW
c      IF (INDEX('Yy',ANTW) .GT. 0) THEN
c   10    CONTINUE
c         WRITE(*,'(  '' Give extension of this input file        '',
c     *               ''                : '',$)')
c         READ (*,'(A3)') EXT1
c         FILE = 'STR3DINP.' // EXT1
c         INQUIRE (FILE=FILE,EXIST=EX)
c         IF (EX) THEN
c            OPEN (IINP,FILE=FILE,STATUS='OLD',FORM='FORMATTED')
c            JNIF=1
c         ELSE
c            WRITE(*,'(  '' File does not exist, again (Y/N)      '',
c     *                  ''                   : '',$)')
c            READ (*,'(A)') ANTW
c            IF (INDEX('Yy',ANTW) .GT. 0) GOTO 10
c         ENDIF
c      ENDIF
C
      open (ipr,file='jet3d.ipr',status='replace')
      
c      WRITE(*,'(  '' Give extension for output file           STR'',
c     *            ''3DPRT.ext'')')
c      IF (JNIF.EQ.0) THEN
c         WRITE(*,'(  ''                    input file (next run) '',
c     *               ''STR3DINP.ext'')')
c      ENDIF
c      WRITE(*,'(  ''                    output data for plots STR'',
c     *            ''3DTEK.ext'')')
c      WRITE(*,'(  ''                    numerical file (opt)  STR'',
c     *            ''3DNUM.ext    : '',$)')
c      READ (*,'(A3)') EXT
cC
c      FILE = 'STR3DPRT.' // EXT
c      INQUIRE(FILE=FILE,EXIST=EX)
c      IF (EX) THEN
c         WRITE(*,'(/,'' ***ERROR - File '',A,'' does exist ***'')')
c     *                             FILE
c         FOUT = .TRUE.
c      ELSE
c         OPEN (IPR,FILE=FILE,FORM=  'FORMATTED',STATUS='NEW')
c      ENDIF
C
c      IF (JNIF.EQ.0) THEN
c         FILE = 'STR3DINP.' // EXT
c         INQUIRE(FILE=FILE,EXIST=EX)
c         IF (EX) THEN
c            WRITE(*,'(/,'' ***ERROR - File '',A,'' does exist ***'')')
c     *                                FILE
c            FOUT = .TRUE.
c         ELSE
c            OPEN (IINP,FILE=FILE,FORM='FORMATTED',STATUS='NEW')
c         ENDIF
c      ENDIF
C
      call getarg (2, tekfile)
      if (tekfile == "") then
         open (iref,file='jet3d.tek',status="replace")
      else
         open (iref,file=tekfile,status="replace")
      end if
      
c      FILE = 'STR3DTEK.' // EXT
c      INQUIRE(FILE=FILE,EXIST=EX)
c      IF (EX) THEN
c         WRITE(*,'(/,'' ***ERROR - File '',A,'' does exist ***'')')
c     *                             FILE
c         FOUT = .TRUE.
c      ELSE
c         OPEN (IREF,FILE=FILE,FORM=  'FORMATTED',STATUS='NEW')
c      ENDIF
C
      OPEN (ISCR,          FORM='UNFORMATTED',STATUS='SCRATCH')
C
c      IF (FOUT) GOTO 9999
C
C             *********************************
C             *   READ PROGRAM MODE           *
C             *********************************
C
      open (inum,file = 'jet3d.num',status='replace')
      
c      WRITE(*,'(  '' Would you save the numerical results on file'',
c     *            '' (Y/N)       : '',$)')
c      READ (*,'(A)') ANTW
c      IF (INDEX('Yy',ANTW) .GT. 0) THEN
c          IFILE  = 1
c          FILE   = 'STR3DNUM.' // EXT
c          INQUIRE(FILE=FILE,EXIST=EX)
c          IF (EX) THEN
c             WRITE(*,'(/,'' ***ERROR - File '',A,'' does exist ***'')')
c     *                                 FILE
c             FOUT = .TRUE.
c             GOTO 9999
c          ELSE
c              OPEN  (INUM,FILE=FILE,FORM=  'FORMATTED',STATUS='NEW')
c          ENDIF
c      ELSE
c          IFILE  = 0
c      ENDIF
C
      WRITE(*,*) CLS
C
      WRITE(IPR,'(/,1X,A20)') PRIDCO
      WRITE(IPR,'(/,1X,A20,/)') BEGDAT
C
c      IF (JNIF.EQ.1) THEN
c        WRITE(IPR,'('' Used input file name:'',/)')
c        WRITE(IPR,'(''      STR3DINP.'',A3,/ )') EXT1
c      ENDIF
c      WRITE(IPR,'('' Names of opened output files :'',/)')
c      WRITE(IPR,'(''      STR3DPRT.'',A3   )') EXT
c      WRITE(IPR,'(''      STR3DTEK.'',A3   )') EXT
c      IF (JNIF .EQ. 0) THEN
c        WRITE(IPR,'(''      STR3DINP.'',A3   )') EXT
c      ENDIF
c      IF (IFILE .EQ. 1) THEN
c         WRITE(IPR,'(''      STR3DNUM.'',A3   )') EXT
c      ENDIF
C
 9999 CONTINUE
      RETURN
C
      END
c     jet3d-intspl  , version  1.01,  1 April     1979, A. W. J. Koster
      SUBROUTINE INTSPL(YS, INT, Y, A, B, C, D, FS)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : INTERPOLATIE IN SPLINE S(Y)
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C
C     LIJST VAN PARAMETERS
C
C     NAAM SOORT  OMSCHRIJVING
C
C     YS    REAL   INPUTVARIABELE ;
C                  Y-WAARDE WAARVOOR IN DE SPLINE GEINTERPOLEERD WORDT
C     INT  INTEGER INPUTVARIABELE ;
C                  INTERVAL VOOR YS, ZODAT Y(INT)<YS<Y(INT+1)
C     Y     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  Y(I) IS DE ABSCIS VAN HET I-DE STEUNPUNT VAN DE
C                  SPLINE
C     A     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  A(I) IS DE KONSTANTE TERM VAN DE SPLINE IN HET I-DE
C                  INTERVAL
C     B     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  B(I) IS DE KOEFFICIENT VAN  Y VAN DE SPLINE IN HET
C                  I-DE INTERVAL
C     C     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  C(I) IS DE KOEFFICIENT VAN Y**2 VAN DE SPLINE IN HJET
C                  I-DE INTERVAL
C     D     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  D(I) IS DE KOEFFICIENT VAN Y**3 VAN DE SPLINE IN HET
C                  I-DE INTERVAL
C     FS    REAL   OUTPUTVARIABELE ;
C                  DE D.M.V. SPLINE-INTERPOLATIE BEPAALDE WAARDE S(YS)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION Y(*), A(*), B(*), C(*), D(*)
C
C     BEREKENEN VAN FS (M.B.V. HORNER-SCHEMA)
C
      DY=YS-Y(INT)
C
      FS=A(INT)+DY*(B(INT)+DY*(C(INT)+DY*D(INT)))
C
      RETURN
      END

c     jet3d-kontr   , version  2.02,  1 May       1979, A. W. J. Koster
      SUBROUTINE KONTR(EXT   ,YYMAX ,ZZMAX ,Y     ,NY    ,Z     ,
     *                 NZ    ,UTAB  ,UAP   ,UAT   ,RTAB  ,RHOAT ,
     *                 XL    ,YL    ,ZL    ,S0    ,X0    ,Y0    ,
     *                 Z0    ,C0    ,THETA0,PHI0  ,B0    ,U0    ,
     *                 RHO0  ,SMAX  ,N     ,MAXDER,H0    ,HMIN  ,
     *                 EPS   ,IFILE ,PRSTEP,IPR   ,MXY          )
C
C     WATERLOOPKUNDIG LABORATORIUM       AFDELING WILD
C
C     FUNKTIEOMSCHRIJVING    : KONTROLE-PRINTUITVOER
C     INGANG                 : SUBROUTINE-AANROEP
C     UITGANG                : TERUG NAAR AANROEPEND MODUUL
C     FOUTMELDING            : GEEN
C     LOGICAL UNITNUMMERS    : LUN= IPR  VOOR PRINTUITVOER
C     GEBRUIKTE SUBROUTINES  : PRTAB1
C                              PRTAB2
C
C LIJST VAN PARAMETERS:
C
C  NAAM   SOORT  LENGTE  COMMON  OMSCHRIJVING:
C  ----  ------  ------  ------  ------------
C   EXT     CHAR*3 1             AKTUELE REKENGEVAL
C   YYMAX   REAL   1             MAXIMALE WAARDE VOOR Y
C   ZZMAX   REAL   1             MAXIMALE WAARDE VOOR Z
C   Y       REAL   DYN.          AFSTANDEN VAN DE RESP.RIJEN TOT DE
C           ARRAY                OORSPRONG;
C                                Y(I) IS DE AFSTAND VAN DE I-DE RIJ TOT
C                                DE OORSPRONG.
C   NY      I      1             AANTAL RIJEN VAN HET NETWERK
C   Z       REAL   DYN.          AFSTANDEN VAN DE RESP. KOLOMMEN TOT DE
C           ARRAY                OORSPRONG;
C                                Z(I) IS DE AFSTAND VAN DE I-DE KOLOM
C                                TOT DE OORSPRONG
C   NZ      I      1             AANTAL KOLOMMEN VAN HET NETWERK
C   UTAB    I      1             KEUZEPARAMETER;
C                                =0 : UA IS KONSTANT
C                                =1 : UA = UA(Y)
C                                =2 : UA = UA(Y,Z)
C   UAP     REAL   DYN.          GETABELLEERDE SNELHEID UA(Y);
C           ARRAY                UAP(I) IS DE SNELHEID OP Y=Y(I)
C   UAT     REAL   MXY,*         GETABELLEERDE SNELHEID UA(Y,Z);
C           ARRAY                UAT(I,J) IS DE SNELHEID OP
C                                (Y,Z)=(Y(I),Z(J))
C   RTAB    I      1             KEUZEPARAMETER;
C                                =0 : RHOA IS KONSTANT
C                                =1 : RHOA=RHOA(Y)
C   RHOAT   REAL   DYN.          GETABELLEERDE DICHTHEID RHOA(T);
C           ARRAY                RHOAT(I) IS DE DICHTHEID VOOR Y=Y(I)
C   XL      REAL   1             X-COORDINAAT LOZINGSPUNT
C   YL      REAL   1             Y-COORDINAAT LOZINGSPUNT
C   ZL      REAL   1             Z-COORDINAAT LOZINGSPUNT
C   X0      R      1             BEGINVOORWAARDE VOOR X
C   Y0      R      1             BEGINVOORWAARDE VOOR Y
C   Z0      R      1             BEGINVOORWAARDE VOOR Z
C   S0      R      1             STARTPUNT VAN S OP DE BAAN
C   C0      R      1             BEGINVOORWAARDE VAN C
C THETA0    R      1             BEGINVOORWAARDE VAN THETA
C  PHI0     R      1             BEGINVOORWAARDE VAN  PHI
C   B0      R      1             BEGINVORRWAARDE VAN B
C   U0      R      1             BEGINVOORWAARDE VAN U
C   RHO0    R      1             DICHTHEID VAN DE STRAAL
C  SMAX     R      1             MAXIMALE WAARDE VOOR S
C   N       I      1             AANTAL VERGELIJKINGEN(ONBEKENDEN)
C MAXDER    I      1             MAXIMALE ORDE
C   H0      R      1             INITIELE STAPGROOTTE LANGS DE BAAN
C  HMIN     R      1             MINIMALE STAPGROOTTE LANGS DE BAAN
C  EPS      R      1             CRITERIUM VOOR DE MAXIMALE FOUT
C  IFILE    I      1             UITVOERINDIKATOR
C COSCOS    I      1             INDICATOR ENTRAINMENTVGL.
C PRSTEP    R      1             PRINTSTAP VOOR S
C  ALMOM    R      1        *    MEESLEURKOEFFICIENT VOOR STRALEN
C  ALTH     R      1        *    MEESLEURKOEFFICIENT VOOR "THERMALS"
C   UA      R      1        *    KONSTANTE SNELHEID VAN HET ONTVANGENDE
C                                MEDIUM
C   CD      R      1        *    "DRAG"-KOEFFICIENT
C   G       R      1        *    VERSNELLING VAN DE ZWAARTEKRACHT
C  IPR      I      1             UNIT NUMMER VOOR PRINT UITVOER
C  MXY      I      1        *    1E INDEX UAT- ARRAY
C**********************************************************************
C
C DECLARATIES EN SPECIFIKATIES
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER      COSCOS    ,UTAB   ,RTAB
      REAL*8       LABDA
      CHARACTER*3  EXT
C
      DIMENSION   UAT (MXY,*),UAP (*),RHOAT (*),Y (*),Z (*)
      COMMON/VAST/UA        ,ALMOM  ,ALTH     ,CD   ,G    ,RHOA  ,
     *            PI         ,LABDA    ,DUADY,DUADZ,DRHODY,COSCOS
C
C AFDRUKKEN BEGIN NIEUWE PAGINA
C
      WRITE(IPR,'(/,'' Initial input:''  )')
      WRITE(IPR,'(  '' --------------'',/)')
C
C AFDRUKKEN VAN HET AKTUELE REKENGEVAL:
C
      WRITE(IPR,'('' Case: '',A3,/)') EXT
C
C AFDRUKKEN VAN MAXIMALE WAARDEN VOOR Y EN Z
C
      WRITE(IPR,'('' Y-Maximum  = '',F10.2)'  ) ZZMAX
      WRITE(IPR,'('' Z-Maximum  = '',F10.2)'  ) YYMAX
      WRITE(IPR,'('' LABDA      = '',F10.2,/)') LABDA
C
C AFDRUKKEN VAN DE SNELHEID VOOR VERSCHILLENDE GEVALLEN
C
      IF (UTAB .EQ. 0) THEN
         WRITE(IPR,'('' Velocity UA is constant;  UA   = '',F10.3,/)')
     *                                            UA
      ELSE IF (UTAB .EQ. 1) THEN
         WRITE(IPR,'('' Tabel for velocity  UA(Z)'',/)')
         WRITE(IPR,'(15X,''   Z    Velocity'')')
         CALL PRTAB1(Y     ,UAP   ,NY    ,IPR   )
C
      ELSE IF (UTAB .EQ. 2) THEN
         CALL PRTAB2(Y     ,NY    ,Z     ,NZ    ,UAT   ,IPR   ,MXY )
C
      ENDIF
C
C AFDRUKKEN VAN DE DICHTHEID VOOR VERSCHILLENDE GEVALLEN
C
      IF (RTAB .EQ. 0) THEN
         WRITE(IPR,'(/,'' Density RHOA is constant; RHOA = '',
     *                 F10.3,/)') RHOA
      ELSE IF (RTAB .EQ. 1) THEN
         WRITE(IPR,'(/,'' Tabel for density RHOA(Z)'',/)')
         WRITE(IPR,'(15X,''   Z     Density '')')
         CALL PRTAB1(Y     ,RHOAT ,NY    ,IPR   )
C
      ENDIF
C
      WRITE(IPR,'(/,'' Constant parameters: '',/)')
C
C AFDRUKKEN VAN DE KONSTANTEN IN DE DIFFERENTIAALVERGELIJKINGEN:
C
      WRITE(IPR,'('' ALMOM      = '',E10.3)'  ) ALMOM
      WRITE(IPR,'('' ALTH       = '',E10.3)'  ) ALTH
      WRITE(IPR,'('' CD         = '',E10.3)'  ) CD
      WRITE(IPR,'('' G          = '',E10.3,/)') G
C
C AFDRUKKEN LIGGING LOZINGSPUNT
C
      WRITE(IPR,'('' Location of Discharge: '')')
      WRITE(IPR,'(''   X        = '',F10.3)'  ) XL
      WRITE(IPR,'(''   Y        = '',F10.3)'  ) ZL
      WRITE(IPR,'(''   Z        = '',F10.3,/)') YL
C
C AFDRUKKEN VAN HET STARTPUNT VAN S OP DE BAAN:
C
      WRITE(IPR,'('' Start conditions for S  = '',F10.3,/)') S0
C
C AFDRUKKEN VAN DE BEGINVOORWAARDEN:
C
      BR0 = 2.0*B0
C
      WRITE(IPR,'('' X0         = '',F10.3)'  ) X0
      WRITE(IPR,'('' Y0         = '',F10.3)'  ) Z0
      WRITE(IPR,'('' Z0         = '',F10.3)'  ) Y0
      WRITE(IPR,'('' C0         = '',E10.3)'  ) C0
      WRITE(IPR,'('' THETA0     = '',F10.3)'  ) THETA0
      WRITE(IPR,'('' PHI0       = '',F10.3)'  ) PHI0
      WRITE(IPR,'('' BR0        = '',E10.3)'  ) BR0
      WRITE(IPR,'('' U0         = '',E10.3)'  ) U0
      WRITE(IPR,'('' RHO0       = '',F10.2,/)') RHO0
C
C AFDRUKKEN VAN DE OVERIGE PARAMETERS:
C
      WRITE(IPR,'('' Maximal value for S     = '',F10.3)'  ) SMAX
      WRITE(IPR,'('' Initial step size       = '',E10.3)'  ) H0
      WRITE(IPR,'('' Minimal step size       = '',E10.3)'  ) HMIN
      WRITE(IPR,'('' Maximal Error condition = '',E10.3,/)') EPS
C
      WRITE(IPR,'('' Number of equations     = '',I10)'    ) N
      WRITE(IPR,'('' Maximal order           = '',I10,/)'  ) MAXDER
C
      WRITE(IPR,'('' Print step              = '',E10.3,/)') PRSTEP
C
C NUMERIEKE PROCESGEGEVENS NAAR SCHIJF:
C
      IF (IFILE .EQ. 1) THEN
         WRITE(IPR,'('' Numerical information written on file '',
     *               '' STR3DNUM.'',A3,/)') EXT
      ENDIF
C
C COSCOS hard op 1
C
C     IF (COSCOS .EQ. 0) THEN
C        WRITE(IPR,'('' No COSINE-term in entrainment '',
C    *               ''equation'',/)')
C     ELSE IF (COSCOS .EQ. 1) THEN
C        WRITE(IPR,'('' COSINE-term in entrainment equation'',/)')
C     ENDIF
C
      RETURN
      END
c     jet3d-kospl1  , version  0.00,  1 July      1978, A. W. J. Koster
      SUBROUTINE KOSPL1(X, F, N1, N2, A, B, C, D)
C
C     DEZE SUBROUTINE BEREKENT DE KOEFFICIENTEN VAN EEN NATUURLIJKE
C     SPLINE-FUNKTIE
C     WILD LIBRARY NUMMER SP 056
C     WATERLOOPKUNDIG LABORATORIUM AFDELING WILD
C     INGANG           SUBROUTINE AANROEP
C     UITGANG          TERUG NAAR AANROEPENDE MODUUL
C     PARAMETERS SOORT     LENGTE    I O T OMSCHRIJVING
C     X         REAL ARRAY DYNAMISCH *     ABSCISSEN DER GEGEVEN PUNTEN
C     F         REAL ARRAY DYNAMISCH *     ORDINATEN DER GEGEVEN PUNTEN
C     N1        INTEGER    -         *     INDEX VAN HET BEGINPUNT
C     N2        INTEGER    -         *     INDEX VAN HET EINDPUNT
C     A         REAL ARRAY DYNAMISCH   *   KONSTANTE TERM IN DE SPLINE
C     B         REAL ARRAY DYNAMISCH   *   KOEFFICIENT VAN X IN SPLINE
C     C         REAL ARRAY DYNAMISCH   *   KOEFFICIENT VAN X**2
C     D         REAL ARRAY DYNAMISCH   *   KOEFFICIENT VAN X**3
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION A(*), B(*), C(*), D(*), X(*), F(*)
C
      M1=N1+1
      M2=N2-1
      S=0.0
      DO 10 I=N1,M2
      D(I)=X(I+1)-X(I)
      R=(F(I+1)-F(I))/D(I)
      C(I)=R-S
      S=R
   10 CONTINUE
      S=0.0
      R=0.0
      C(N1)=0.0
      C(N2)=0.0
      DO 20 I=M1,M2
      C(I)=C(I)+R*C(I-1)
      B(I)=(X(I-1)-X(I+1))*2.0-R*S
      S=D(I)
      R=S/B(I)
   20 CONTINUE
      MM=M2-M1+1
      DO 30 K=1,MM
      I=M2+1-K
      C(I)=(D(I)*C(I+1)-C(I))/B(I)
   30 CONTINUE
      DO 40 I=N1,M2
      S=D(I)
      R=C(I+1)-C(I)
      D(I)=R/S
      C(I)=C(I)*3.0
      B(I)=(F(I+1)-F(I))/S-(C(I)+R)*S
      A(I)=F(I)
   40 CONTINUE
C
      RETURN
      END
c     jet3d-leespc  , version  2.05,  1 July      1991, Heleen Leepel
      SUBROUTINE LEES(YYMAX ,ZZMAX ,NY    ,NZ    ,UTAB  ,UAP   ,
     *                UAT   ,RTAB  ,RHOAT ,XL    ,YL    ,ZL    ,
     *                S0    ,C0    ,THETA0,PHI0  ,B0    ,U0    ,
     *                RHO0  ,SMAX  ,H0    ,HMIN  ,EPS   ,PRSTEP,
     *                JNIF  ,IINP  ,MXY                        )
C
C     WATERLOOPKUNDIG LABORATORIUM     AFDELING WILD
C
C     FUNKTIEOMSCHRIJVING    : INLEZEN VAN INVOER RECORDS
C     INGANG                 : SUBROUTINE-AANROEP
C     UITGANG                : TERUG NAAR AANROEPEND MODUUL
C     FOUTMELDING            : GEEN
C     LOGICAL UNITNUMMERS    : LUN= *    - INVOER DATA RECORDS (SCHERM)
C                                   IINP - INVOER FILE
C
C LIJST VAN PARAMETERS:
C
C  NAAM   SOORT  LENGTE  COMMON  OMSCHRIJVING:
C  ----  ------  ------  ------  ------------
C   YYMAX   R      1             MAXIMALE WAARDE VOOR Y
C   ZZMAX   R      1             MAXIMALE WAARDE VOOR Z
C   NY      I      1             AANTAL RIJEN VAN HET NETWERK
C   NZ      I      1             AANTAL KOLOMMEN VAN HET NETWERK
C   UA      R      1         *   KONSTANTE SNELHEID VAN HET ONTVANGENDE
C                                MEDIUM
C   UTAB    I      1             KEUZEPARAMETER;
C                                =0 : UA IS KONSTANT
C                                =1 : UA = UA(Y)
C                                =2 : UA = UA(Y,Z)
C   UAP     REAL   NY            GETABELLEERDE SNELHEID UA(Y);
C           ARRAY                UAP(I) IS DE SNELHEID OP Y=Y(I)
C   UAT     REAL   MXY,*         GETABELLEERDE SNELHEID UA(Y,Z);
C           ARRAY                UAT(I,J) IS DE SNELHEID OP
C                                (Y,Z)=(Y(I),Z(J))
C   RHOA    R      1         *   DICHTHEID VAN HET MEDIUM IN EEN SITUA-
C                                TIE WAAR DE DICHTHEID HOMOGEEN VERDEELD
C                                IS
C   RTAB    I      1             KEUZEPARAMETER;
C                                =0 : RHOA IS CONSTANT
C                                =1 : RHOA = RHOA(Y)
C   RHOAT   REAL   NY            GETABELLEERDE DICHTHEID RHOA(Y);
C           ARRAY                RHOAT(I) IS DE DICHTHEID VOOR Y=Y(I)
C   XL      R      1             X-COORDINAAT LOZINGSPUNT
C   YL      R      1             Y-COORDINAAT LOZINGSPUNT
C   ZL      R      1             Z-COORDINAAT LOZINGSPUNT
C   S0      R      1             STARTPUNT VAN S OP DE BAAN
C   C0      R      1             BEGINVOORWAARDE VAN C
C THETA0    R      1             BEGINVOORWAARDE VAN THETA
C  PHI0     R      1             BEGINVOORWAARDE VAN  PHI

C   B0      R      1             BEGINVORRWAARDE VAN B
C   U0      R      1             BEGINVOORWAARDE VAN U
C   RHO0    R      1             BEGINVOORWAARDE VAN RHO
C  SMAX     R      1             MAXIMALE WAARDE VOOR S
C   H0      R      1             INITIELE STAPGROOTTE LANGS DE BAAN
C  HMIN     R      1             MINIMALE STAPGROOTTE LANGS DE BAAN
C  EPS      R      1             CRITERIUM VOOR DE MAXIMALE FOUT
C COSCOS    I      1         *   INDICATOR ENTRAINMENTVERGELIJKING
C PRSTEP    R      1             PRINTSTAP VOOR S
C  ALMOM    R      1        *    MEESLEURKOEFFICIENT VOOR STRALEN
C  ALTH     R      1        *    MEESLEURKOEFFICIENT VOOR "THERMALS"
C   CD      R      1        *    "DRAG"-KOEFFICIENT
C   G       R      1        *    VERSNELLING VAN DE ZWAARTEKRACHT
C JNIF      I      1             INDICATOR J/N (1/0) LEZEN VAN INPUT FILE
C IINP      I      1             LUN INPUT FILE (READ OR WRITE)
C MXY       I      1             1E INDEX UAT- ARRAY
C**********************************************************************
C
C DECLARATIES EN SPECIFICATIES
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER     COSCOS,UTAB  ,RTAB
      REAL*8      LABDA
      CHARACTER*1 ANTW
      CHARACTER*4 CLS
C
      DIMENSION   UAT    (MXY,*),UAP(*),RHOAT(*)
C
      COMMON/VAST/UA    ,ALMOM ,ALTH  ,CD    ,G     ,RHOA  ,
     *            PI    ,LABDA ,DUADY ,DUADZ ,DRHODY,COSCOS
C
C  INITIALISATIE
C
      CLS    = CHAR(27)//'[2J'
      WRITE(*,*) CLS
C
C  INLEZEN VAN MAXIMALE WAARDEN VOOR Y EN Z
C     := RECORD  1
C
      IF (JNIF.EQ.0) THEN
         WRITE(*,'(/,'' Input parameters:'')')
         WRITE(*,'(  '' -----------------'')')
         WRITE(*,'(/,'' YYMAX  maximum value for Y                  '',
     *               ''             : '',$)')
         READ (*,*) ZZMAX
         WRITE(*,'(  '' ZZMAX  maximum value for Z                  '',
     *               ''             : '',$)')
         READ (*,*) YYMAX
         WRITE(IINP,'(2F10.2,20X,A12)') ZZMAX,YYMAX,'YYMAX ,ZZMAX'
      ELSE
         READ (IINP,'(2F10.0)') ZZMAX,YYMAX
      ENDIF
C
C  INLEZEN VAN KEUZEPARAMETER UTAB
C     := RECORD  3
C
      IF (JNIF.EQ.0) THEN
         WRITE(*,'(/,'' UTAB   uniform velocity Ua of the ambient fl'',
     *               ''ow (Y/N)     : '',$)')
         READ (*,'(A)') ANTW
C
C INLEZEN VAN SNELHEID UA, UA(Y) C.Q. UA(Y,Z)
C     := RECORD  4 EN VOLGENDE
C
         IF (INDEX('Yy',ANTW) .GT. 0) THEN
            UTAB = 0
            WRITE(*,'(  '' UA     uniform velocity distribution     '',
     *                  ''                : '',$)')
            READ (*,*) UA
            WRITE(IINP,'(I5,35X,A4)') UTAB,'UTAB'
            WRITE(IINP,'(F10.3 )') UA
         ELSE
            WRITE(*,'(  '' NY   number of table values in Y- directi'',
     *                  ''on'')')
            WRITE(*,'(  ''       either  NY = 0   or   2 <= NY <= 21'',
     *                  ''                : '',$)')
            READ (*,*) NZ
            IF (NZ .EQ. 0) THEN
               UTAB = 1
               WRITE(*,'(  '' NZ  number of values in Z- direction'')')
               WRITE(*,'(  ''      3 <= NZ <= 21                    '',
     *                     ''                   : '',$)')
               READ (*,*) NY
               WRITE(*,'(  '' UAP    non-uniform velocity distributi'',
     *                     ''on                 : '')')
               READ (*,*) (UAP (I),I=1,NY)
               WRITE(IINP,'(3I5,25X,A16)')  UTAB  ,NY    ,NZ,
     *                                     'UTAB  ,NZ    ,NY'
               WRITE(IINP,'(8F10.3 )') (UAP(I),I=1,NY)
            ELSE
               UTAB = 2
               WRITE(*,'(  '' NZ  number of values in Z- direction'')')
               WRITE(*,'(  ''      2 <= NZ <= 21                    '',
     *                     ''                   : '',$)')
               READ (*,*) NY
               WRITE(*,'(  '' UAT    2- dimensional velocity table'')')
               WRITE(*,'(  '' per Y- point vertical velocity profile'',
     *                     ''                   : '')')
               WRITE(IINP,'(3I5,25X,A16)')  UTAB  ,NY    ,NZ,
     *                                     'UTAB  ,NZ    ,NY'
               DO 60 J=1,NZ
                  WRITE(*,'('' IY = '',I3,'' : '',$)') J
                  READ (*,*) (UAT (I,J),I=1,NY)
                  WRITE(IINP,'(8F10.3)') (UAT(I,J),I=1,NY)
   60          CONTINUE
            ENDIF
         ENDIF
      ELSE
         READ (IINP,'(3I5)') UTAB,NY,NZ
         IF (UTAB.EQ.0) THEN
            READ (IINP,'(F10.0)') UA
         ELSE IF (UTAB.EQ.1) THEN
            READ (IINP,'(8F10.0)') (UAP(I),I=1,NY)
         ELSE
            DO 61 J=1,NZ
               READ (IINP,'(8F10.0)') (UAT(I,J),I=1,NY)
   61       CONTINUE
         ENDIF
      ENDIF
C
C INLEZEN VAN KEUZEPARAMETER RTAB
C      := RECORD  3
C
      IF (JNIF.EQ.0) THEN
         WRITE(*,'(/,'' RTAB   homogeneous density RHOa of the ambie'',
     *               ''nt flow (Y/N): '',$)')
         READ (*,'(A)') ANTW
C
C INLEZEN VAN DICHTHEID RHOA C.Q. RHOA(Y)
C     := RECORD  5 EN VOLGENDE
C
         IF (INDEX('Yy',ANTW) .GT. 0) THEN
            RTAB = 0
            WRITE(*,'(  '' RHOA   homogeneous density               '',
     *                  ''                : '',$)')
            READ (*,*) RHOA
            WRITE(IINP,'(I5,35X,A4)') RTAB,'RTAB'
            WRITE(IINP,'(F10.2 )') RHOA
         ELSE
            RTAB = 1
            IF (UTAB.EQ.0) THEN
               WRITE(*,'(  '' NZ   number of table values in Z- dire'',
     *                     ''ction'')')
               WRITE(*,'(  ''           3 <= NZ <= 21               '',
     *                     ''                   : '',$)')
               READ (*,*) NY
            ELSE
               WRITE(*,'('' number of table values NZ = '',I3)') NY
            ENDIF
            WRITE(*,'(  '' RHOAT  non-homogeneous density distributi'',
     *                  ''on              : '')')
            READ (*,*) (RHOAT (I),I=1,NY)
            WRITE(IINP,'(2I5,30X,A9)') RTAB,NY,'RTAB  ,NZ'
            WRITE(IINP,'(8F10.2 )') (RHOAT(I),I=1,NY)
         ENDIF
      ELSE
         READ (IINP,'(2I5)') RTAB,NYR
         IF (RTAB.EQ.0) THEN
            READ (IINP,'(F10.0)') RHOA
         ELSE
            IF (NY.EQ.0 .OR. NY.GT.NYR) NY = NYR
            READ (IINP,'(8F10.0)') (RHOAT(I),I=1,NYR)
         ENDIF
      ENDIF
C
C INLEZEN VAN LIGGING LOZINGSPUNT
C     := RECORD  7
C
      IF (JNIF.EQ.0) THEN
         WRITE(*,'(/,'' Location of the real discharge point'')')
         WRITE(*,'(  '' XL     x-coordinate discharge point         '',
     *               ''             : '',$)')
         READ (*,*) XL
         WRITE(*,'(  '' YL     y-coordinate discharge point (YL >= 0'',
     *               '')            : '',$)')
         READ (*,*) ZL
         WRITE(*,'(  '' ZL     z-coordinate discharge point (ZL >= 0'',
     *               '')            : '',$)')
         READ (*,*) YL
         WRITE(IINP,'(3F10.3,10X,A16)') XL,ZL,YL,'XL    ,YL    ,ZL'
C
C INLEZEN VAN HET STARTPUNT VOOR S OP DE BAAN
C     := RECORD  8
C
         WRITE(*,'(/,'' S0     S-coordinate for the start point of t'',
     *               ''he jet''  )')
         WRITE(*,'(  ''        trajectory calculation'')')
         WRITE(*,'(  ''        (end of zone of flow establisment)   '',
     *               ''             : '',$)')
         READ (*,*) S0
         WRITE(IINP,'(F10.3,30X,A2)') S0,'S0'
      ELSE
         READ (IINP,'(3F10.0)') XL,ZL,YL
         READ (IINP,'( F10.0)') S0
      ENDIF
C
C INLEZEN VAN DE BEGINVOORWAARDEN:
C     := RECORD  9
C
      IF (JNIF.EQ.0) THEN
         WRITE(*,'(/,'' C0     initial condition for concentration i'',
     *               ''n jet axis   : '',$)')
         READ (*,*) C0
         WRITE(*,'(  '' THETA0 initial condition of  in degrees'')')
         WRITE(*,'(  ''          0 <= THETA0 <= 180                 '',
     *               ''             : '',$)')
         READ (*,*) THETA0
         WRITE(*,'(  '' PHI0   initial condition of  in degrees'')')
         WRITE(*,'(  ''        -90 <  PHI0   <   90                 '',
     *               ''             : '',$)')
         READ (*,*) PHI0
         WRITE(*,'(/,'' BR0    initial condition of jet width BR    '',
     *               ''             : '',$)')
         READ (*,*) BR0
         WRITE(*,'(  '' U0     initial condition of velocity U in th'',
     *               ''e jet axis   : '',$)')
         READ (*,*) U0
         WRITE(*,'(  '' RHO0   initial condition of density RHO in t'',
     *               ''he jet axis  : '',$)')
         READ (*,*) RHO0
         WRITE(IINP,'(3F10.3,10X,A18)')  C0    ,THETA0,PHI0,
     *                                  'C0    ,THETA0,PHI0'
         WRITE(IINP,'(3F10.3,10X,A18)')  BR0   ,U0    ,RHO0,
     *                                  'BR0   ,U0    ,RHO0'
C
C INLEZEN VAN DE MAXIMALE WAARDE S EN DE PRINTSTAP
C     := RECORD 10
C
         WRITE(*,'(/,'' SMAX   maximum value of S in the calculation'',
     *               ''             : '',$)')
         READ (*,*) SMAX
         WRITE(*,'(  '' PRSTEP print step for S along the trajectory'',
     *               ''             : '',$)')
         READ (*,*) PRSTEP
         WRITE(IINP,'(2F10.3,20X,A13)') SMAX,PRSTEP,'SMAX  ,PRSTEP'
      ELSE
         READ (IINP,*) C0 ,THETA0,PHI0
         READ (IINP,*) BR0,U0    ,RHO0
         READ (IINP,*) SMAX,PRSTEP
      ENDIF
      B0 = 0.5*BR0
C
C WEGSCHRIJVEN 'STANDAARD' PARAMETERS IVM EVENTUELE WIJZIGINGEN
C
C ==> CIRKELEN ZOLANG IWIJZ .NE. 0
C
  100 CONTINUE
         WRITE(*,*) CLS
         WRITE(*,'(/,'' List of standard parameters'')')
         WRITE(*,'(/,'' Name   Parameter description                '',
     *               ''                    Value   Number'')')
         WRITE(*,'(/,'' LAMBDA tuning parameter in the system diff. '',
     *               ''equations    : '',F10.3,''        1'')') LABDA
         WRITE(*,'(  '' ALMOM  entrainment coefficient for "momentum'',
     *               '' jet"        : '',F10.3,''        2'')') ALMOM
         WRITE(*,'(  '' ALTH   entrainment coefficient for "thermal '',
     *               ''jet"         : '',F10.3,''        3'')') ALTH
         WRITE(*,'(  '' CD     drag-coefficient                     '',
     *               ''             : '',F10.3,''        4'')') CD
         WRITE(*,'(  '' G      acceleration of gravity              '',
     *               ''             : '',F10.3,''        5'')') G
         WRITE(*,'(  '' H0     initial step size                    '',
     *               ''             : '',E10.3,''        6'')') H0
         WRITE(*,'(  '' HMIN   minimum step size                    '',
     *               ''             : '',E10.3,''        7'')') HMIN
         WRITE(*,'(  '' EPS    criterion for maximum local solution '',
     *               ''error        : '',E10.3,''        8'')') EPS
         WRITE(*,'(/,'' Give parameter number to change  (0=no chang'',
     *               ''es)          : '',$)')
c         READ (*,*) IWIJZ
      iwijz = 0
C
C TEST IWIJZ VOOR OPTIONELE VERANDERINGEN
C
         IF (IWIJZ .EQ. 1) THEN
            WRITE(*,'(/,'' LAMBDA tuning parameter in the system dif'',
     *                  ''f. equations    : '',$)')
            READ (*,*) LABDA
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 2) THEN
            WRITE(*,'(/,'' ALMOM  entrainment coefficient for "momen'',
     *                  ''tum jet"        : '',$)')
            READ (*,*) ALMOM
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 3) THEN
            WRITE(*,'(/,'' ALTH   entrainment coefficient for "therm'',
     *                  ''al jet"         : '',$)')
            READ (*,*) ALTH
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 4) THEN
            WRITE(*,'(/,'' CD     drag-coefficient                  '',
     *                  ''                : '',$)')
            READ (*,*) CD
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 5) THEN
            WRITE(*,'(/,'' G      acceleration of gravity           '',
     *                  ''                : '',$)')
            READ (*,*) G
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 6) THEN
            WRITE(*,'(/,'' H0     initial step size                 '',
     *                  ''                : '',$)')
            READ (*,*) H0
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 7) THEN
            WRITE(*,'(/,'' HMIN   minimum step size                 '',
     *                  ''                : '',$)')
            READ (*,*) HMIN
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .EQ. 8) THEN
            WRITE(*,'(/,'' EPS    criterion for maximum local soluti'',
     *                  ''on error        : '',$)')
            READ (*,*) EPS
C
C <==
C
      GO TO 100
C
         ELSE IF (IWIJZ .NE. 0) THEN
C
C <==
C
      GO TO 100
C
C EINDE VAN OPTIONELE PARAMETERS
C
         ENDIF
C
      RETURN
      END
c     jet3d-prtab1  , version  1.01,  1 April     1979, A. W. J. Koster
      SUBROUTINE PRTAB1(Y     ,F     ,NY    ,IPR   )
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : PRINTEN VAN EEN 1-DIMENSIONALE TABEL
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C     LOGICAL
C     UNITNUMBER   : LUN = IPR VOOR PRINTUITVOER
C
C     LIJST VAN PARAMETERS
C
C     NAAM  SOORT  OMSCHRIJVING
C
C     Y     REAL   INPUTVEKTOR VAN LENGTE N ;
C                  Y(I) IS DE ABSCIS VAN DE I-DE TABELWAARDE
C     F     REAL   INPUTVEKTOR VAN LENGTE N ;
C                  F(I) IS DE I-DE TABELWAARDE
C     NY   INTEGER INPUTVARIABELE ;
C                  AANTAL TABELWAARDEN
C     IPR  INTEGER UNIT NUMMER PRINT IUTVOER
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION       Y(*), F(*)
C
C     PRINTEN VAN DE TABEL ( VAN BOVEN NAAR BENEDEN )
C
      DO 10 I= 1,NY
         J   = NY + 1 - I
         WRITE(IPR,'('' '',I10,2F10.2)') J, Y (J), F (J)
   10 CONTINUE
C
      RETURN
      END
c     jet3d-prtab2  , version  1.01,  1 April     1979, A. W. J. Koster
      SUBROUTINE PRTAB2(Y     ,NY    ,Z     ,NZ    ,UAT   ,IPR   ,MXY)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : PRINTEN VAN EEN 2-DIMENSIONALE TABEL VOOR UA
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C     LOGICAL
C     UNITNUMBER   : LUN = IPR VOOR PRINTUITVOER
C
C     LIJST VAN PARAMETERS
C
C     NAAM  SOORT  OMSCHRIJVING
C
C     Y     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  Y(I) IS DE AFSTAND VAN DE I-DE RIJ TOT DE OORSPRONG
C     NY   INTEGER INPUTVARIABELE ;
C                  AANTAL RIJEN IN HET NETWERK
C     Z     REAL   INPUTVECTOR VAN LENGTE NZ ;
C                  Z(I) IS DE AFSTAND VAN DE I-DE KOLOM TOT DE OORSPRONG
C     NZ   INTEGER INPUTVARIABELE ;
C                  AANTAL KOLOMMEN IN HET NETWERK
C     UAT   REAL   NY * NZ INPUTMATRIX ;
C                  UAT(I,J) IS DE SNELHEID VAN HET MEDIUM IN HET PUNT
C                  (Y(I),Z(J))
C     IPR  INTEGER UNIT NUMMER VOOR PRINT UITVOER
C     MXY  INTEGER 1E INDEX UAT- ARRAY
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION UAT(MXY,*), Y(*), Z(*),IKOL (10)
C
C     FORMEREN VAN EEN ARRAY T.B.V. KOLOMNUMMERING
C
      DO 10 I=1,NZ
         IKOL (I) = I
   10 CONTINUE
C
      WRITE(IPR,'('' TABEL FOR UA (Z,Y)'',/)')
      WRITE(IPR,'(20X,8I7  /(21X,8I7  ),/)'   ) (IKOL (   J),J=1,NZ)
      WRITE(IPR,'(20X,8F7.3/(21X,8F7.3),/)'   ) (Z    (   J),J=1,NZ)
C
C     PRINTEN VAN DE 2-DIMENSIONALE TABEL, VAN BOVEN NAAR BENEDEN
C
      DO 20 I= 1,NY
         II  = NY + 1 - I
         WRITE(IPR,'(1X,I6,2X,F6.2,6X,8F7.3/(21X,8F7.3),/)')
     *                               II ,Y (II) ,(UAT  (II,J),J=1,NZ)
   20 CONTINUE
C
      RETURN
      END
c     jet3d-reset   , version  1.01,  1 July      1979, A. W. J. Koster
      SUBROUTINE RESET(ISTEP, H)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE                : RESETTEN VAN ENKELE PARAMETERS
C                            : I.G.V. FOUTMELDING SUBROUTINE DVOGER
C     INGANG                 : SUBROUTINE-AANROEP
C     UITGANG                : TERUG NAAR AANROEPEND MODUUL
C     GEBRUIKTE SUBROUTINES  : GEEN
C
C     LIJST VAN PARAMETERS
C
C     NAAM         SOORT  I O T LENGTE  COMMON  OMSCHRIJVING
C
C     ISTEP       INTEGER     *    1       -    STAPPENTELLER
C     H           REAL        *    1       -    STAPGROOTTE
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      H=H/100.
      ISTEP=ISTEP-1
C
      RETURN
      END
c     jet3d-rhoa1   , version  1.01,  1 April     1979, A. W. J. Koster
      SUBROUTINE RHOA1(YS, INT, Y, A, B, C, D)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : BEPALEN VAN DE DICHTHEID RHOA VOOR HET GEVAL
C                    RHOA=RHOA(Y)
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C     GEBRUIKTE
C     SUBROUTINES  : INTSPL
C
C     LIJST VAN PARAMETERS
C
C     NAAM SOORT  OMSCHRIJVING
C
C     YS    REAL   INPUTVARIABELE ;
C                  Y-WAARDE WAARVOOR DE DICHTHEID RHOA WORDT BEREKEND
C     INT  INTEGER INPUTVARIABELE ;
C                  Y-INTERVAL WAAR YS IN LIGT, ZO DAT Y(INT)<YS<Y(INT+1)
C     Y     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  Y(I) IS DE ABSCIS VAN HET I-DE STEUNPUNT VAN DE
C                  SPLINE
C     A     REAL   INPUTVECTOR VAN LENGTE NY ;
C                  A(I) IS DE KONSTANTE TERM VAN DE SPLINE VOOR HET
C                  I-DE INTERVAL
C     B     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  B(I) IS DE KOEFFICIENT VAN Y VAN DE SPLINE VOOR HET
C                  I-DE INTERVAL
C     C     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  C(I) IS DE KOEFFICIENT VAN Y**2 VAN DE SPLINE VOOR
C                  HET I-DE INTERVAL
C     D     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  D(I) IS DE KOEFFICIENT VAN Y**3 VAN DE SPLINE VOOR
C                  HET I-DE INTERVAL
C     RHOA  REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE M.B.V. SPLINE-INTERPOLATIE BEPAALDE DICHTHEID
C                  RHOA(YS)
C    DRHODY REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE AFGELEIDE DRHOA/DY VAN RHOA(Y)
C
C     EXPLICIETE TYPE-DEFINIERING VAN VARIABELEN
C     VASTLEGGEN VAN COMMON-GEBIED
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER COSCOS
      REAL*8  LABDA
C
      COMMON /VAST/     UA, ALMOM,  ALTH,    CD,     G,  RHOA,    PI,
     *              LABDA, DUADY, DUADZ,DRHODY,COSCOS
C
C
      DIMENSION Y(*), A(*), B(*), C(*), D(*)
C
C     BEREKENEN VAN RHOA(YS) D.M.V. SPLINE-INTERPOLATIE
C
      CALL INTSPL(YS, INT, Y, A, B, C, D, RHOA)
C
C     INTERPOLEREN IN AFGELEIDE SPLINE TER BEREKENING VAN DRHOA/DY
C     (M.B.V. HORNER- SCHEMA)
C
      YY    =YS-Y(INT)
      DRHODY=B(INT)+YY*(2.*C(INT)+3.*YY*D(INT))
C
      RETURN
      END
c     jet3d-ua1     , version  1.01,  1 April     1979, A. W. J. Koster
      SUBROUTINE UA1(YS, INT, Y, A, B, C, D)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : BEPALEN VAN SNELHEID UA EN AFGELEIDE DUA/DY VOOR
C                    HET GEVAL UA=UA(Y)
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C     GEBRUIKTE
C     SUBROUTINES  : INTSPL
C
C     LIJST VAN PARAMETERS
C
C     NAAM SOORT  OMSCHRIJVING
C
C     YS    REAL   INPUTVARIABELE ;
C                  Y-WAARDE WAARVOOR DE SNELHEID UA EN DE AFGELEIDE
C                  DUA/DY WORDT BEREKEND
C     INT  INTEGER INPUTVARIABELE ;
C                  Y-INTERVAL WAAR YS IN LIGT, ZO DAT Y(INT)<YS<Y(INT+1)
C     Y     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  Y(I) IS DE ABSCIS VAN HET I-DE STEUNPUNT VAN DE
C                  SPLINE
C     A    REAL    INPUTVEKTOR VAN LENGTE NY ;
C                  A(I) IS DE KONSTANTE TERM VAN DE SPLINE IN HET I-DE
C                  INTERVAL
C     B     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  B(I) IS DE KOEFFICIENT VAN Y VAN DE SPLINE IN HET
C                  I-DE INTERVAL
C     C     REAL   INPUTVEKTOR VAN LENGTE NY ;
C                  C(I) IS DE KOEFFICIENT VAN Y**2 VAN DE SPLINE IN HET
C                  I-DE INTERVAL
C     D     REAL   INPUTVEKTOR VAN LENGTE NY;
C                  D(I) IS DE KOEFFICIENT VAN Y**3 VAN DE SPLINE
C                  IN HET I-DE INTERVAL
C     UA    REAL   OUTPUTVARIABELE; (COMMON)
C                  DE D.M.V. SPLINE-INTERPOLATIE BEREKENDE SNELHEID
C                  UA(YS)
C     DUADY REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE D.M.V. INTERPOLATIE IN DE AFGELEIDE SPLINE BERE-
C                  KENDE DUA/DY VOOR Y=YS.
C     DUADZ REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE PARTIELE AFGELEIDE DUA/DZ VOOR Y=YS.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER COSCOS
      REAL*8  LABDA
C
      COMMON /VAST/     UA, ALMOM,  ALTH,    CD,     G,  RHOA,    PI,
     *             LABDA, DUADY, DUADZ,DRHODY,COSCOS
C
C     DIMENSIONERING VAN ARRAY'S
C
      DIMENSION Y(*), A(*), B(*), C(*), D(*)
C
C     INTERPOLEREN IN SPLINE TER BEREKENING VAN UA
C
      CALL INTSPL(YS, INT, Y, A, B, C, D, UA)
C
C     INTERPOLEREN IN AFGELEIDE SPLINE TER BEREKENING VAN DUA/DY
C
      YY   =YS-Y(INT)
      DUADY=B(INT)+YY*(2.*C(INT)+3.*YY*D(INT))
      DUADZ=0.
C
      RETURN
      END
c     jet3d-ua2     , version  1.01,  1 April     1979, A. W. J. Koster
      SUBROUTINE UA2(UAT,  Y, NY,  Z, NZ, YS, ZS, LY, LZ,  C, WK, MXY)
C
C     WATERLOOPKUNDIG LABORATORIUM    AFDELING WILD
C
C     FUNKTIE      : BEPALEN VAN SNELHEID UA EN PARTIELE AFGELEIDEN
C                    DUA/DY EN DUA/DZ VOOR HET GEVAL UA=UA(Y,Z)
C     INGANG       : AANROEP
C     UITGANG      : TERUG NAAR AANROEPEND MODUUL
C     GEBRUIKTE
C     SUBROUTINES  : FIND2
C                    IBCICU : (I.M.S.L.)
C                    DBCEVU : (I.M.S.L.)
C
C     LIJST VAN PARAMETERS
C
C     NAAM SOORT  OMSCHRIJVING
C
C     UAT   REAL   NY X NZ  INPUTMATRIX ;
C                  UAT(I,J) BEVAT DE SNELHEID VAN HET MEDIUM IN HET
C                  PUNT (Y(I),Z(J))
C     Y     REAL   INPUTVECTOR VAN LENGTE NY ;
C                  Y(I) BEVAT DE AFSTAND VAN DE I-DE RIJ TOT OORSPRONG
C     NY   INTEGER INPUTVARIABELE ;
C                  AANTAL RIJEN IN HET NETWERK
C     Z     REAL   INPUTVEKTOR VAN LENGTE NZ ;
C                  Z(I) IS DE AFSTAND VAN DE I-DE KOLOM TOT DE
C                  OORSPRONG
C     NZ   INTEGER INPUTVARIABELE ;
C                  AANTAL KOLOMMEN IN HET NETWERK
C     YS    REAL   INPUTVARIABELE ;
C                  Y-COORDINAAT VAN HET GEGEVEN PUNT (YS,ZS)
C     ZS    REAL   INPUTVARIABELE ;
C                  Z-COORDINAAT VAN HET GEGEVEN PUNT (YS,ZS)
C     LY   INTEGER INPUTVARIABELE ;
C                  Y-INTERVAL VOOR HET VORIGE PUNT
C     LZ   INTEGER INPUTVARIABELE ;
C                  Z-INTERVAL VOOR HET VORIGE PUNT
C     WK    REAL   WERKVEKTOR VAN LENGTE MINIMAAL
C                  4*MAX(4,NY)+MAX((NX-1)*3,(NY-1)*3+NY)
C     MXY  INTEGER 1E INDEX UAT- ARRAY
C     UA    REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE M.B.V. SPLINE-INTERPOLATIE BEPAALDE SNELHEID
C                  UA(YS,ZS)
C     DUADY REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE PARTIELE AFGELEIDE DUA/DY IN HET PUNT (YS,ZS)
C     DUADZ REAL   OUTPUTVARIABELE ; (COMMON)
C                  DE PARTIELE AFGELEIDE DUA/DZ IN HET PUNT (YS,ZS)
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER COSCOS
      REAL*8  LABDA
C
      COMMON /VAST/ UA    , ALMOM,  ALTH,    CD,     G,  RHOA,    PI,
     *              LABDA, DUADY, DUADZ,DRHODY,COSCOS
C
C     DIMENSIONERING VAN ARRAYS
C
      DIMENSION UAT(MXY,*), WK(*),  C(4,*),  Y(*),  Z(*), PDS(6)
C
C     KONTROLEREN OF HET PUNT (YS,ZS) IN EEN NIEUWE RECHTHOEK VALT
C
      IF (YS.GE.Y(LY) .AND. YS.LE.Y(LY+1) .AND.
     +    ZS.GE.Z(LZ) .AND. ZS.LE.Z(LZ+1)) GO TO 10
C
C
C     ZOEKEN VAN DE RECHTHOEK VOOR HET PUNT (YS,ZS)
C
      CALL FIND2(Y, NY, Z, NZ, YS, ZS, LY, LZ)
C
C     BEPALEN VAN DE COEFFICIENTEN VAN DE BICUBIC SPLINE VOOR DE NIEUWE
C     RECHTHOEK
C
      CALL IBCICU(UAT, MXY, Y, NY, Z, NZ, LY, LZ, C, WK, IER)
   10 CONTINUE
C
C     BEPALEN VAN DE SNELHEID UA(YS,ZS) EN DE PARTIELE AFGELEIDEN
C     DUA/DY EN DUA/DZ IN DAT PUNT
C
      CALL DBCEVU(Y, NY, Z, NZ, LY, LZ, C, YS, ZS, PDS, IER)
C
      UA   =PDS(1)
      DUADY=PDS(2)
      DUADZ=PDS(3)
C
      RETURN
      END
c     jet3d-uerset  , version  2.05,  1 Januari   1978, imsl routine
      SUBROUTINE UERSET (LEVEL,LEVOLD)
C
C   FUNCTION            - SET MESSAGE LEVEL FOR IMSL ROUTINE UERTST
C
C   USAGE               - CALL UERSET (LEVEL,LEVOLD)
C
C   ARGUMENTS    LEVEL  - NEW VALUE FOR MESSAGE LEVEL. (INPUT)
C                           OUTPUT FROM IMSL ROUTINE UERTST IS
C                           CONTROLLED SELECTIVELY AS FOLLOWS,
C                             LEVEL = 4 CAUSES ALL MESSAGES TO BE
C                                       PRINTED,
C                             LEVEL = 3 MESSAGES ARE PRINTED IF IER IS
C                                       GREATER THAN 32,
C                             LEVEL = 2 MESSAGES ARE PRINTED IF IER IS
C                                       GREATER THAN 64,
C                             LEVEL = 1 MESSAGES ARE PRINTED IF IER IS
C                                       GREATER THAN 128,
C                             LEVEL = 0 ALL MESSAGE PRINTING IS
C                                       SUPPRESSED.
C                LEVOLD - PREVIOUS MESSAGE LEVEL. (OUTPUT)
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - UERTST,UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
      IMPLICIT REAL*8 (A-H,O-Z)
C
      INTEGER            LEVEL,LEVOLD
C                                  FIRST EXECUTABLE STATEMENT
      LEVOLD = LEVEL
      CALL UERTST (LEVOLD,'UERSET')
      RETURN
      END
c     jet3d-uertst  , version  2.05,  1 Januari   1978, imsl routine
      SUBROUTINE UERTST (IER,NAME)
C
C   FUNCTION            - PRINT A MESSAGE REFLECTING AN ERROR CONDITION
C
C   USAGE               - CALL UERTST (IER,NAME)
C
C   ARGUMENTS    IER    - ERROR PARAMETER. (INPUT)
C                           IER = I+J WHERE
C                             I = 128 IMPLIES TERMINAL ERROR,
C                             I =  64 IMPLIES WARNING WITH FIX, AND
C                             I =  32 IMPLIES WARNING.
C                             J = ERROR CODE RELEVANT TO CALLING
C                                 ROUTINE.
C                NAME   - A SIX CHARACTER LITERAL STRING GIVING THE
C                           NAME OF THE CALLING ROUTINE. (INPUT)
C
C   PRECISION/HARDWARE  - SINGLE/ALL
C
C   REQD. IMSL ROUTINES - UGETIO
C
C   NOTATION            - INFORMATION ON SPECIAL NOTATION AND
C                           CONVENTIONS IS AVAILABLE IN THE MANUAL
C                           INTRODUCTION OR THROUGH IMSL ROUTINE UHELP
C
C   REMARKS      THE ERROR MESSAGE PRODUCED BY UERTST IS WRITTEN
C                ONTO THE STANDARD OUTPUT UNIT. THE OUTPUT UNIT
C                NUMBER CAN BE DETERMINED BY CALLING UGETIO AS
C                FOLLOWS..   CALL UGETIO(1,NIN,NOUT).
C                THE OUTPUT UNIT NUMBER CAN BE CHANGED BY CALLING
C                UGETIO AS FOLLOWS..
C                                NIN = 0
C                                NOUT = NEW OUTPUT UNIT NUMBER
C                                CALL UGETIO(3,NIN,NOUT)
C                SEE THE UGETIO DOCUMENT FOR MORE DETAILS.
C
C   COPYRIGHT           - 1978 BY IMSL, INC. ALL RIGHTS RESERVED.
C
C   WARRANTY            - IMSL WARRANTS ONLY THAT IMSL TESTING HAS BEEN
C                           APPLIED TO THIS CODE. NO OTHER WARRANTY,
C                           EXPRESSED OR IMPLIED, IS APPLICABLE.
C
C-----------------------------------------------------------------------
C
C                                  SPECIFICATIONS FOR ARGUMENTS
C
      IMPLICIT REAL*8    (A-H,O-Z)
C
      INTEGER            IER
      CHARACTER*6        NAME
C                                  SPECIFICATIONS FOR LOCAL VARIABLES
      CHARACTER*6        NAMSET,NAMEQ
      CHARACTER*1        IEQ
      DATA               NAMSET /'UERSET'/
      DATA               NAMEQ  /'      '/
C                                  FIRST EXECUTABLE STATEMENT
      DATA               LEVEL/4/,IEQDF/0/,IEQ /'='/
      IF (IER.GT.999) GO TO 25
      IF (IER.LT.-32) GO TO 55
      IF (IER.LE.128) GO TO 5
      IF (LEVEL.LT.1) GO TO 30
C                                  PRINT TERMINAL MESSAGE
C---- CALL UGETIO(1,NIN,IOUNIT)
      IF (IEQDF.EQ.1) WRITE(*,35) IER,NAMEQ,IEQ,NAME
      IF (IEQDF.EQ.0) WRITE(*,35) IER,NAME
      GO TO 30
    5 IF (IER.LE.64) GO TO 10
      IF (LEVEL.LT.2) GO TO 30
C                                  PRINT WARNING WITH FIX MESSAGE
C---- CALL UGETIO(1,NIN,IOUNIT)
      IF (IEQDF.EQ.1) WRITE(*,40) IER,NAMEQ,IEQ,NAME
      IF (IEQDF.EQ.0) WRITE(*,40) IER,NAME
      GO TO 30
   10 IF (IER.LE.32) GO TO 15
C                                  PRINT WARNING MESSAGE
      IF (LEVEL.LT.3) GO TO 30
C---- CALL UGETIO(1,NIN,IOUNIT)
      IF (IEQDF.EQ.1) WRITE(*,45) IER,NAMEQ,IEQ,NAME
      IF (IEQDF.EQ.0) WRITE(*,45) IER,NAME
      GO TO 30
   15 CONTINUE
C                                  CHECK FOR UERSET CALL
      IF (NAME.NE.NAMSET) GO TO 25
      LEVOLD = LEVEL
      LEVEL = IER
      IER = LEVOLD
      IF (LEVEL.LT.0) LEVEL = 4
      IF (LEVEL.GT.4) LEVEL = 4
      GO TO 30
   25 CONTINUE
      IF (LEVEL.LT.4) GO TO 30
C                                  PRINT NON-DEFINED MESSAGE
C---- CALL UGETIO(1,NIN,IOUNIT)
      IF (IEQDF.EQ.1) WRITE(*,50) IER,NAMEQ,IEQ,NAME
      IF (IEQDF.EQ.0) WRITE(*,50) IER,NAME
   30 IEQDF = 0
      RETURN
   35 FORMAT(/,' ***ERROR - (terminal error IER = ',I3,
     *         ') from IMSL routine ',a6,a1,a6)
   40 FORMAT(/,' ***WARNING - (fix error  IER = ',I3,
     *         ') from IMSL routine ',a6,a1,a6)
   45 FORMAT(/,' ***WARNING - (error IER = ',I3,
     *         ') from IMSL routine ',a6,a1,a6)
   50 FORMAT(/,' ***ERROR - (undefined IER = ',I5,
     *         ') from IMSL routine ',a6,a1,a6)
C
C                                  SAVE P FOR P = R CASE
C                                    P IS THE PAGE NAME
C                                    R IS THE ROUTINE NAME
   55 IEQDF = 1
      NAMEQ = NAME
      RETURN
      END
c     jet3d-wrttek  , version  2.05,  1 July      1991, A. A. van Rij
      SUBROUTINE WRTTEK(ISCR  ,IPR   ,IREF  ,EXT   ,ISTEP ,YMMX ,MXUIT)
C
C
C     DELFT HYDRAULICS LABORATORY     DEPARTMENT ESTUARIES AND SEAS
C
C     FUNCTION            : WRITE INTERFACE FILE TO TEKAL
C     ENTRY               : AANROEP
C     EXIT                : CALLING MODULE
C     ERROR MESSAGES      : NONE
C     LOGICAL UNITS       : LUN ISCR = SCRATCH FILE WITH RESULTS
C                           LUN IPR  = PRINT DEVICE
C                           LUN IREF = INTERFACE FILE FOR TEKAL
C
C     SUBROUTINES CALLED  : NONE
C
C
C     PARAMETERS
C
C     NAME     TYPE        I O T  LENGTH   DESCRIPTION
C     ----     ----        - - -  ------   -----------
C
C     EXT      CHAR*3      *      1        IDENTIFICATION OF RUN
C     IPR      INTEGER     * *    1        PRINT DEVICE
C     IREF     INTEGER     * *    1        INTERFACE FILE FOR TEKAL
C     ISCR     INTEGER     *      1        SCATCH FILE WITH RESULTS
C     ISTEP    INTEGER     *      1        NUMBER OF ITERATION STEPS
C                                          WRITTEN TO SCRATCH FILE
C     YMMX     REAL          *    2,MXUIT  MINIMUM AND MAXIMUM VALUES
C     MXUIT    INTEGER     *      1        AANTAL WEG TE SCHRIJVEN VAR.
C     ******************************************************************
C
C     DECLARATIONS
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      CHARACTER*3  EXT
      DIMENSION    YMMX (2,*)
C
C REWIND SCRATCH FILE
C
      REWIND ISCR
C
C INITIALISATION OF MINIMA AND MAXIMA
C
      DO 10 I = 1,MXUIT
         YMMX (1,I) =  999999.
         YMMX (2,I) = -999999.
   10 CONTINUE
C
C WRITE HEADLINES TO INTERFACE FILE
C
      WRITE(IREF,'(''**Case       = '',A3)         ') EXT
      WRITE(IREF,'(''* column    1 : S distance along curve'')')
      WRITE(IREF,'(''* column    2 : X-coordinate'')')
      WRITE(IREF,'(''* column    3 : Y-coordinate'')')
      WRITE(IREF,'(''* column    4 : Z-coordinate'')')
      WRITE(IREF,'(''* column    5 : Mixing factor'')')
      WRITE(IREF,'(''* column    6 : Width     '')')
      WRITE(IREF,'(''* column    7 : V total   '')')
      WRITE(IREF,'(''* column    8 : Concentration'')')
      WRITE(IREF,'(''BL01'')')
      WRITE(IREF,'(2I8)'     ) (ISTEP + 1),MXUIT
C
C FOR ISTEP - READ DATA FROM SCRATCH FILE
C           - CALCULATE MINIMA AND MAXIMA
C           - WRITE DATA TO ITERFACE FILE
C
      DO 20 I = 0,ISTEP
C
         READ (ISCR) XCOOR ,YCOOR  ,ZCOOR ,VERDUN,BREED,VTOT,CONS,S
C
         YMMX (1,1) = MIN (YMMX (1,1),S     )
         YMMX (1,2) = MIN (YMMX (1,2),XCOOR )
         YMMX (1,3) = MIN (YMMX (1,3),YCOOR )
         YMMX (1,4) = MIN (YMMX (1,4),ZCOOR )
         YMMX (1,5) = MIN (YMMX (1,5),VERDUN)
         YMMX (1,6) = MIN (YMMX (1,6),BREED )
         YMMX (1,7) = MIN (YMMX (1,7),VTOT  )
         YMMX (1,8) = MIN (YMMX (1,8),CONS  )
         YMMX (2,1) = MAX (YMMX (2,1),S     )
         YMMX (2,2) = MAX (YMMX (2,2),XCOOR )
         YMMX (2,3) = MAX (YMMX (2,3),YCOOR )
         YMMX (2,4) = MAX (YMMX (2,4),ZCOOR )
         YMMX (2,5) = MAX (YMMX (2,5),VERDUN)
         YMMX (2,6) = MAX (YMMX (2,6),BREED )
         YMMX (2,7) = MAX (YMMX (2,7),VTOT  )
         YMMX (2,8) = MAX (YMMX (2,8),CONS  )
C
         WRITE(IREF,'(8(1X,E12.5))') S,XCOOR,YCOOR,ZCOOR,VERDUN,BREED,
     *                               VTOT ,CONS
C
   20 CONTINUE
C
C WRITE BLOCK AND COLUMN DEFINITION TO PRINT DEVICE
C
      WRITE(IPR,'(//,'' Output info for plotting:''  )')
      WRITE(IPR,'(   '' -------------------------'',/)')
      WRITE(IPR,'('' *Case       = '',A3,''   Block = BL01'')') EXT
      WRITE(IPR,'(''  Column 1   = S distance along curve '')')
      WRITE(IPR,'(''  Column 2   = X-coordinate  '')'  )
      WRITE(IPR,'(''  Column 3   = Y-coordinate  '')'  )
      WRITE(IPR,'(''  Column 4   = Z-coordinate  '')'  )
      WRITE(IPR,'(''  Column 5   = Mixing factor '')'  )
      WRITE(IPR,'(''  Column 6   = Jet width     '')'  )
      WRITE(IPR,'(''  Column 7   = V-total       '')'  )
      WRITE(IPR,'(''  Column 8   = Concentration '',/)')
C
C WRITE MINIMA AND MAXIMA TO PRINT DEVICE
C
      WRITE(IPR,'('' Function               Minimum       Maximum'')'  )
      WRITE(IPR,'('' ========               =======       ======='',/)')
      WRITE(IPR,'('' S-distance    '',2(3X,E12.5))') YMMX(1,1),YMMX(2,1)
      WRITE(IPR,'('' X-coordinate  '',2(3X,E12.5))') YMMX(1,2),YMMX(2,2)
      WRITE(IPR,'('' Y-coordinate  '',2(3X,E12.5))') YMMX(1,3),YMMX(2,3)
      WRITE(IPR,'('' Z-coordinate  '',2(3X,E12.5))') YMMX(1,4),YMMX(2,4)
      WRITE(IPR,'('' mixing factor '',2(3X,E12.5))') YMMX(1,5),YMMX(2,5)
      WRITE(IPR,'('' jet width     '',2(3X,E12.5))') YMMX(1,6),YMMX(2,6)
      WRITE(IPR,'('' V-total       '',2(3X,E12.5))') YMMX(1,7),YMMX(2,7)
      WRITE(IPR,'('' Concentration '',2(3X,E12.5))') YMMX(1,8),YMMX(2,8)
C
      RETURN
      END
