      module scremo_data
      
      implicit none
      integer, parameter :: name_size  =  20       ! size of descriptive names
	integer                   :: nmax
	integer                   :: mmax
	integer                   :: noseg, nosegl,nlay,nbounl,nboun
	integer                   :: segdis, nl, ml, kl
	integer                   :: noq1, noq2, noq3, noq
	real                      :: udis
      INTEGER     , ALLOCATABLE :: LGRID(:,:)
      REAL        , ALLOCATABLE :: XB(:,:)
      REAL        , ALLOCATABLE :: YB(:,:)
      REAL        , ALLOCATABLE :: XBt(:,:)
      REAL        , ALLOCATABLE :: YBt(:,:)
      integer     , allocatable :: ipoint(:,:)
      real        , allocatable :: length(:,:)
      real        , allocatable :: volume(:)
      real        , allocatable :: surf(:)
      real        , allocatable :: area(:)
      real        , allocatable :: flow(:)
	integer, allocatable :: lgrid3D(:,:,:)
      real        , allocatable :: deltax(:,:)
      real        , allocatable :: deltay(:,:)
      real        , allocatable :: deltaz(:,:)
      real        , allocatable :: depth(:,:)
      real        , allocatable :: ax(:,:)
      real        , allocatable :: ay(:,:)
      real        , allocatable :: uc(:,:,:)
      real        , allocatable :: vc(:,:,:)
      real        , allocatable :: wc(:,:,:)
      real        , allocatable :: u2d(:,:)
      real        , allocatable :: v2d(:,:)


      type t_casedata                                    ! case data
          character(len=name_size) :: name         ! name
          integer                  :: cas          ! case #
          real                     :: L            ! Length L	m
          real                     :: W1           ! Width W / W1	m
c          real                     :: W2           ! Width W2	m
c          real                     :: R            ! Radius R	m
          real                     :: GD           ! Orientation	deg
          real                     :: H            ! Total Depth	m
          real                     :: HD           ! Shore depth m
          integer                  :: NG           ! nr of cells in long. dir.	-
          integer                  :: MG           ! nr of cells in lateral dir.	-
          integer                  :: KG           ! nr of cells in vertical direction	-
          real                     :: WD           ! Wind Direction 	deg
          real                     :: WS           ! Wind Speed at 10 m	m/s
c          real                     :: CD           !Residual Current Direction 	deg
          real                     :: CS           ! Residual Current Speed	m/s
		real                     :: LL           ! Discharge point L direction, relative to edge m
		real                     :: WL           ! Discharge point W direction, relative to edge m
		real                     :: ZL           ! Discharge point Z direction, relative to surface m
          character(len=name_size) :: LayL         ! Indication where discharge should be placed (UNCHANGED/SURFACE/BOTTOM)
		real                     :: X0           ! Shift in lga/cco
		real                     :: Y0           ! Shift in lga/cco

      end type t_casedata


      end module scremo_data

