      subroutine make_geo(casedata)

      use scremo_data

	type(t_casedata) :: casedata

      ! locals

	integer       :: n,m,iseg,k,ioqn,ioqm,ioqk
	real          :: x,y,x0,y0,ds,x1,y1,d01

	! door de open zee in case 2 ook rechts te leggen is dit stuk geldig voor case 1/2

      ax = 0.0
	ay = 0.0
	do m = 1,mmax
	do n = 1,nmax

	!   depth at grid points

          x  = xb(n,m)
	    y  = yb(n,m)
	    x0 = xb(n,1)
	    y0 = yb(n,1)
	    x1 = xb(n,mmax-1)
	    y1 = yb(n,mmax-1)
	    ds =  sqrt((x -x0)**2+(y -y0)**2)
	    d01 = sqrt((x1-x0)**2+(y1-y0)**2)
	    ds = ds/d01
	    ds = max(min(ds,1.),0.)
          depth(n,m) = (1.-ds)*casedata%HD+ds*casedata%H
	enddo
	enddo
	    
	do m = 1,mmax
	do n = 1,nmax
	    iseg = lgrid(n,m)
	    lgrid3d(n,m,1) = iseg
	    do k = 2,nlay
	        if (iseg.gt.0) then
	            lgrid3d(n,m,k) = lgrid3d(n,m,k-1) + nosegl
              elseif (iseg.lt.0) then
	            lgrid3d(n,m,k) = lgrid3d(n,m,k-1) + nbounl
              else
                  lgrid3d(n,m,k) = lgrid3d(n,m,k-1) 
	        endif
	    enddo
	    deltay(n,m) = casedata%L/real(casedata%NG)
          deltax(n,m) = casedata%W1/real(casedata%MG)
	    if (iseg.gt.0) then
              deltaz(n,m) = 
     j        (depth(n,m)+depth(n-1,m)+depth(n,m-1)+depth(n-1,m-1))
     j        /4./real(casedata%KG)
	    else
	        deltaz(n,m) = 0.00
	    endif
	    if (n.gt.1) then
	    x0 = xb(n-1,m)
	    y0 = yb(n-1,m)
	    x1 = xb(n  ,m)
	    y1 = yb(n  ,m)
	    ds = sqrt ((x1-x0)**2.+(y1-y0)**2.)
	    ax(n,m) = ds*(depth(n-1,m)+depth(n,m))/2./real(casedata%KG)
	    endif
          if (m.gt.1) then	    
	    x0 = xb(n,m-1)
	    y0 = yb(n,m-1)
	    x1 = xb(n,m)
	    y1 = yb(n,m)
	    ds = sqrt ((x1-x0)**2.+(y1-y0)**2.)
	    ay(n,m) = ds*(depth(n,m-1)+depth(n,m))/2./real(casedata%KG)
	    endif
	enddo
	enddo

      do k = 1,nlay
	do m = 1,mmax
	do n = 1,nmax

	    iseg = lgrid3d(n,m,k)
	    if (iseg.gt.0) then
              surf(iseg) = deltay(n,m)*deltax(n,m)
	        volume(iseg) = surf(iseg)*deltaz(n,m)
	    endif

          call get_ioq(n,m,k,ioqn,ioqm,ioqk)

      ! pointers
	    
	    if (ioqn.gt.0) then
          ipoint(1,ioqn) = iseg
	    ipoint(2,ioqn) = lgrid3d(n+1,m,k)
	    length(1,ioqn) = deltay(n,m)/2.
	    length(2,ioqn) = deltay(n+1,m)/2.
	    area(ioqn) = ay(n,m)
	    endif

          if (ioqm.gt.0) then
          ipoint(1,ioqm) = iseg
	    ipoint(2,ioqm) = lgrid3d(n,m+1,k)
	    length(1,ioqm) = deltax(n,m)/2.
	    length(2,ioqm) = deltax(n,m+1)/2.
	    area(ioqm) = ax(n,m)
	    endif

          if (ioqk .gt. 0) then
          ipoint(1,ioqk) = iseg
	    ipoint(2,ioqk) = lgrid3d(n,m,k+1)
	    length(1,ioqk) = deltaz(n,m)/2.
	    length(2,ioqk) = deltaz(n,m)/2.
	    area(ioqk) = deltax(n,m)*deltay(n,m)
          endif

	enddo
	enddo
	enddo

      return
	end

      subroutine get_ioq(n,m,k,ioqn,ioqm,ioqk)

	use scremo_data

	integer :: n,m,k,ioqn,ioqm,ioqk

          ioqn = -1
	    if (n.lt.nmax.and.m.ne.1.and.m.ne.mmax) 
     j    ioqn = (k-1)*(nmax-1)*(mmax-2) + (m-2)*(nmax-1) + n
	    ioqm = -1
	    if (m.lt.mmax.and.n.ne.1.and.n.ne.nmax) 
     j    ioqm = noq1 + (k-1)*(mmax-1)*(nmax-2) + (m-1)*(nmax-2) + n-1
          ioqk = -1
	    if (k.lt.nlay.and.m.ne.1.and.m.ne.mmax
     j             .and.n.ne.1.and.n.ne.nmax)  ioqk = noq1 + noq2
     j        + (k-1)*(mmax-2)*(nmax-2) + (m-2)*(nmax-2) + n-1

	return
	end
