      subroutine writehyd(lu_hyd,hydname,lu_mes)

      use scremo_data 

      character*255             :: hydname
      integer                   :: lu_hyd
      integer                   :: lu_mes

      integer                   :: ilay

      write (lu_mes,*) 'Writing HYD file ...'

      write (lu_hyd,1000)
 1000 format (
     j'task      full-coupling'/
     j'geometry  curvilinear-grid'/
     j'horizontal-aggregation       no'/
     j'minimum-vert-diffusion-used  no'/
     j'vertical-diffusion           calculated'/
     j'description'/
     j'''                                                          '''/
     j'''                                                          '''/
     j'''                                                          '''/
     j'end-description'/
     j'reference-time           ''20110101000000'''/
     j'hydrodynamic-start-time  ''20110101000000'''/
     j'hydrodynamic-stop-time   ''20110102000000'''/
     j'hydrodynamic-timestep    ''00000001000000'''/
     j'conversion-ref-time      ''20110101000000'''/
     j'conversion-start-time    ''20110101000000'''/
     j'conversion-stop-time     ''20110102000000'''/
     j'conversion-timestep      ''00000001000000''')

      write (lu_hyd,1010) mmax,nmax,nlay,nlay
 1010 format (
     j'grid-cells-first-direction ',i7/
     j'grid-cells-second-direction',i7/
     j'number-hydrodynamic-layers ',i7/
     j'number-water-quality-layers',i7)

      call w1(lu_hyd,'hydrodynamic-file',trim(hydname)//'.dat')
      call w2(lu_hyd,'aggregation-file')
      call w1(lu_hyd,'grid-indices-file',trim(hydname)//'.lga')
      call w1(lu_hyd,'grid-coordinates-file',trim(hydname)//'.cco')
      call w1(lu_hyd,'volumes-file',trim(hydname)//'.vol')
      call w1(lu_hyd,'areas-file',trim(hydname)//'.are')
      call w1(lu_hyd,'flows-file',trim(hydname)//'.flo')
      call w1(lu_hyd,'pointers-file',trim(hydname)//'.poi')
      call w1(lu_hyd,'lengths-file',trim(hydname)//'.len')
      call w2(lu_hyd,'salinity-file')
      call w2(lu_hyd,'temperature-file')
      call w2(lu_hyd,'vert-diffusion-file')
      call w1(lu_hyd,'surfaces-file',trim(hydname)//'.srf')
      call w2(lu_hyd,'total-grid-file')
      call w2(lu_hyd,'discharges-file')
      call w2(lu_hyd,'chezy-coefficients-file')
      call w2(lu_hyd,'shear-stresses-file')
      call w2(lu_hyd,'walking-discharges-file')
      call w2(lu_hyd,'attributes-file')

      write (lu_hyd,1040)
 1040 format (
     j'constant-dispersion'/
     j'   first-direction    0.1000E+01'/
     j'   second-direction   0.1000E+01'/
     j'   third-direction    0.1000E-06'/
     j'end-constant-dispersion')

      write (lu_hyd,1050)
	do ilay = 1,nlay
	    write (lu_hyd,1051) 1./real(nlay)
	enddo
      write (lu_hyd,1052)

	do ilay = 1,nlay
	    write (lu_hyd,1061) 
	enddo
      write (lu_hyd,1062)

 1050 format ('hydrodynamic-layers')
 1051 format (f15.3)
 1052 format (
     j'end-hydrodynamic-layers'/
     j'water-quality-layers   ')
 1061 format ('        1.000')
 1062 format (
     j'end-water-quality-layers'/
     j'discharges'/
     j'end-discharges')
	return
      end

      subroutine w1(lu,ca,cb)
	integer lu
	character*(*) ca
	character*(*) cb
	character*25  c25
	c25 = ca
	write (lu,1000) c25,trim(cb)
 1000 format (a25,'''',a,'''')
      return
	end
      subroutine w2(lu,ca)
	integer lu
	character*(*) ca
	character*25  c25
	c25 = ca
	write (lu,'(a25,''none'')') c25
      return
	end


